con


'P2 Invaders - 1 Cog -VGA 800 x 600 - Real sound effects!
'Version 2.04 DE2 1P
'21st March 2014

'Program by Ozpropdev (Brian Dennis)

'For FPGA Build 20th March 2014


'Video timing

'{
'for 40MHz dot clock and 60Hz vertical sync
	dot_clock_frqa = $1000_0000  '40Mhz
	front_porch =40
	sync_pulse = 128
	back_porch = 88		'800 + 40 + 128 + 88 = 1056 pixels

	top_blanks = 23
	bottom_blanks =1
	vsync = 4		'600 + 23 + 1 + 4 = 628 lines
'}

{
'for 50MHz dot clock and 72Hz Vertical sunc
	dot_clock_frqa = $1400_0000  '50Mhz
	front_porch =56
	sync_pulse = 120
	back_porch = 64		'800 + 56 + 120 + 64 =  1040 pixels

	top_blanks = 23
	bottom_blanks =37
	vsync = 6		'600 + 23 + 37 + 6 = 666 lines
}


'IO assignments
'==============


	rx = 91
	tx = 90

'Button assignments
'===================

	'for DE0-Nano 
'	left_button = 26
'	right_button = 27
'	fire_button = 28

	'for DE2-115 - Thanks to "Potatohead" for supplying these
	left_button = 31
	right_button = 30
	fire_button = 29


'System definitions
'===================

	_clkmode = xinput
	_xinfreq = 80_000_000

'Assorted constants
'==================

	ms = _xinfreq / 1000

	sprite_base = e_alien0 + 55
	p_overlay = sprite_base + num_sprites * 8 '$d0
	p_erase   = p_overlay + 8 '$d8
	p_plot    = p_erase + 8 '$e0
	pixel_base = p_plot + 8 '$e8

	baudrate = 1_000_000 
	tps = 10_000   'ticks per second
	prescaler_value = _xinfreq / tps
	clocks_per_bit = _xinfreq / baudrate

	main_code_base = $a0

	idle_time = 1 * ms

'Video properties
'================

'single instance game

	cols = 256
	rows = 150
	cpp = 2   'clocks per pixel
	v_parm1 = 3
	v_parm2 = 3
	v_parm3 = 5
	v_parm4 = 8
	v_parm5 = 8
	v_parm6 = 2
	v_parm7 = (8-v_parm5)*4 '0
	v_parm8 = 0

	bytes_per_col = cols / 8

'Game properties
'===============

	alien_cols = 11
	alien_rows = 5
	total_aliens = alien_cols * alien_rows

	alien_vert_inc = 5
	alien_horiz_inc = 3
	alien_min = alien_max + ((total_aliens-1) * alien_speed_change)
	alien_max = 40
	alien_speed_change = 35

	cannon_y = 120
	cannon_min = 8
	cannon_max = 232
	cannon_horiz_inc = 1
	cannon_speed = 150

	missile_speed = 80

	bomb_speed = 240 
	bomb_speed2 = 350

	saucer_speed = (cannon_speed * 150)/100
	saucer_y = 9
	saucer_time_interval = 30 'seconds

	start_lives = 3
	extra_life = 1500   

	shield_y = 108 
	sx = 54
	s1 = 32
	s2 = s1 + sx
	s3 = s2 + sx
	s4 = s3 + sx

'game flags
'==========

	#0
	missile_active
	cannon_left
	cannon_right
	scan
	bullseye
	score_changed
	new_hi_score
	id_victim
	game_over
	game_over_msg
	winner
	saucer_active
	saucer_direction
	bomb_active
	blast_active
	packet
	overlap
	hold_score
	load_monitor
	halt
	killed
	show_lives
	demo_mode
	demo_abort
	demo_move
	demo_fire
	new_hs
	no_bombs
	bomb_active2
	num_flags

'System flags
'============

	#0
	live_data
	mute
	tx_disable
	ch1
	ch2
	ch3
	ch1_nibble
	ch2_nibble
	ch3_nibble
	num_sys_flags
	

'Game sprites
'============

	#0
	s_cannon
	s_missile
	s_bomb_a
	s_bomb_b
	s_saucer
	s_alien1a
	s_alien1b
	s_alien2a
	s_alien2b
	s_alien3a
	s_alien3b
	s_shield_left
	s_shield_right
	s_explosion
	num_sprites

'Game enrities
'=============

	#0
	e_shield1_left
	e_shield1_right
	e_shield2_left
	e_shield2_right
	e_shield3_left
	e_shield3_right
	e_shield4_left
	e_shield4_right
	e_cannon
	e_missile
	e_bomb
	e_bomb2
	e_saucer
	e_explosion
	e_alien0

'Bytecode assignment
'===================

	#0
	g_cls
	g_entity_init
	g_idle    'g_end
	g_pause
	g_repeat
	g_loop
	g_for
	g_next
	g_message
	g_wait4fire
	g_back
	g_plot_e
	g_check_edge
	g_plot_all_aliens
	g_plot_shields
	g_new_game
	g_saucer
	g_cannon
	g_missile
	g_aliens
	g_wait4left
	g_id_victim
	g_plot_s
	g_load_sprites
	g_move_bomb
	g_blast
	g_game_over
	g_tx_byte
	g_comms
	g_alive_loop
	g_goto	
	g_vaporize
	g_new_cannon
	g_update_lives
	g_update_scores
	g_alien_init
	g_game_status
	g_elapsed
	g_elapsed_loop
	g_restart
	g_demo_start
	g_show_id
	g_demo_status
	g_move_bomb2
'	g_id_window
	g_freeze
	g_start_sound
	
dat
'/////////////////////////////////////////////////////////////////////////////////////

			orgh	$e00/4

'/////////////////////////////////////////////////////////////////////////////////////


			org


'Launch 1 instabce of game

			cogid	id
			cogrun	_game1,#0

id			long	0

_game1			long	(@game1 >> 2) << 16 | (@coglet >> 2)

'Each game will require it's own video buffer, I/O definitions and DAC confiigs

game1			long	@video1
			long	left_button
			long	right_button
			long	fire_button
			long	%1111			'pin mask for P0..P3
			long	%1111_101100000		'pin configuration for video DAC
			long	@pallette1
			long	5   'lsb of r2r ladder for sound
			long	0  'window


'/////////////////////////////////////////////////////////////////////////////////////

'Game Coglet area	COG RAM address $00 - $A0

'/////////////////////////////////////////////////////////////////////////////////////

			org	

game_launch		
coglet			rdlongc	_video,ptra++     'get game config values
			rdlongc	left_,ptra++
			rdlongc	right_,ptra++
			rdlongc	fire_,ptra++
			rdlongc	:pinmask,ptra++
			rdlongc	:pindacs,ptra++
			rdlongc	:p_select,ptra++
			rdlongc	sound_dac,ptra++
			rdlong	ax,ptra++

'calc window offset
			
			testb	ax,#0 wz
		if_nz	mov	window,#32
			testb	ax,#1 wz
		if_nz	add	window,_9600

			mov	sound_dac_mask,#%1111
			shl	sound_dac_mask,sound_dac
			or	dira,sound_dac_mask   'enable 4 pins for audio r2r
			sub	sound_dac,#4

			clrp	#tx
		'	setpera	_115200
			setsera	_sercfg,_115200


			reps	#25,#1 '@:loop
			setptrx	#pixel_base
:loop			pushx	#0

			setptrx	#pixel_base+1
			pushx	:b31
			setptrx	#pixel_base+10
			pushx	#1

			mov	pc,:_game_start

:dj			setptra	:_colors              'initial color pallette
			reps	#19,#2 '@:loop1
			setptrb	:p_select
			rdlong	:dj,ptrb++
:loop1			wrlong	:dj,ptra++

			setctra	#%00111			'set ctra for PLL*8
                	setfrqa	:_45mhz			'set frqa
			setvid	#%0100000		'set vid for vga output
			setvidy	vidy_			'set yiq coefficients
			setvidi	vidi_
			setvidq	vidq_
			cfgdacs	#%11_11_11_11		'set dacs to video mode
		'	cfgpins	:pinmask,:pindacs		'set pins for dac outputs

			getcnt	ticker
			add	ticker,tick_time


			setptry	#p_overlay       'Initialize plot function code templates
			reps	#8,#1 '@:loop2
			setinda	#overlay1
:loop2		'	pushy	inda++
			wraux	inda++,ptry++

			setptry	#p_erase
			reps	#8,#1 '@:loop3
			setinda	#erase1
:loop3		'	pushy	inda++
			wraux	inda++,ptry++

			setptry	#p_plot
			reps	#8,#1 '@:loop4
			setinda	#plot1
:loop4		'	pushy	inda++
			wraux	inda++,ptry++


		'	jmptask	#vga,#%0010       'Setup multi-tasking
		'	jmptask	#timers,#%0100
		'	settask	schedule

			jmpt1	#vga       'Setup multi-tasking
			jmpt2	#timers
			settask	schedule

			getcnt	packet_timer

			jmp	#game

:_colors		long	@colors
:p_select		long	0

:_45mhz			long	dot_clock_frqa

:b31			long	$80000000
:xx			long	$80000001
:pinmask		long	0
:pindacs		long	0

:_game_start		long	@game_start

schedule		long	%%2100_1010_1010_1010

_115200			long	clocks_per_bit
_sercfg			long	%10 << 16 + rx << 9 + %10 << 7 + tx

vidy_			long	$00_2C_00_00		'red gain
vidi_			long	$00_00_2C_00		'green gain
vidq_			long	$00_00_00_2C		'blue gain


overlay1		and	b0,m0 wz
		if_nz	jmp	#bit_collision_l
			and	b1,m1 wz
		if_nz	jmp	#bit_collision_m
			and	b2,m2 wz
		if_nz	jmp	#bit_collision_r
			addptra	#3
			jmp	#no_write
	
erase1			andn	b0,m0
			nop
			andn	b1,m1
			nop
			andn	b2,m2
			nop
			nop
			nop

plot1			or	b0,m0
			nop
			or	b1,m1
			nop
			or	b2,m2
			nop
			nop
			nop

'........ end of coglet area. (160 longs)

'0000000000000000000000000000000   TASK #0   0000000000000000000000000000000000

			orgf	main_code_base '$a0


'Game engine (Bytecode Interpreter)

game			testb	game_flags,#load_monitor wz
		if_z	jmp	#:lc2
			rdlong	ax2,_monitor
			jmp	#:lc3

:lc2			rdbyte	ax,pc
			shl	ax,#2
			add	ax,_coglet_table
			rdlong	ax2,ax

:lc3			mov	ax3,ax2
			shr	ax3,#24
			and	ax2,_ffffff
			setptra	ax2
			setinda	#0
:loop			rdlongc	inda++,ptra++
			nop
			djnz	ax3,@:loop

			call	#coglet
			jmp	#game

next_coglet		add	pc,#1

'rx function

			serina	rx_byte wc
		if_nc	jmp	#cc2
			wrbyte	rx_byte,rx_ptr
			add	rx_ptr,#1
			cmp	rx_byte,#13 wz,wc
		if_e	mov	rx_ptr,_rx_buffer
		if_e	setb	game_flags,#load_monitor


'tx function
cc2			rdbyte	tx_byte,packet_ptr wz
		if_z	clrb	game_flags,#packet
		if_z	jmp	#coglet_ret
			add	packet_ptr,#1
:txw			serouta	tx_byte wc
		if_nc	jmp	#:txw

			
coglet_ret		ret

'--------------------------------------------------------------------------------
'Convert entity record into the following data

'et_a   entity property address
'et_x	entity x coord
'et_y   entity y coord
'et_s   entity base sprite
'et_f   entity flags
'et_v   entity video address
'et_b   entity bitmap address
'et_w   entity width
'et_o   sprite offset (shuft left count)
'et_sc  entity score value

get_metrics		
			rdaux	ax,entity
			getbyte	et_y,ax,#0
			getbyte	et_x,ax,#1
			getbyte	et_s,ax,#2
			getbyte	et_f,ax,#3
		
		'	setptry	entity
		'	popbr	ax
		'	setf	#%0_00_00_10_00
		'	movf	et_y,ax
		'	movf	et_x,ax
		'	movf	et_s,ax
		'	movf	et_f,ax

'calc video start address

metrix			mov	ax,et_y
			shl	ax,#v_parm3
			mov	bx,et_x
			shr	bx,#3
			add	ax,bx
			mov	et_v,_video
			add	et_v,ax
			add	et_v,window

'get sprite address & width

			mov	et_b,et_s
			and	et_b,#$f
			testb	et_f,#6 wz
		if_nz	add	et_b,#1
			shl	et_b,#3
			add	et_b,#sprite_base

			mov	et_w,et_s
			shr	et_w,#4
			add	et_w,#1

'calc sprite offset

			mov	et_o,#24
			mov	ax,et_x
			and	ax,#7
			sub	et_o,ax
			sub	et_o,et_w

'entity score value (multipes of 10, max 310)
		
			mov	ax,et_f
			and	ax,#$3f
			mov	et_sc,ax
			shl	et_sc,#3  ' x 8
			add	et_sc,ax
			add	et_sc,ax  ' x 10

metrix_ret
get_metrics_ret		ret	wz,wc

'--------------------------------------------------------------------------------

overlay			setptry	#p_overlay
			jmp	#plotf

erase			setptry	#p_erase
			jmp	#plotf

plot			setptry	#p_plot

'modify "plorf" routine to plot/erase/overlay

plotf			mov	kx,#8
			setindb	#i0
:loop		'	popbr	indb++
			rdaux	indb++,ptry++
			djnz	kx,@:loop

'execute "plotf"

			setptra	et_v
			'getspb	spb2
			
			setptry	et_b

			mov	cxf,#8
			mov	byte_ofst,#0
loop_f		'	popbr	dxf
			rdaux	dxf,ptry++
			rdbyte	b0,ptra++
			rdbyte	b1,ptra++
			rdbyte	b2,ptra++
			subptra	#3
		'	setf	#%0_00_00_11_10
			shl	dxf,et_o
		'	movf	m0,dxf
		'	movf	m1,dxf
		'	movf	m2,dxf

			getbyte	m0,dxf,#2
			getbyte	m1,dxf,#1
			getbyte	m2,dxf,#0

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'Code changes applied here  (plot/erase/overlay)

i0			andn	b0,m0
			nop
			andn	b1,m1
			nop
			andn	b2,m2
			nop
			nop
			nop
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
			wrbyte	b0,ptra++
			wrbyte	b1,ptra++
			wrbyte	b2,ptra++
no_write		addptra	#bytes_per_col-3  '61 '29
			djnz	cxf,@loop_f

overlay_ret
erase_ret
plot_ret
plotf_ret		ret


bit_collision_r		add	byte_ofst,#1
bit_collision_m		add	byte_ofst,#1
bit_collision_l		setb	game_flags,#bullseye
			getptra	hit_address
			add	hit_address,byte_ofst
			jmp	#plot_ret

hit_address		long	0

kx			long	0
cxf			long	0
dxf			long	0
byte_ofst		long	0
b0			long	0
b1			long	0
b2			long	0
m0			long	0
m1			long	0
m2			long	0
'et_a			long	0
et_b			long	0
et_x			long	0
et_y			long	0
et_s			long	0
et_f			long	0
et_v			long	0
et_w			long	0
et_o			long	0
et_sc			long	0

entity			long	0
game_flags		long	0

missile_ticks		long	0
cannon_ticks		long	0
alien_ticks		long	0
bomb_ticks		long	0
bomb_ticks2		long	0
saucer_ticks		long	0

pc			long	0
pause			long	0
_repeats		long	0
loop_pc			long	0
_start			long	0
_end			long	0
_step			long	0
_last			long	0

ax3			long	0
_monitor		long	@mon

alien_direction_	long	0
alien_speed_		long	0
alien_row_		long	0
score_			long	0
hi_score_		long	1200
alien_count_		long	0
saucer_timer_		long	0
blast_start_		long	0
packet_ptr		long	0
packet_timer		long	0
saucer_value_		long	0
x_hit_			long	0
y_hit_			long	0
o_hit_			long	0
score_time_		long	0
release_timer_		long	0
release_timer2_		long	0
bomb_owner_		long	0
col_enables_		long	0
lives_			long	start_lives
level_			long	0
last_score_		long	0
elapsed_		long	0
hold_fire_		long	0
reload_timer_		long	0
demo_timer_		long	0
demo_dir_		long	0

left_			long	0
right_			long	0
fire_			long	0
sys_flags		long	0

zero			long	0
_ffffff			long	$ffffff

_video			long	0 '@video
_coglet_table		long	@coglet_table

ax2			long	0
fx			long	0
ax			long	0
bx			long	0
cx			long	0
px			long	0
ex			long	0
dx			long	0

window			long	0
_9600			long	6400 '9600


'////////////////////////  End of TASk #0   /////////////////////////////////////


'11111111111111111111111111  TASK #1   1111111111111111111111111111111111111111111111

'VGA 800x600 pixels (Game window is 256x150 pixels)

vga		        mov	x,#top_blanks
			call	#qblank
			mov	vid_ptr,_video
			add	vid_ptr,#v_parm8 * 4
			mov	lcolor_ptr,#0

	                mov     x,lines_vis		'set visible lines

line			mov	dx9,lcolor_ptr		'set color
			shr	dx9,#v_parm1
			add	dx9,_colors
			rdlong	char_color,dx9

			setptrx	#pixel_base + v_parm6
			addptrx	#v_parm8

prep_pix		test	lcolor_ptr,#v_parm2 wz
		if_nz	jmp	#:send_pixels

'prepare pixel data (New compact/efficient version!)

			mov	cx9,#v_parm5
:pp1			rdlong	ax9,vid_ptr	'get 32 pixels
			eswap8	ax9		'endian reverse
			rev	ax9,#0		'reverse bits
			pushx	ax9		'push to clut ram
			add	vid_ptr,#4	'index to next 32 pixels (long)
			djnz	cx9,@:pp1
			add	vid_ptr,#v_parm7

:send_pixels		call	#qsync			'do horizontal sync

			waitvid	mode,char_color
		
			add	lcolor_ptr,#1
			djnz    x,@line           	'another line?

	                mov     x,#bottom_blanks
			call	#qblank 
			setp	#0			'do vertical sync
			mov	x,#vsync
			call	#qblank
			clrp	#0

	                jmp     #vga

'================================================================================

qblank			call	#qsync			'blank lines
			waitvid	#800,#0
			djnz	x,@qblank
qblank_ret		ret

'================================================================================

'horizontal sync

qsync			waitvid	#40,#0
			waitvid	#128,#1
			waitvid	#88,#0
qsync_ret		ret

'================================================================================
'				color base		mode		clocks/pixel	clocks/waitvid
edge			long	pixel_base << 24 +	$7 << 20 +	cpp << 13 +	144 
mode			long	pixel_base << 24 +	$7 << 20 +	cpp << 13 +	800
char_color		long	%111_111_111 << 18 + %000_011_000 << 9

lines_vis		long	600

x			long	0

lcolor_ptr		long	0
_colors			long	@colors
ax9			long	0
bx9			long	0
cx9			long	0
dx9			long	0
ex9			long	0
vid_ptr			long	0


'/////////////////////////////  End of TASK #1    //////////////////////////////

'2222222222222222222222222222222   TASK #2   222222222222222222222222222222222222222

'Game timers
'Sound tasker

timers			passcnt	ticker
			add	ticker,tick_time

'Sound Tasker - 10kHz 4 bit (Needs 4 bit R@R ladder network on P5-P8)

			add	cps_prescaler,#1
			cmp	cps_prescaler,_10_000 wz,wc
		if_e	mov	cps_prescaler,#0
		if_e	mov	coglets_per_sec,game_loop_count
		if_e	mov	game_loop_count,#0
		if_e	setb	game_flags,#score_changed

			testb	sys_flags,#mute wz
		if_nz	jmp	#:no_sound

			
			testb	sys_flags,#ch1 wz
		if_z	mov	nibble,#0
		if_z	jmp	#:ch2_check
			rdbyte	nibble,ch1_ptr
			cmp	nibble,#$e wz,wc
		if_e	clrb	sys_flags,#ch1
		if_e	jmp	#:ch2_check
			notb	sys_flags,#ch1_nibble
			testb	sys_flags,#ch1_nibble wz
		if_nz	shl	nibble,#4
		if_nz	add	ch1_ptr,#1
			and	nibble,#$f0

		
:ch2_check		testb	sys_flags,#ch2 wz
		if_z	mov	nibble2,#0
		if_z	jmp	#:ch3_check
			rdbyte	nibble2,ch2_ptr
			cmp	nibble2,#$e wz,wc
		if_e	clrb	sys_flags,#ch2
		if_e	jmp	#:make_noise
			notb	sys_flags,#ch2_nibble
			testb	sys_flags,#ch2_nibble wz
		if_nz	shl	nibble2,#4
		if_nz	add	ch2_ptr,#1
			and	nibble2,#$f0

:ch3_check		testb	sys_flags,#ch3 wz
		if_z	mov	nibble3,#$80
		if_z	jmp	#:make_noise
			rdbyte	nibble3,ch3_ptr
			cmp	nibble3,#$e wz,wc
		if_e	clrb	sys_flags,#ch3
		if_e	jmp	#:make_noise
			notb	sys_flags,#ch3_nibble
			testb	sys_flags,#ch3_nibble wz
		if_nz	shl	nibble3,#4
		if_nz	add	ch3_ptr,#1
			and	nibble3,#$f0

:make_noise		testb	sys_flags,#ch1 wz
		if_nz	jmp	#:mn2
			testb	sys_flags,#ch2 wz
		if_nz	mov	nibble,nibble2
		if_z	jmp	#:no_sound

:mn2			shl	nibble,sound_dac
			andn	pina,sound_dac_mask
			or	pina,nibble


{
			testb	sys_flags,#sound wz
		if_z	jmp	#:no_sound

			rdbyte	nibble,sound_ptr
			cmp	nibble,#$e wz,wc
		if_e	clrb	sys_flags,#sound
		if_e	jmp	#:no_sound

			notb	sys_flags,#nibble_select
			testb	sys_flags,#nibble_select wz
		if_nz	shl	nibble,#4
		if_nz	add	sound_ptr,#1
			and	nibble,#$f0
			shl	nibble,sound_dac
			andn	pina,sound_dac_mask
			or	pina,nibble

}
:no_sound

			jz	elapsed_,@:e9
			sub	elapsed_,#1

:e9

			add	cannon_ticks,#1
			add	alien_ticks,#1
			add	missile_ticks,#1
			add	bomb_ticks,#1
			add	bomb_ticks2,#1
			add	saucer_ticks,#1
			add	reload_timer_,#1

			jz	hold_fire_,@:hf
			sub	hold_fire_,#1

:hf			jmp	#timers

sound_dac		long	0
sound_dac_mask		long	0

_rx_buffer		long	@rx_buffer
rx_ptr			long	@rx_buffer
rx_byte			long	0
tx_byte			long	0
tick_time		long	_xinfreq / tps
ticker			long	0

nibble			long	0
nibble2			long	0
nibble3			long	0

'sound_ptr		long	0

game_loop_count		long	0
coglets_per_sec		long	0
cps_prescaler		long	0
_10_000			long	10_000

ch1_2			long	|< ch1 | |< ch2
ch1_ptr			long	0
ch2_ptr			long	0
ch3_ptr			long	0
'ch4_ptr			long	0

'/////////////////////////////  End of TASK #2    //////////////////////////////


'***********************************************************************************

'Game "coglet" library

'***********************************************************************************
			org

clearscreen		setptra	_video
			addptra	window

			
:loop			mov	:ax,#8
:loop2			wrlong	zero,ptra++
			djnz	:ax,@:loop2
			addptra	:adj
			djnz	:count,@:loop

			setptra	_video
			addptra	window
			addptra	_line
			mov	:count,#8
:loop3			wrlong	solid,ptra++
			djnz	:count,@:loop3

{
			setptra	_video
			addptra	window
			mov	:count,#150
:loop4			wrbyte	:bit7,ptra
			addptra	#31
			wrbyte	:bit0,ptra++
			addptra	#(cols-256)/8
			djnz	:count,@:loop4

}
			jmp	#next_coglet

:bit7			long	|< 7
:bit0			long	|< 0
:adj			long	(cols-256)/8
:count			long	150
:ax			long	0
solid			long	$ffffffff
_line			long	(cols/8)*135

cls_end			long	$cececece
'*********************************************************************
			org

message			add	pc,#1
			rdbytec	msg_m,pc
			add	pc,#1
			rdbytec	xm,pc
			add	pc,#1
			rdbytec	ym,pc

			mov	vid,_video
			add	vid,window
			shl	ym,#v_parm4
			add	vid,ym
			add	vid,xm
			shl	msg_m,#2
			add	msg_m,msgs_m
			rdlongc	msg_m,msg_m
			setptra	msg_m

m_print			rdbytec	ax,ptra++ wz
		if_z	jmp	#next_coglet
			and	ax,#$3f
			shl	ax,#3
			add	ax,_chars
			setptrb	ax
			mov	cx,#8
:loop2			rdbytec	ax,ptrb++
			wrbyte	ax,vid
			add	vid,#bytes_per_col '32
			djnz	cx,@:loop2
'			sub	vid,#255  '(8*32)-1
			sub	vid,_adjx '#(8*bytes_per_col)-1
			jmp	#m_print

_adjx			long	(8*bytes_per_col)-1
_chars			long	@chars
vid			long	0

		
msgs_m			long	@messages
msg_m			long	0
xm			long	0
ym			long	0

msg_end			long	$cececece
'*********************************************************************
			org

pause_x100ms		add	pc,#1
			rdbytec	:pause_val,pc
			mul32	:pause_val,:delay
		'	setmula	:pause_val
		'	setmulb	:delay
			getmull	:pause_val
			getcnt	:ax
			add	:pause_val,:ax
			passcnt	:pause_val
			jmp	#next_coglet

:delay			long	_xinfreq / 10  '100mS

:ax			long	0
:pause_val		long	0

pause_end		long	$cececece
'*********************************************************************
			org

entity_init	
			setptry	#0

			wraux	:shield1a,ptry++	'pushy	:shield1a
			wraux	:shield1b,ptry++	'pushy	:shield1b
			wraux	:shield2a,ptry++	'pushy	:shield2a
			wraux	:shield2b,ptry++	'pushy	:shield2b
			wraux	:shield3a,ptry++	'pushy	:shield3a
			wraux	:shield3b,ptry++	'pushy	:shield3b
			wraux	:shield4a,ptry++	'pushy	:shield4a
			wraux	:shield4b,ptry++	'pushy	:shield4b
			wraux	:cannon,ptry++		'pushy	:cannon
			wraux	:missile,ptry++		'pushy	:missile
			wraux	:bomb,ptry++		'pushy	:bomb
			wraux	:bomb2,ptry++		'pushy	:bomb2
			wraux	:saucer,ptry++		'pushy	:saucer
			wraux	:explosion,ptry++	'pushy	:explosion
			jmp	#next_coglet
{
Bit 31		Entity active (alive)
Bit 30		Alternate sprite flag - Used to animate alien characters.
Bit 29-24	Score value x 10
Bit 23-20	Sprite width (-1)
Bit 19-16	Sprite base number
Bit 15-8	Sprite X coordinate
Bit 7-0		Sprite Y coordinate
}

:shield1a		long	15 << 20 | s_shield_left << 16 | s1 << 8 | shield_y
:shield1b		long	15 << 20 | s_shield_right << 16 | (s1+16) << 8 | shield_y
:shield2a		long	15 << 20 | s_shield_left << 16 | s2 << 8 | shield_y
:shield2b		long	15 << 20 | s_shield_right << 16 | (s2+16) << 8 | shield_y
:shield3a		long	15 << 20 | s_shield_left << 16 | s3 << 8 | shield_y
:shield3b		long	15 << 20 | s_shield_right << 16 | (s3+16) << 8 | shield_y
:shield4a		long	15 << 20 | s_shield_left << 16 | s4 << 8 | shield_y
:shield4b		long	15 << 20 | s_shield_right << 16 | (s4+16) << 8 | shield_y
:cannon			long	14 << 20 | s_cannon
:missile		long	0 << 20 | s_missile << 16
:bomb			long	1 << 20 |s_bomb_a << 16
:bomb2			long	1 << 20 |s_bomb_a << 16
:saucer			long	20 << 24 | 15 << 20 | s_saucer << 16 | 0 << 8 | saucer_y
':explosion		long	15 << 20 | s_explosion << 16
:explosion		long	10 << 20 | s_explosion << 16

ei_end			long	$cececece
'*********************************************************************
			org
_g_alien_init

'calculate alien top row start position

			setptry	#e_alien0
			setinda	#:list
		'	setf	#%0_01_00_00_00

			mov	:ax,level_
			max	:ax,#4
			add	:ax,#1
			mov	:y,#20-6
:calc_y			add	:y,#6
			djnz	:ax,@:calc_y

'set alien positions

			mov	:ex,#alien_rows
:loop2			mov	:z,inda++
			mov	:sc,:z
			shr	:sc,#8
			or	:sc,#$80
			mov	:cx,#alien_cols
			mov	:x,#10
			cmp	:ex,#alien_rows wz,wc
		if_e	add	:x,#2
			mov	dx,#0
:loop		'	movf	:dx,:sc  
		'	movf	:dx,:z
		'	movf	:dx,:x
		'	movf	:dx,:y
			setbyte	:dx,:sc,#3
			setbyte	:dx,:z,#2
			setbyte	:dx,:x,#1
			setbyte	:dx,:y,#0

:loop3		'	pushy	:dx
			wraux	:dx,ptry++
			add	:x,#18
			djnz	:cx,@:loop
			add	:y,#12
			djnz	:ex,@:loop2

			jmp	#next_coglet

:list			long	3 << 8 | 7 << 4 | s_alien1a
			long	2 << 8 | 10 << 4 |s_alien2a
			long	2 << 8 | 10 << 4 | s_alien2a
			long	1 << 8 | 11 << 4 | s_alien3a
			long	1 << 8 | 11 << 4 | s_alien3a

:ax			long	0
:cx			long	0
:ex			long	0
:dx			long	0


:x			long	0
:y			long	0
:z			long	0
:sc			long	0

ai_end			long	$cececece
'*********************************************************************
			org

_g_repeat		add	pc,#1
			rdbytec	_repeats,pc
			add	pc,#1
			mov	loop_pc,pc
			jmp	#coglet_ret

rpt_end			long	$cececece
'*********************************************************************
			org

_g_for			add	pc,#1
			rdbytec	_start,pc
			add	pc,#1
			rdbytec	_end,pc
			add	pc,#1
			rdbytec	_step,pc
			add	pc,#1
			mov	loop_pc,pc
			jmp	#coglet_ret

for_end			long	$cececece
'*********************************************************************
			org

_g_loop			sub	_repeats,#1 wz
		if_z	jmp	#next_coglet
			mov	pc,loop_pc
			jmp	#coglet_ret

loop_end		long	$cececece
'*********************************************************************
			org

_g_next			add	_start,_step
			cmp	_start,_end wz,wc
		if_ae	jmp	#next_coglet
			mov	pc,loop_pc
			jmp	#coglet_ret

next_end		long	$cececece
'*********************************************************************
			org

_g_wait4fire		getp	fire_ wz
		if_nz	jmp	#_g_wait4fire
			jmp	#next_coglet

wait4fire_end		long	$cececece
'*********************************************************************
			org

_g_wait4left		getp	left_ wz
		if_nz	jmp	#_g_wait4left
			jmp	#next_coglet

wait4left_end		long	$cececece
'*********************************************************************
			org

_g_back			mov	pc,loop_pc
			jmp	#coglet_ret

back_end		long	$cececece
'*********************************************************************
			org

_g_plot_e		add	pc,#1
			rdbytec	entity,pc
			call	#get_metrics
			call	#plot
			jmp	#next_coglet

plot_e_end		long	$cececece
'*********************************************************************
			org

draw_all_aliens	

			rdbyte	:ax,:pidx
			add	:ax,#1
			and	:ax,#3
			wrbyte	:ax,:pidx

			add	:ax,#:p0
			sets	:pq,:ax
:px			nop
			nop
:pq			mov	:px,:p0
			setptrb	:px

			getcnt	:ax

:loop			rdbyte	entity,ptrb++
			add	entity,#e_alien0
			call	#get_metrics
			call	#plot

			add	:ax,:bx
			passcnt	:ax
			djnz	:count,@:loop
			jmp	#next_coglet

:p0			long	@spiral_load
:p1			long	@load_b2t
:p2			long	@zig_zag
:p3			long	@zig_zag2

:pidx			long	@pattern_index
:ax			long	0
:bx			long	_xinfreq / 50

:count			long	total_aliens
daa_end			long	$cececece
'*********************************************************************
			org

draw_shields		mov	entity,#e_shield1_left
:loop			call	#get_metrics
			call	#plot
			add	entity,#1	
			djnz	:count,@:loop
			jmp	#next_coglet

:count			long	8

ds_end			long	$cececece
'*********************************************************************
			org

new_game		and	game_flags,:_init_flags
			mov	alien_row_,#0
			setb	game_flags,#show_lives

			mov	:x,#10
			mov	:y,#cannon_y
			mov	:z,#14 << 4 | s_cannon

			mov	dx,#0

'			setf	#%0_01_00_00_00
':loop			movf	:dx,:z
'			movf	:dx,:x
'			movf	:dx,:y
'			setptry	#e_cannon
'			pushy	:dx

:loop			setbyte	:dx,:z,#2
			setbyte	:dx,:x,#1
			setbyte	:dx,:y,#0
			wraux	:dx,#e_cannon
			
			setb	game_flags,#score_changed
			setb	game_flags,#new_hi_score
			mov	alien_speed_,:_alien_min
			mov	alien_count_,:_num_aliens
			mov	alien_ticks,#0
			mov	saucer_ticks,#0
			getcnt	saucer_timer_

			mov	alien_direction_,#0
			mov	saucer_ticks,#0

			mov	hold_fire_,:hold_time

			jmp	#next_coglet

:hold_time		long	4 * tps
:_num_aliens		long	total_aliens
:_alien_min		long	alien_min
:_init_flags		long	|< demo_mode

:ax			long	0
:x			long	0
:y			long	0
:z			long	0
:dx			long	0

ng_end			long	$cececece
'*********************************************************************
			org

move_cannon		testb	game_flags,#halt wz
		if_nz	jmp	#next_coglet

			testb	game_flags,#winner wz
		if_nz	jmp	#next_coglet

			testb	game_flags,#demo_mode wz
		if_z	jmp	#:chk_buttons

'demo mode
			getp	right_ wz
		if_z	setb	game_flags,#demo_abort
			getp	left_ wz
		if_z	setb	game_flags,#demo_abort
			getp	fire_ wz
		if_z	setb	game_flags,#demo_abort

			testb	game_flags,#demo_move wz
		if_z	jmp	#:new_move

:moving			cmpcnt	demo_timer_ wc
		if_c	clrb	game_flags,#demo_move
		if_c	jmp	#next_coglet

			cmp	demo_dir_,#1 wz,wc
		if_e	jmp	#:force_right
			cmp	demo_dir_,#2 wz,wc
		if_e	jmp	#:force_left
			jmp	#next_coglet

:new_move		getcnt	demo_timer_
			getlfsr	:ax
			and	:ax,#1
			mov	:bx,:fake_press_time
			shl	:bx,:Ax
			add	demo_timer_,:bx
			setb	game_flags,#demo_move
:same			getlfsr	:ax
			and	:ax,#3
			cmp	:ax,demo_dir_ wz,wc
		if_e	jmp	#:same
			mov	demo_dir_,:ax

			getlfsr	:ax
			testb	:ax,#22 wz
		if_nz	setb	game_flags,#demo_fire

			clrb	game_flags,#left_button
			clrb	game_flags,#right_button
			mov	cannon_ticks,#0
			jmp	#next_coglet

:fake_press_time	long	300 * ms

'check buttons

:chk_buttons		getp	right_ wz
		if_nz	jmp	#:chk2

:force_right		testb	game_flags,#cannon_right wz
		if_z	mov	cannon_ticks,#0
			setb	game_flags,#cannon_right
			clrb	game_flags,#cannon_left
			jmp	#:inc

:chk2			getp	left_ wz
		if_nz	jmp	#:no_buttons

:force_left		testb	game_flags,#cannon_left wz
		if_z	mov	cannon_ticks,#0
			setb	game_flags,#cannon_left
			clrb	game_flags,#cannon_right
			jmp	#:inc

:no_buttons		andn	game_flags,:mask
			jmp	#next_coglet

'check cannon timer

:inc			testb	game_flags,#cannon_right wz
		if_z	jmp	#:cc2
			cmp	cannon_ticks,:_cannon_speed wz,wc
		if_b	jmp	#next_coglet
			sub	cannon_ticks,:_cannon_speed
			jmp	#:move

:cc2			testb	game_flags,#cannon_left wz
		if_z	jmp	#next_coglet
			cmp	cannon_ticks,:_cannon_speed wz,wc
		if_b	jmp	#next_coglet
			sub	cannon_ticks,:_cannon_speed

'check cannon position

:move			rdaux	:ax,#e_cannon

		'	setptry	#e_cannon
		'	popbr	:ax
			mov	:dx,#0
		'	setf	#%0_10_00_11_01
		'	movf	:dx,:ax

			getbyte	:dx,:ax,#1

			testb	game_flags,#cannon_right wz
		if_z	jmp	#:tst2
			cmp	:dx,#cannon_max wz,wc
		if_e	jmp	#next_coglet
			jmp	#:proceed

:tst2			testb	game_flags,#cannon_left wz
		if_z	jmp	#next_coglet
			cmp	:dx,#cannon_min wz,wc
		if_e	jmp	#next_coglet

'erase cannon

:proceed		cmp	lcolor_ptr,#cannon_y wz,wc    'sync with video
	'	if_ae	jmp	#:proceed

			mov	entity,#e_cannon
			call	#get_metrics
			call	#erase

		'	setptry	#e_cannon
		'	popbr	:ax
			mov	:dx,#0
		'	setf	#%0_10_00_11_01
		'	movf	:dx,:ax

			rdaux	:ax,#e_cannon
			getbyte	:dx,:ax,#1

'adjust cannon

			testb	game_flags,#cannon_right wz
		if_z	jmp	#:mc2
			add	:dx,#cannon_horiz_inc
			jmp	#:update

:mc2			testb	game_flags,#cannon_left wz
		if_z	jmp	#next_coglet
			sub	:dx,#cannon_horiz_inc


'update cannon

:update			setbyte	:ax,:dx,#1
			wraux	:ax,#e_cannon

		'	movf	:ax,:dx
		'	pushyr	:ax

			call	#get_metrics
			call	#plot
			jmp	#next_coglet

 
:_cannon_speed		long	cannon_speed
:mask			long	|< cannon_left | |< cannon_right

:ax			long	0
:bx			long	0
:dx			long	0

mc_end			long	$cececece

'*********************************************************************
			org

move_saucer		testb	game_flags,#halt wz
		if_nz	jmp	#next_coglet

			testb	game_flags,#hold_score wz
		if_nz	jmp	#:show_score

			testb	game_flags,#saucer_active wz
		if_nz	jmp	#flying_s

			mov	axs,saucer_timer_
			subcnt	axs
			cmp	axs,_saucer_interval wz,wc
		if_b	jmp	#next_coglet

'new saucer

			jz	alien_count_,@next_coglet

:new_value		getlfsr	svs
			and	svs,#3 wz
		if_z	jmp	#:new_value

			mov	saucer_value_,#0
:set_sv			add	saucer_value_,#50
			djnz	svs,@:set_sv

			getlfsr	axs
			testb	axs,#0 wz
			setbnz	game_flags,#saucer_direction
			mov	saucer_ticks,#0
			setb	game_flags,#saucer_active

'init start position

:set_sp			rdaux	axs,#e_saucer
		if_z	setbyte	axs,#0,#1
		if_nz	setbyte	axs,#240,#1
			wraux	axs,#e_saucer

		'	setptry	#e_saucer
		'	popbr	axs
		'	setf	#%0_00_01_00_00
	'	if_z	movf	axs,#0
	'	if_nz	movf	axs,#241
	'		pushyr	axs

			jmp	#next_coglet


'show score from saucer

:show_score		mov	axs,score_time_
			subcnt	axs
			cmp	axs,_score_dwell wz,wc
		if_b	jmp	#next_coglet
			clrb	game_flags,#hold_score
			mov	entity,#e_saucer
			call	#get_metrics
			mov	svid,et_v
			setptra	_msg12
			call	#sprint
			jmp	#next_coglet

_score_dwell		long	1300 * ms

'existing saucer

flying_s		cmp	saucer_ticks,_saucer_speed wz,wc
		if_b	jmp	#next_coglet
			sub	saucer_ticks,_saucer_speed

			mov	entity,#e_saucer
			call	#get_metrics

:sync_saucer		cmp	lcolor_ptr,#64 wz,wc
		if_b	jmp	#:sync_saucer

			call	#erase

			rdaux	axs,#e_saucer
			getbyte	dxs,axs,#1
			testb	game_flags,#saucer_direction wz
		if_z	add	dxs,#1
		if_nz	sub	dxs,#1
			setbyte	axs,dxs,#1
			wraux	axs,#e_saucer

		'	setptry	#e_saucer
		'	popbr	axs
		'	setf	#%0_10_00_11_01
		'	movf	dxs,axs
		'	testb	game_flags,#saucer_direction wz
	'	if_z	add	dxs,#1
	'	if_nz	sub	dxs,#1
		'	movf	axs,dxs
		'	pushyr	axs

:flying2		call	#get_metrics
			testb	game_flags,#saucer_direction wz
		if_nz	jmp	#:l_check

:r_check		cmp	et_x,#241 wz,wc
		if_b	jmp	#:saucer_good
			jmp	#:eof

:l_check		cmp	et_x,#0 wz,wc
		if_a	jmp	#:saucer_good

'end of flight

:eof			clrb	game_flags,#saucer_active
			getcnt	saucer_timer_
			jmp	#next_coglet
			
:saucer_good		call	#plot
:done			jmp	#next_coglet

sprint			rdbytec	ax,ptra++ wz
sprint_ret	if_z	ret
			and	ax,#$3f
			shl	ax,#3
			add	ax,s_chars
			setptrb	ax
			mov	cx,#8
:loop2			rdbytec	ax,ptrb++
			wrbyte	ax,svid
			add	svid,#bytes_per_col '32
			djnz	cx,@:loop2
			sub	svid,_adjx2 '#(8*bytes_per_col)-1  '255  '(8*32)-1
			jmp	#sprint

_adjx2			long	(8*bytes_per_col)-1
s_chars			long	@chars
svid			long	0

_saucer_speed		long	saucer_speed
_saucer_interval	long	saucer_time_interval  * _xinfreq

axs			long	0
cxs			long	0
dxs			long	0
svs			long	0

_msg12			long	@msg12
ms_end			long	$cececece
'*********************************************************************
			org

move_missile		testb	game_flags,#blast_active wz
		if_nz	jmp	#:skip_id

			testb	game_flags,#missile_active wz
		if_nz	jmp	#:part2

			testb	game_flags,#killed wz
		if_nz	jmp	#:skip_id

			testb	game_flags,#demo_fire wz
		if_nz	jmp	#:fire

			getp	fire_ wz
		if_nz	jmp	#:skip_id

:fire 			clrb	game_flags,#demo_fire
			cmp	reload_timer_,:rl_time wz,wc
	 	if_b	jmp	#:skip_id
			mov	reload_timer_,#0
'new missile
			testb	game_flags,#hold_score wz
		if_nz	jmp	#:skip_sound
			testb	game_flags,#killed wz
		if_nz	jmp	#:skip_sound

		'	mov	sound_ptr,_shoot_sound
		'	setb	sys_flags,#sound

			mov	ch1_ptr,_shoot_sound
			setb	sys_flags,#ch1

:skip_sound		setb	game_flags,#missile_active
			mov	missile_ticks,#0

			rdaux	:ax,#e_cannon
			getbyte	:dx,:ax,#1
			add	:dx,#6
			rdaux	:ax,#e_missile
			setbyte	:ax,:dx,#1
			mov	:dx,#cannon_y-4
			setbyte	:ax,:dx,#0
			wraux	:ax,#e_missile

		'	setptry	#e_cannon
		'	popbr	:ax
		'	setf	#%0_10_00_11_01
		'	movf	:dx,:ax
		'	add	:dx,#6
		'	setptry	#e_missile
		'	popbr	:ax
		'	movf	:ax,:dx
		'	setf	#%0_00_00_00_00
		'	mov	:dx,#cannon_y-4
		'	movf	:ax,:dx
		'	pushyr	:Ax

:skip_id		add	pc,#1
			jmp	#next_coglet

:rl_time		long	tps / 5

'is it time to move existing missile?

:part2			cmp	missile_ticks,:_missile_speed wz,wc
		if_b	jmp	#:skip_id
			sub	missile_ticks,:_missile_speed

'erase missile

:part3			mov	entity,#e_missile
			call	#get_metrics
			call	#erase
'move missile
			mov	:dx,#0
			rdaux	:ax,#e_missile

		'	setptry	#e_missile
		'	popbr	:ax
		'	setf	#%0_00_00_00_00

			getbyte	:dx,:ax,#0
		'	movf	:dx,:ax
			sub	:dx,#1 wz
			cmp	:dx,#8 wz,wc
		if_b	clrb	game_flags,#missile_active
		if_b	jmp	#:skip_id

			setbyte	:ax,:dx,#0
			wraux	:ax,#e_missile

		'	movf	:ax,:dx
		'	pushyr	:ax

'see if we have hit something

:pass2			clrb	game_flags,#bullseye
			call	#get_metrics
			call	#overlay

			testb	game_flags,#bullseye wz
		if_nz	setb	game_flags,#id_victim

			call	#get_metrics 
			testb	game_flags,#bullseye wz
		if_z	call	#plot
		if_z	jmp	#:skip_id

:done			jmp	#next_coglet
			
:_missile_speed		long	missile_speed

:ax			long	0
:bx			long	0
:dx			long	0
:ptra2			long	0
:ptrb2			long	0

_shoot_sound		long	@shoot_sound

mm_end			long	$cececece
'*********************************************************************
			org

move_aliens		testb	game_flags,#halt wz
		if_nz	jmp	#next_coglet

			testb	game_flags,#blast_active wz
		if_nz	jmp	#next_coglet

			testb	game_flags,#killed wz
		if_nz	jmp	#:done

:attack			cmp	alien_ticks,alien_speed_ wz,wc
		if_b	jmp	#:done
			mov	alien_ticks,#0

			cmp	alien_row_,#0 wz,wc
		if_ne	sub	alien_row_,#1
		if_ne	jmp	#:get_mo

			rdbyte	:idx,_sfx_index
			add	:idx,#1
			and	:idx,#3
			wrbyte	:idx,_sfx_index

			add	:idx,#_fx1
			sets	:tone,:idx
			nop
			nop
{
			testb	sys_flags,#sound wz
:tone		if_z	mov	sound_ptr,_fx1
		if_z	setb	sys_flags,#sound
}
:tone			mov	ch2_ptr,_fx1
			setb	sys_flags,#ch2

			mov	alien_row_,#alien_rows-1

'get alien movement offsets

:get_mo			mov	entity,#e_alien0

			cmp	alien_direction_,#0 wz,wc
		if_e	mov	:gx,#alien_horiz_inc
		if_e	mov	:gy,#0
			cmp	alien_direction_,#1 wz,wc
		if_e	mov	:gx,#0
		if_e	mov	:gy,#alien_vert_inc
			cmp	alien_direction_,#2 wz,wc
		if_e	mov	:gx,#-alien_horiz_inc & $ff
		if_e	mov	:gy,#0
			cmp	alien_direction_,#3 wz,wc
		if_e	mov	:gx,#0
		if_e	mov	:gy,#alien_vert_inc

			cmp	alien_row_,#0 wz
		if_z	setb	game_flags,#scan
		if_z	jmp	#:again

'calc row start

			mov	:ax,alien_row_
:loopq			add	entity,#alien_cols
			djnz	:ax,@:loopq

'get alien properties and erase alien

:again			call	#get_metrics

			testb	et_f,#7 wz
		if_z	jmp	#:next_alien

			call	#erase
			notb	et_f,#6  'alternate sprite
		
'move alien
			add	et_x,:gx
			and	et_x,#$ff
			add	et_y,:gy

			mov	:ax,#cannon_y-8
			cmp	et_y,:ax wz,wc
		if_ae	or	game_flags,:_killed
		if_ae	mov	lives_,#1

'update alien		
		'	setf	#%0_10_00_00_00
		'	movf	:ax,et_y
		'	movf	:ax,et_x
		'	movf	:ax,et_s
		'	movf	:ax,et_f
		'	setptry	entity
		'	pushy	:ax

			setbyte	:ax,et_y,#0
			setbyte	:ax,et_x,#1
			setbyte	:ax,et_s,#2
			setbyte	:ax,et_f,#3
			wraux	:ax,entity

'redraw alien
			call	#get_metrics
			call	#plot

			testb	game_flags,#killed wz 'game_over wz
		if_nz	jmp	#next_coglet

'index to next alien in rpw

:next_alien		add	entity,#1
			djnz	:count,@:again

:done			jmp	#next_coglet

:count			long	alien_cols
':go_mask		long	|< game_over | |< game_over_msg
:_killed			long	|< killed
:gx			long	0
:gy			long	0

:ax			long	0
:bx			long	0
:cx			long	0
:dx			long	0
:idx			long	0

_fx1			long	@tone1
			long	@tone2
			long	@tone3
			long	@tone4

_sfx_index		long	@sfx_index
ma_end			long	$cececece
'*********************************************************************

			org

match_victim		clrb	game_flags,#id_victim

			mov	y_hit_,hit_address
			sub	y_hit_,_video
			sub	y_hit_,window
			mov	x_hit_,y_hit_
			shr	y_hit_,#v_parm3 '5
			and	x_hit_,#$1f
			shl	x_hit_,#3

			mov	ax5,#b0
			add	ax5,byte_ofst
			sets	:fred,ax5
			mov	bx5,#$80
			mov	cx5,#8
			nop
			nop
:fred			mov	ax5,0
:loopb			test	ax5,bx5 wz
		if_nz	jmp	#:bit_match
			shr	bx5,#1
			djnz	cx5,@:loopb

:bit_match		mov	o_hit_,#8
			sub	o_hit_,cx5

			mov	dx5,x_hit_
			add	dx5,o_hit_


'has missile hit shield?

:jjj			mov	entity,#e_shield1_left
:ppp			mov	count5,#8
:mmm			rdbyte	:mmm,hit_address
			mov	:ppp,hit_address
			sub	:ppp,#bytes_per_col '32

:chk2			call	#get_metrics
			getlfsr	:jjj
			call	#check
		if_nz	clrb	game_flags,#missile_active
		if_nz	and	:jjj,:mmm		
		if_nz	wrbyte	:jjj,:ppp
		if_nz	wrbyte	zero,hit_address
		if_nz	jmp	#next_coglet		
			add	entity,#1
			djnz	count5,@:chk2


'has missile hit an alien?

			mov	entity,#e_alien0
			mov	count5,#total_aliens
:nxt			call	#get_metrics
			testb	et_f,#7 wz
		if_z	jmp	#:nxt2
			call	#check
		if_nz	jmp	#kill_alien
:nxt2			add	entity,#1
			djnz	count5,@:nxt

'has missile hit saucer?


			testb	game_flags,#saucer_active wz
		if_z	jmp	#next_coglet
			mov	entity,#e_saucer
			call	#get_metrics
			call	#check
		if_z	jmp	#next_coglet

'kill saucer

		'	mov	sound_ptr,_kill_saucer
		'	setb	sys_flags,#sound

			mov	ch1_ptr,_kill_saucer
			setb	sys_flags,#ch1

			clrb	game_flags,#missile_active
			call	#get_metrics
			call	#erase
			call	#get_metrics
			setptra	_msg11
			cmp	saucer_value_,#50 wz,wc
		if_a	wrbyte	_one,ptra
		if_e	wrbyte	_space,ptra
		if_e	wrbyte	_five,ptra[1]
			cmp	saucer_value_,#100 wz,wc
		if_a	wrbyte	_five,ptra[1]
		if_e	wrbyte	_zero,ptra[1]
			mov	xvid,et_v

xprint			rdbytec	ax,ptra++ wz
xprint_ret	if_z	jmp	#there
			and	ax,#$3f
			shl	ax,#3
			add	ax,x_chars
			setptrb	ax
			mov	cx,#8
:loop2			rdbytec	ax,ptrb++
			wrbyte	ax,xvid
			add	xvid,#bytes_per_col '32
			djnz	cx,@:loop2
			sub	xvid,_adjx3  '#(8*bytes_per_col)-1  '(8*64)-1
			jmp	#xprint

_adjx3			long	(8*bytes_per_col)-1
x_chars			long	@chars
xvid			long	0


there			clrb	game_flags,#saucer_active
			getcnt	saucer_timer_
			add	score_,saucer_value_
			setb	game_flags,#score_changed
			getcnt	score_time_
			setb	game_flags,#hold_score

id_done			jmp	#next_coglet

_kill_alien_snd		long	@alien_killed_sound

kill_alien		sub	alien_speed_,_speed_change

			testb	game_flags,#killed wz
	'	if_z	mov	sound_ptr,_kill_alien_snd
	'	if_z	setb	sys_flags,#sound

		if_z	mov	ch1_ptr,_kill_alien_snd
		if_z	setb	sys_flags,#ch1

			add	score_,et_sc
			setb	game_flags,#score_changed

			sub	alien_count_,#1 wz
		if_z	setb	game_flags,#winner
	
			call	#get_metrics
			call	#erase
			notb	et_f,#7

		'	setf	#%0_01_00_00_00
		'	movf	ax5,et_f
		'	movf	ax5,et_s
		'	movf	ax5,et_x
		'	movf	ax5,et_y
		'	setptry	entity
		'	pushy	ax5

			setbyte	ax5,et_f,#3
			setbyte	ax5,et_s,#2
			setbyte	ax5,et_x,#1
			setbyte	ax5,et_y,#0
			wraux	ax5,entity

		'	setptry	#e_explosion
		'	popbr	ax5
		'	setf	#%0_10_00_00_00
		'	movf	ax5,et_y
		'	movf	ax5,et_x
		'	pushyr	ax5

			rdaux	ax5,#e_explosion
			setbyte	ax5,et_y,#0
			setbyte	ax5,et_x,#1
			wraux	ax5,#e_explosion

			mov	entity,#e_explosion
			call	#get_metrics
			call	#plot
			getcnt	blast_start_
			setb	game_flags,#blast_active
			
			jmp	#id_done

check			clrb	game_flags,#overlap
			cmp	dx5,et_x wz,wc
		if_b	jmp	#check2
			cmp	y_hit_,et_y wz,wc
		if_b	jmp	#check2
			add	et_y,#8
			cmp	y_hit_,et_y wz,wc
		if_a	jmp	#check2
			add	et_x,et_w
			add	et_x,#1
			cmp	dx5,et_x wz,wc
		if_a	jmp	#check2
			setb	game_flags,#overlap
check2			testb	game_flags,#overlap wz
check_ret		ret


count5			long	total_aliens
_speed_change		long	alien_speed_change
ax5			long	0
bx5			long	0
cx5			long	0
dx5			long	0
ex5			long	0
count2			long	0
_msg11			long	@msg11

_space			long	" "
_zero			long	"0"
_one			long	"1"
_five			long	"5"

_kill_saucer		long	@ufo_killed

mv_end			long	$cececece
'*********************************************************************
			org

_g_plot_s		add	pc,#1
			rdbytec	:s,pc
			add	pc,#1
			rdbytec	:x,pc
			add	pc,#1
			rdbytec	:y,pc

			mov	et_v,_video
			add	et_v,window
			shl	:y,#v_parm3
			shr	:x,#3
			add	et_v,:x
			add	et_v,:y

			mov	et_b,#sprite_base
			shl	:s,#3
			add	et_b,:s

			mov	et_o,#0

			call	#plot

			jmp	#next_coglet

:x			long	0
:y			long	0
:s			long	0

ps_end			long	$cececece
'*********************************************************************
			org

load_sprites		setptry	#sprite_base
			setptra	:source

:loop			rdword	:ax,ptra++
		'	pushy	:ax
			wraux	:ax,ptry++
			djnz	:count,@:loop
			jmp	#next_coglet

:count			long	num_sprites * 8
:source			long	@cannon
:ax			long	0

ls_end			long	$cececece
'*********************************************************************
			org

check_edge		testb	game_flags,#scan wz
		if_z	jmp	#next_coglet

			clrb	game_flags,#scan

			testb	alien_direction_,#0 wz
		if_nz	jmp	#:detected

			mov	entity,#e_alien0

:loop			call	#get_metrics
			testb	et_f,#7 wz
		if_z	jmp	#:nxt

			testb	alien_direction_,#1 wz
		if_nz	jmp	#:test_left

			mov	:ax,#245
			sub	:ax,et_w
			cmp	et_x,:ax wz,wc
		if_a	jmp	#:detected
			jmp	#:nxt

:test_left		cmp	et_x,#10 wz,wc
		if_a	jmp	#:nxt
	
:detected		add	alien_direction_,#1
			and	alien_direction_,#3
			jmp	#next_coglet

:nxt			add	entity,#1
			djnz	:count,@:loop
			jmp	#next_coglet

:count			long	total_aliens
:ax			long	0

ce2_end			long	$cececece
'*********************************************************************
			org

bombs_away		testb	game_flags,#halt wz
		if_nz	jmp	#next_coglet

			testb	game_flags,#bomb_active wz
		if_nz	jmp	#:check_bomb

			testb	game_flags,#game_over wz
		if_nz	jmp	#next_coglet

			testb	game_flags,#no_bombs wz
		if_nz	jmp	#next_coglet

			mov	:ax,level_
			shl	:ax,#3
			add	:ax,:ls
			rdlong	:_release,:ax
			add	:ax,#4
			rdlong	:_bomb_speed,:ax

			mov	:ax,release_timer_
			subcnt	:ax
			cmp	:ax,:_release wz,wc
		if_b	jmp	#next_coglet

			jnz	hold_fire_,@next_coglet

'scan columns for active aliens

			mov	col_enables_,#0

			mov	:ax,#alien_rows

:loop2			mov	:bx,#alien_cols
			mov	:cx,#1
			shl	:cx,#alien_cols-1

:loop			setptry	:alien
		'	popbr	:dx
			rdaux	:dx,ptry++
			testb	:dx,#31 wz
		if_nz	or	col_enables_,:cx
			shr	:cx,#1
			add	:alien,#1
			djnz	:bx,@:loop
			djnz	:ax,@:loop2

			jz	col_enables_,@next_coglet

'pick random active column

:loop3			getlfsr	:ax
			and	:ax,#$f
			cmp	:ax,#alien_cols wz,wc
		if_ae	jmp	#:loop3

			mov	:ec,#1
			shl	:ec,#alien_cols-1
			shr	:ec,:ax
			test	col_enables_,:ec wz
		if_z	jmp	#:loop3

			mov	entity,#e_alien0
			add	entity,#alien_cols * (alien_rows-1)
			add	entity,:ax

'find lowest alien in column

:loop4			call	#get_metrics
			testb	et_f,#7 wz
		if_z	sub	entity,#alien_cols
		if_z	jmp	#:loop4

			mov	bomb_owner_,entity
			sub	bomb_owner_,#e_alien0

			getlfsr	:bx
			and	:bx,#7
			add	:bx,#2

			getlfsr	:ax
			isob	:ax,#6

			setbyte	:dx,:ax,#3
			setbyte	:dx,#1 << 4 | s_bomb_a,#2
			mov	:ax,et_x
			add	:ax,:bx
			setbyte	:dx,:ax,#1
			mov	:ax,et_y
			add	:ax,#10
			setbyte	:dx,:ax,#0
			wraux	:dx,#e_bomb

		'	setptry	#e_bomb
		'	setf	#%0_01_00_00_00
		'	movf	:dx,:ax
		'	movf	:dx,#1 << 4 | s_bomb_a
		'	mov	:ax,et_x
		'	add	:ax,:bx
		'	movf	:dx,:ax
		'	mov	:ax,et_y
		'	add	:ax,#10
		'	movf	:dx,:ax
		'	pushy	:dx
		
			setb	game_flags,#bomb_active
			jmp	#next_coglet

'time to move existing bomb?

:check_bomb		cmp	bomb_ticks,:_bomb_speed wz,wc
		if_b	jmp	#next_coglet
			mov	bomb_ticks,#0
		
'move bomb
			mov	entity,#e_cannon
			call	#get_metrics
			mov	c_x,et_x

			mov	entity,#e_bomb
			call	#get_metrics
			mov	b_x,et_x
			call	#erase

			mov	:dx,#0
			rdaux	:ax,#e_bomb

		'	setptry	#e_bomb
		'	popbr	:ax
		'	setf	#%0_00_00_00_00
		'	movf	:dx,:ax
			getbyte	:dx,:ax,#0
			add	:dx,#1			
			cmp	:dx,#cannon_y-5 wz,wc
		if_ae	jmp	#:chk_cannon


:chk2			setbyte	:ax,:dx,#0
		'	movf	:ax,:dx
			notb	:ax,#30		
		'	pushyr	:ax
			wraux	:ax,#e_bomb
			jmp	#:no_cannon

:chk_cannon		cmp	b_x,c_x wz,wc
		if_b	jmp	#:hit_bottom
			add	c_x,#15
			cmp	b_x,c_x wz,wc
		if_b	jmp	#:hit_cannon

:hit_bottom		clrb 	game_flags,#bomb_active
			jmp	#:tmx

:hit_cannon		setb	game_flags,#killed
			clrb	game_flags,#bomb_active
			jmp	#next_coglet

:no_cannon		clrb	game_flags,#bullseye
			call	#get_metrics
			call	#overlay

			testb	game_flags,#bullseye wz
		if_nz	jmp	#:hitz
			call	#get_metrics
			call	#plot
			jmp	#next_coglet

'bomb hit something  

:hitz			mov	y_hit_,hit_address
			sub	y_hit_,_video
			sub	y_hit_,window
			mov	x_hit_,y_hit_
			shr	y_hit_,#5
			and	x_hit_,#$1f
			shl	x_hit_,#3

			mov	:ax,#b0
			add	:ax,byte_ofst
			sets	:fred,:ax
			mov	:cx,#8
			mov	:dx,#$80
			nop
			nop
:fred			mov	:ax,0
			test	:ax,:dx wz
		if_nz	or	:ex,:dx
			shr	:dx,#1
			djnz	:cx,@:fred

:hitz2			not	:ex
			rdbyte	:ax,hit_address
			and	:ax,:ex
		'	wrbyte	:ax,hit_address
			wrbyte	zero,hit_address
			add	hit_address,#bytes_per_col '32
			getlfsr	:bx
			rdbyte	:ax,hit_address
			and	:ax,:bx
			wrbyte	:ax,hit_address

			clrb	game_flags,#bomb_active
:tmx			getcnt	release_timer_
			jmp	#next_coglet

:ls			long	@level_settings

':patx			long	%11000111
:_release		long	400 * ms

:_bomb_speed		long	bomb_speed 
:ec			long	0 '|< alien_cols-1
:ax			long	0
:bx			long	0
:cx			long	0
:dx			long	0
:ex			long	0
:count			long	total_aliens
:alien			long	e_alien0

c_x			long	0
b_x			long	0
_ff			long	$ff
ba_end			long	$cececece
'*********************************************************************
			org

blast			testb	game_flags,#blast_active wz
		if_z	jmp	#next_coglet

			mov	:ax,blast_start_
			subcnt	:ax
			cmp	:ax,:blast_delay wz,wc
		if_b	jmp	#next_coglet

			clrb	game_flags,#blast_active

			mov	entity,#e_explosion
			call	#get_metrics
			call	#erase

			clrb	game_flags,#missile_active

			jmp	#next_coglet

:ax			long	0
:blast_delay		long	133 * ms
blast_end		long	$cececece
'*********************************************************************
			org

game_end		mov	level_,#0
			mov	score_,#0
			mov	lives_,#start_lives
			mov	last_score_,#0

			mov	vidx,bar
			add	vidx,_video
			add	vidx,window
			add	vidx,#4

			mov	count8,#32
:loop2			mov	count7,#6
 			setptra	vidx
:loop			wrlong	zero,ptra++
			djnz	count7,@:loop
		'	ror	patx,#1
			add	vidx,#32 'bar2
			djnz	count8,@:loop2

			mov	entity,#e_bomb
			call	#get_metrics
			call	#erase

			setptra	_msg6
			mov	gvid,_video
			add	gvid,window
			add	gvid,_loc
			call	#ge_print

			testb	game_flags,#new_hs wz
		if_z	jmp	#next_coglet
			setptra	_msg14
			mov	gvid,_video
			add	gvid,window
			add	gvid,_loc2
			call	#ge_print

			jmp	#next_coglet

ge_print		rdbytec	ax,ptra++ wz
ge_print_ret	if_z	ret		
			and	ax,#$3f
			shl	ax,#3
			add	ax,g_chars
			setptrb	ax
			mov	cx,#8
:loop2			rdbytec	ax,ptrb++
			wrbyte	ax,gvid
			add	gvid,#bytes_per_col '32
			djnz	cx,@:loop2
'			sub	gvid,#255  '(8*32)-1
			sub	gvid,_adjx4  '#(8*bytes_per_col)-1 '255  '(8*32)-1
			jmp	#ge_print


_adjx4			long	(8*bytes_per_col)-1
vidx			long	0
count7			long	0
count8			long	0
bar			long	(cols/8) * 18
bar2			long	64 '(cols-256)/8
patx			long	$55555555

g_chars			long	@chars
gvid			long	0 '@video

_msg6			long	@msg6
_msg14			long	@msg14
_loc			long	(3 * cols) + 10
_loc2			long	(4 * cols) + (bytes_per_col*2) + 9
ge_end			long	$cececece

'*********************************************************************
			org

send		'	tjnz	tx_counter,#send

			add	pc,#1
			rdbyte	tx_byte,pc

:txw			serouta	tx_byte wc
		if_nc	jmp	#:txw

		'	or	tx_byte,#$100
		'	shl	tx_byte,#1
		'	mov	tx_counter,#oversample * 10

			jmp	#next_coglet

send_end		long	$cececece
'*********************************************************************
			org

comms			testb	sys_flags,#tx_disable wz
		if_nz	jmp	#next_coglet

			testb	game_flags,#packet wz
		if_nz	jmp	#next_coglet  'continue

			mov	jx,packet_timer
			subcnt	jx
			cmp	jx,packet_interval wz,wc
		if_b	jmp	#next_coglet

			getcnt	packet_timer
			setb	game_flags,#packet
			mov	packet_ptr,_packet_buffer

			mov	dxr,alien_count_
			setptra	_ac
			call	#dec2

			mov	dxr,alien_speed_
			setptra	_as
			call	#dec4

			mov	dxr,score_
			setptra	_scr
			call	#dec4

			mov	dxr,saucer_ticks
			setptra	_st
			call	#dec6

			mov	dxr,saucer_value_
			setptra	_sv
			call	#dec3

			mov	dxr,x_hit_
			setptra	_hitx
			call	#dec3

			mov	dxr,y_hit_
			setptra	_hity
			call	#dec3

			mov	dxr,o_hit_
			setptra	_hito
			call	#dec2

			mov	dxr,release_timer_
			setptra	_rt
			call	#dec10

		'	setptry	#e_cannon
		'	popbr	axr
		'	setf	#%0_00_00_00_01
		'	movf	dxr,axr

			rdaux	axr,#e_cannon
			getbyte	dxr,axr,#1

			setptra	_canx
			call	#dec3
	
		'	setptry	#e_bomb
		'	popbr	axr
		'	setf	#%0_00_00_00_01
		'	movf	dxr,axr

			rdaux	axr,#e_bomb
			getbyte	dxr,axr,#1

			setptra	_bmbx
			call	#dec3

			getcnt	dxr
			setptra	_cntr
			call	#dec10

			mov	dxr,rx_byte
			setptra	_rxb
			call	#dec3

			mov	dxr,bomb_owner_
			setptra	_ona
			call	#dec2

			mov	dxr,col_enables_
			setptra	_bmsk
			mov	cxr,#alien_cols
			call	#bin

			mov	dxr,lives_
			add	dxr,#"0"
			wrbyte	dxr,_lve

			mov	dxr,level_
			add	dxr,#"0"
			wrbyte	dxr,_lvl

			mov	dxr,coglets_per_sec 
			setptra	_stream
			call	#dec6

			jmp	#next_coglet


bin			mov	jx,#1
			shl	jx,cxr
:bin2			shl	dxr,#1
			test	dxr,jx wz
		if_z	mov	axr,#"0"
		if_nz	mov	axr,#"1"
			wrbyte	axr,ptra++
			djnz	cxr,@:bin2
bin_ret			ret

dec10			mov	jx,_1_000_000_000
			mov	cxr,#10
			jmp	#loop0

dec6			mov	jx,_100000
			mov	cxr,#6
			jmp	#loop0

dec5			mov	jx,_10000
			mov	cxr,#5
			jmp	#loop0

dec4			mov	jx,_1000
			mov	cxr,#4
			jmp	#loop0

dec3			mov	jx,#100
			mov	cxr,#3
			jmp	#loop0

dec2			mov	jx,#10
			mov	cxr,#2

loop0			div32u	dxr,jx
		'	setdiva	dxr
		'	setdiva	#0
		'	setdivb	jx
			getdivq	exr
			add	exr,#"0"
			wrbyte	exr,ptra++
			getdivr	dxr
			div32u	jx,#10
		'	setdiva	jx
		'	setdiva	#0
		'	setdivb	#10
			getdivq	jx
			djnz	cxr,@loop0
dec10_ret
dec6_ret
dec5_ret
dec4_ret
dec3_ret
dec2_ret		ret

		
axr			long	0
bxr			long	0
cxr			long	0
dxr			long	0
exr			long	0

_1_000_000_000		long	1_000_000_000
_100000			long	100_000
_10000			long	10_000
_1000			long	1_000
_ac			long	@ac
_as			long	@as
_scr			long	@scr
_st			long	@st
_sv			long	@sv
_hitx			long	@hitx
_hity			long	@hity
_hito			long	@hito
_rt			long	@rt
_cntr			long	@cntr
_canx			long	@canx
_bmbx			long	@bmbx
_rxb			long	@rxb
_ona			long	@ona
_bmsk			long	@bmsk
_lve			long	@lve
_lvl			long	@lvl
_stream			long	@stream

jx			long	0
_packet_buffer		long	@packet_buffer
packet_interval		long	_xinfreq / 8

comms_end		long	$cececece
'*********************************************************************
			org

monitor			setptrb	_rx_buffer

			rdbyte	:ax,ptrb++
			cmp	:ax,#13 wz,wc
		if_e	jmp	#:done

			cmp	:ax,#"c" wz,wc
		if_e	notb	sys_flags,#tx_disable

			cmp	:ax,#"m" wz,wc
		if_e	notb	sys_flags,#mute

			cmp	:ax,#"1" wz,wc
		if_e	mov	:ax,:_pallette1
		if_e	jmp	#:copy

			cmp	:ax,#"2" wz,wc
		if_e	mov	:ax,:_pallette2
		if_e	jmp	#:copy

			cmp	:ax,#"3" wz,wc
		if_e	mov	:ax,:_pallette3
		if_e	jmp	#:copy

			cmp	:ax,#"4" wz,wc
		if_e	mov	:ax,:_pallette4
		if_ne	jmp	#:mon1

:copy			mov	:cx,#19
			mov	:dx,:_colors
:clr1			rdlong	:bx,:ax
			wrlong	:bx,:dx
			add	:ax,#4
			add	:dx,#4
			djnz	:cx,@:clr1
			jmp	#:done

:_pallette1		long	@pallette1
:_pallette2		long	@pallette2
:_pallette3		long	@pallette3
:_pallette4		long	@pallette4
:_colors		long	@colors

:mon1			cmp	:ax,#"z" wz,wc     'zero hi_score
		if_e	mov	hi_score_,#0
		if_e	setb	game_flags,#score_changed
		if_e	setb	game_flags,#new_hi_score
		if_e	jmp	#:done

			cmp	:ax,#"h" wz,wc     'halt game
		if_e	notb	game_flags,#halt
		if_e	jmp	#:done

			cmp	:ax,#"q" wz,wc    'launch prop2 monitor
		if_e	jmp	#:prop_mon

			cmp	:ax,#"r" wz,wc    'restart game
		if_e	mov	pc,:_game_start

			cmp	:ax,#"k" wz,wc   'kill player
		if_e	setb	game_flags,#killed

			cmp	:ax,#"l" wz,wc    'extra life
		if_e	add	lives_,#1
		if_e	max	lives_,#9
		if_e	setb	game_flags,#show_lives
	'	if_e	mov	sound_ptr,_extra_guy
	'	if_e	setb	sys_flags,#sound
		if_e	mov	ch1_ptr,_extra_guy
		if_e	setb	sys_flags,#ch1

			cmp	:ax,#"v" wz,wc    'difficulty level +
		if_e	add	level_,#1
		if_e	max	level_,#4

			cmp	:ax,#"s" wz,wc   'release saucer
		if_e	getcnt	:ax
		if_e	sub	:ax,:saucer_interval
		if_e	mov	saucer_timer_,:ax

			cmp	:ax,#"b" wz,wc     'disable bombs
		if_e	notb	game_flags,#no_bombs

	
			cmp	:ax,#"d" wz,wc      'restore shields
		if_ne	jmp	#:chk_e
			mov	:cx,#8
			mov	entity,#e_shield1_left
:loop_d			call	#get_metrics
			call	#plot
			add	entity,#1
			djnz	:cx,@:loop_d

:chk_e			cmp	:ax,#"e" wz,wc      'remove shields
		if_ne	jmp	#:done
			mov	:cx,#8
			mov	entity,#e_shield1_left
:loop_e			call	#get_metrics
			call	#erase
			add	entity,#1
			djnz	:cx,@:loop_e

:done			setptrb	_rx_buffer
			mov	:cx,#20
:clr			wrbyte	:space,ptrb++
			djnz	:cx,@:clr

			clrb	game_flags,#load_monitor
			jmp	#coglet_ret

:prop_mon		serouta	#16
			
			getcnt	:ax
			add	:ax,:wait
			passcnt	:ax


			cogrun	:entry,#0
:entry			long	$6e4 'c
:io			long	tx << 9 | rx

:wait			long	_xinfreq / 3
:saucer_interval	long	saucer_time_interval  * _xinfreq
:space			long	" "
:ax			long	0
:bx			long	0
:cx			long	0
:dx			long	0

:_game_start		long	@game_start
_extra_guy		long	@extra_sound

mon_end			long	$cececece
'*********************************************************************
			org

_g_alive		add	game_loop_count,#1

			testb	game_flags,#killed wz
		if_nz	jmp	#:alive_exit

			mov	pc,:_main
			test	sys_flags,#tx_disable wz
		if_nz	mov	pc,:_main2
			jmp	#coglet_ret

:alive_exit		
		'	mov	sound_ptr,_explode
		'	setb	sys_flags,#sound
			mov	ch1_ptr,_explode
			setb	sys_flags,#ch1

			clrb	game_flags,#bomb_active
			clrb	game_flags,#bomb_active2

			mov	entity,#e_bomb
			call	#get_metrics
			call	#erase

			mov	entity,#e_bomb2
			call	#get_metrics
			call	#erase


			jmp	#next_coglet

:ax			long	0
:_main			long	@main
:_main2			long	@main2

_explode		long	@explosion_sound	
alive_end		long	$cececece
'*********************************************************************
			org

idle			getcnt	:ax
			add	:ax,:bx
			passcnt	:ax

			jmp	#next_coglet

:ax			long	0
:bx			long	idle_time

idle_end		long	$cececece
'*********************************************************************
			org

goto			add	pc,#1
			rdbyte	:ax,pc
			add	:ax,:game_start
			mov	pc,:ax
			jmp	#coglet_ret

:ax			long	0
:game_start		long	@game_start

goto_end		long	$cececece
'*********************************************************************
			org

_g_vaporize		mov	entity,#e_cannon
			call	#get_metrics

			setptra	et_v
			'getspb	spb2
			setptry	et_b

			mov	cxf,#8
			mov	byte_ofst,#0

loop_v			rdaux	dxf,ptry++ 'et_b
			shl	dxf,et_o
			getbyte	m0,dxf,#2
			getbyte	m1,dxf,#1
			getbyte	m2,dxf,#0

		'	popbr	dxf
		'	setf	#%0_00_00_11_10
		'	shl	dxf,et_o
		'	movf	m0,dxf
		'	movf	m1,dxf
		'	movf	m2,dxf

			getlfsr	:ax
			and	m0,:ax
			getlfsr	:ax
			and	m1,:ax
			getlfsr	:ax
			and	m2,:ax

			wrbyte	m0,ptra++
			wrbyte	m1,ptra++
			wrbyte	m2,ptra++
			addptra	#bytes_per_col- 3 '29
			djnz	cxf,@loop_v

			jmp	#next_coglet

:ax			long	0

vap_end			long	$cececece
'*********************************************************************
			org

_g_new_cannon		clrb	game_flags,#killed
			mov	entity,#e_cannon
			call	#get_metrics
			call	#erase

			sub	lives_,#1 wz
		if_nz	jmp	#:still_alive

			or	game_flags,:game_mask
			jmp	#next_coglet

:still_alive		rdaux	:ax,#e_cannon
		'	setptry	#e_cannon
		'	popbr	:ax

		'	mov	:bx,#cannon_min
		'	setf	#%0_00_01_00_00
		'	movf	:ax,:bx
			setbyte	:ax,#cannon_min,#1

			wraux	:ax,#e_cannon
		'	pushyr	:ax
			call	#get_metrics
			call	#plot
			setb	game_flags,#show_lives

			mov	hold_fire_,:hold_time
			jmp	#next_coglet

:hold_time		long	5 * tps

:ax			long	0
:bx			long	0
:_main			long	@main
:game_mask		long	|< game_over | |<game_over_msg | |<show_lives
nc_end			long	$cececece
'*********************************************************************
			org

update_lives		testb	game_flags,#show_lives wz
		if_z	jmp	#next_coglet

			mov	:cvid,_video
			add	:cvid,window
			add	:cvid,:lives_left

			clrb	game_flags,#show_lives

			mov	:ax,lives_
			add	:ax,#"0"
			shl	:ax,#3
			add	:ax,:_chars
			setptrb	:ax
			mov	:cx,#8
:loop			rdbytec	:ax,ptrb++
			wrbyte	:ax,:cvid
			add	:cvid,#bytes_per_col '32
			djnz	:cx,@:loop

			mov	:cx,#8
			mov	:x2,#188 '140

			mov	:bx,lives_ wz
		if_nz	sub	:bx,#1 wz 
					

:next_guy		mov	et_s,#(14 << 4) |s_cannon
			mov	et_x,:x2
			mov	et_y,#138
			mov	et_f,#0

			call	#metrix

			cmp	:cx,:bx wz,wc
		if_a	call	#erase 'wz,wc
		if_be	call	#plot 'wz,wc


:ok			sub	:x2,#24
			djnz	:cx,@:next_guy

			jmp	#next_coglet


:s			long	0
:x			long	0
:x2			long	0
:y			long	0


':lives_left		long	(cols * 17)+64 +1
:lives_left		long	(cols * 17)+128 +1

:cvid			long	0
:_chars			long	@chars
:ax			long	0
:bx			long	0
:cx			long	0

ul_end			long	$cececece
'*********************************************************************
			org

_g_update_scores
			testb	game_flags,#score_changed wz
		if_z	jmp	#next_coglet

			clrb	game_flags,#score_changed

			cmp	score_,hi_score_ wz,wc
		if_a	mov	hi_score_,score_
		if_a	setb	game_flags,#new_hs
		if_a	setb	game_flags,#new_hi_score

			mov	score1,_video
			add	score1,window
			mov	score2,_video
			add	score2,window
			add	score1,#7 '6
			add	score2,#27 '28


			mov	us_dx,us_1000
			mov	us_vid,score1
			mov	us_cx,#4
			mov	us_bx,score_
			call	#display

			testb	game_flags,#new_hi_score wz
		if_z	jmp	#next_coglet

			clrb	game_flags,#new_hi_score
			mov	us_dx,us_1000
			mov	us_vid,score2
			mov	us_cx,#4
			mov	us_bx,hi_score_
			call	#display
			jmp	#next_coglet

display			div32u	us_bx,us_dx
		'	setdiva	us_bx
		'	setdiva	#0
		'	setdivb	us_dx
			getdivq	us_ax
			add	us_ax,#"0"
			call	#pchar
			getdivr	us_bx
			div32u	us_dx,#10
		'	setdiva	us_dx
		'	setdiva	#0
		'	setdivb	#10
			getdivq	us_dx
			djnz	us_cx,@display
display_ret		ret

pchar			and	us_ax,#$3f
			shl	us_ax,#3
			add	us_ax,us_chars
			setptrb	us_ax
			mov	us_ex,#8
:pchar_loop		rdbytec	us_ax,ptrb++
			wrbyte	us_ax,us_vid
			add	us_vid,#bytes_per_col '64 '32
			djnz	us_ex,@:pchar_loop
'			sub	us_vid,#(8*32)-1
			sub	us_vid,_adjx5 '#(8*bytes_per_col)-1
pchar_ret		ret	

_adjx5			long	(8*bytes_per_col)-1
score1			long	0 '@video + 6
score2			long	0 '@video + 27
us_vid			long	0
us_chars		long	@chars
us_ax			long	0
us_bx			long	0
us_cx			long	0
us_dx			long	0
us_ex			long	0
us_1000			long	1_000

usc_end			long	$cececece
'*********************************************************************
			org

_g_game_status		testb	game_flags,#demo_abort wz
		if_z	jmp	#:gs2

			getcnt	:ax
			add	:ax,:demo_abort_delay
			passcnt	:ax
			clrb	game_flags,#demo_mode
			mov	lives_,#start_lives
			mov	score_,#0
			mov	level_,#0
			mov	pc,:_game_restart
			jmp	#coglet_ret

:demo_abort_delay	long	_xinfreq

:gs2			mov	:ax,score_

			mov	:bx,#0
:loop			sub	:ax,:threshold wz,wc
		if_nc	add	:bx,#1
		if_nc	jmp	#:loop
			
			cmp	:bx,last_score_ wz,wc
		if_e	jmp	#:test2
			mov	last_score_,:bx
			add	lives_,#1
			max	lives_,#9
			setb	game_flags,#show_lives

		'	mov	sound_ptr,_extra
		'	setb	sys_flags,#sound

			mov	ch1_ptr,_extra
			setb	sys_flags,#ch1


:test2			cmp	alien_count_,#0 wz
		if_nz	jmp	#next_coglet


			mov	entity,#e_bomb
			call	#get_metrics
			call	#erase

			mov	entity,#e_bomb2
			call	#get_metrics
			call	#erase

			add	level_,#1
			mov	pc,nl
			jmp	#coglet_ret

:ax			long	0
:bx			long	0
:threshold		long	extra_life
:_game_restart		long	@game_restart

nl			long	@game_entry
_extra			long	@extra_sound

gs_end			long	$cececece

'*********************************************************************
			org

_g_elapsed		add	pc,#1
			rdbyte	:ax,pc
			mul32	:ax,:_100ms
		'	setmula	:ax
		'	setmulb	:_100ms
			getmull	elapsed_
			mov	loop_pc,pc
			add	loop_pc,#1
			jmp	#next_coglet

:ax			long	0
:_100ms			long	tps / 10

_elap_end		long	$cececece
'*********************************************************************
			org

_g_elapsed_loop		jz	elapsed_,@next_coglet
			mov	pc,loop_pc
			jmp	#coglet_ret


_el_end			long	$cececece
'*********************************************************************
			org

_g_restart		jz	lives_,@next_coglet
			mov	cannon_ticks,#0
			mov	pc,:main
			jmp	#coglet_ret

:main			long	@main
_gr_end			long	$cececece
'*********************************************************************
			org

_demo_start		getcnt	:ax
			add	:ax,:bx

:loop			cmpcnt	:ax wc
		if_c	jmp	#:start_demo

			getp	fire_ wz
		if_nz	jmp	#:loop

			clrb	game_flags,#demo_mode
			jmp	#next_coglet

:start_demo		setb	game_flags,#demo_mode
			jmp	#next_coglet

:ax			long	0
:bx			long	_xinfreq * 20
dm_end			long	$cececece

'*********************************************************************
			org

_g_show_id		mov	cog_vid,_video
			add	cog_vid,window
			add	cog_vid,:_cogp
			setptra	:msg15_
			call	#cog_print


			mov	:cvid,_video
			add	:cvid,window
			add	:cvid,:_cogid

			cogid	:ax
			add	:ax,#"0"
			shl	:ax,#3
			add	:ax,:_chars
			setptrb	:ax
			mov	:cx,#8
:loop			rdbytec	:ax,ptrb++
			wrbyte	:ax,:cvid
			add	:cvid,#bytes_per_col  '64 '32
			djnz	:cx,@:loop

			jmp	#next_coglet


:cvid			long	0

:_cogid			long	(cols*17)+(bytes_per_col*2)+30
:_cogp			long	(cols*17)+(bytes_per_col*2)+26

:ax			long	0
:_chars			long	@chars
:cx			long	0
:msg15_			long	@msg15


cog_print		rdbytec	ax,ptra++ wz
cog_print_ret	if_z	ret	
			and	ax,#$3f
			shl	ax,#3
			add	ax,cog_chars
			setptrb	ax
			mov	cx,#8
:loop2			rdbytec	ax,ptrb++
			wrbyte	ax,cog_vid
			add	cog_vid,#bytes_per_col '64 '32
			djnz	cx,@:loop2
'			sub	cog_vid,#255  '(8*32)-1
			sub	cog_vid,_adjx6  '#(8*bytes_per_col)-1  '511  '(8*64)-1
			jmp	#cog_print

_adjx6			long	(8*bytes_per_col)-1
cog_chars		long	@chars
cog_vid			long	0

id_end			long	$cececece
'*********************************************************************
			org

demo_status		testb	game_flags,#demo_mode wz
		if_z	jmp	#next_coglet

			mov	ds_vid,_video
			add	ds_vid,window
			add	ds_vid,_ds1
			setptra	_msg16
			call	#ds_print

			mov	ds_vid,_video
			add	ds_vid,window
			add	ds_vid,_ds2
			setptra	_msg17
			call	#ds_print

			jmp	#next_coglet

ds_vid			long	0

_ds1			long	(cols * 1) + 11
_ds2			long	(cols * 13) + 3

ds_print		rdbytec	ax,ptra++ wz
ds_print_ret	if_z	ret	
			and	ax,#$3f
			shl	ax,#3
			add	ax,ds_chars
			setptrb	ax
			mov	cx,#8
:loop2			rdbytec	ax,ptrb++
			wrbyte	ax,ds_vid
			add	ds_vid,#bytes_per_col  '64 '32
			djnz	cx,@:loop2
'			sub	ds_vid,#255  '(8*32)-1
			sub	ds_vid,_adjx7  '#(8*bytes_per_col)-1 '511  '(8*64)-1
			jmp	#ds_print

_adjx7			long	(8*bytes_per_col)-1
ds_chars		long	@chars
_msg16			long	@msg16
_msg17			long	@msg17

demo_s_end			long	$cececece

'*********************************************************************
			org

bombs_away2		testb	game_flags,#halt wz
		if_nz	jmp	#next_coglet

			testb	game_flags,#bomb_active2 wz
		if_nz	jmp	#:check_bomb

			testb	game_flags,#game_over wz
		if_nz	jmp	#next_coglet

			testb	game_flags,#no_bombs wz
		if_nz	jmp	#next_coglet

			mov	:ax,level_
			shl	:ax,#3
			add	:ax,:ls
			rdlong	:_release,:ax
			add	:ax,#4
'			rdlong	:_bomb_speed,:ax

			mov	:ax,release_timer2_
			subcnt	:ax
			cmp	:ax,:_release wz,wc
		if_b	jmp	#next_coglet

			jnz	hold_fire_,@next_coglet

'scan columns for active aliens

			mov	col_enables_,#0

			mov	:ax,#alien_rows

:loop2			mov	:bx,#alien_cols
			mov	:cx,#1
			shl	:cx,#alien_cols-1

:loop			setptry	:alien
		'	popbr	:dx
			rdaux	:dx,ptry++
			testb	:dx,#31 wz
		if_nz	or	col_enables_,:cx
			shr	:cx,#1
			add	:alien,#1
			djnz	:bx,@:loop
			djnz	:ax,@:loop2

			jz	col_enables_,@next_coglet

'pick random active column

:loop3			getlfsr	:ax
			and	:ax,#$f
			cmp	:ax,#alien_cols wz,wc
		if_ae	jmp	#:loop3

			mov	:ec,#1
			shl	:ec,#alien_cols-1
			shr	:ec,:ax
			test	col_enables_,:ec wz
		if_z	jmp	#:loop3

			mov	entity,#e_alien0
			add	entity,#alien_cols * (alien_rows-1)
			add	entity,:ax

'find lowest alien in column

:loop4			call	#get_metrics
			testb	et_f,#7 wz
		if_z	sub	entity,#alien_cols
		if_z	jmp	#:loop4

			mov	bomb_owner_,entity
			sub	bomb_owner_,#e_alien0

			getlfsr	:bx
			and	:bx,#7
			add	:bx,#2

			getlfsr	:ax
			isob	:ax,#6

			setbyte	:dx,:ax,#3
			setbyte	:dx,#1 << 4 | s_bomb_a,#2
			mov	:ax,et_x
			add	:ax,:bx
			setbyte	:dx,:ax,#1
			mov	:ax,et_y
			add	:ax,#10
			setbyte	:dx,:ax,#0
			wraux	:dx,#e_bomb2

		'	setptry	#e_bomb2
		'	setf	#%0_01_00_00_00
		'	movf	:dx,:ax
		'	movf	:dx,#1 << 4 | s_bomb_a
		'	mov	:ax,et_x
		'	add	:ax,:bx
		'	movf	:dx,:ax
		'	mov	:ax,et_y
		'	add	:ax,#10
		'	movf	:dx,:ax
		'	pushy	:dx
		
			setb	game_flags,#bomb_active2
			jmp	#next_coglet

'time to move existing bomb?

:check_bomb		cmp	bomb_ticks2,:_bomb_speed2 wz,wc
		if_b	jmp	#next_coglet
			mov	bomb_ticks2,#0
		
'move bomb
			mov	entity,#e_cannon
			call	#get_metrics
			mov	c_x,et_x

			mov	entity,#e_bomb2
			call	#get_metrics
			mov	b_x,et_x
			call	#erase

			mov	:dx,#0
			rdaux	:ax,#e_bomb2
		'	setptry	#e_bomb2
		'	popbr	:ax
		'	setf	#%0_00_00_00_00
			getbyte	:dx,:ax,#0
		'	movf	:dx,:ax
			add	:dx,#1			
			cmp	:dx,#cannon_y-5 wz,wc
		if_ae	jmp	#:chk_cannon


:chk2			setbyte	:ax,:dx,#0
			notb	:ax,#30		
			wraux	:ax,#e_bomb2
		'	movf	:ax,:dx
		'	notb	:ax,#30		
		'	pushyr	:ax

			jmp	#:no_cannon

:chk_cannon		cmp	b_x,c_x wz,wc
		if_b	jmp	#:hit_bottom
			add	c_x,#15
			cmp	b_x,c_x wz,wc
		if_b	jmp	#:hit_cannon

:hit_bottom		clrb 	game_flags,#bomb_active2
			jmp	#:tmx

:hit_cannon		setb	game_flags,#killed
			clrb	game_flags,#bomb_active2
			jmp	#next_coglet

:no_cannon		clrb	game_flags,#bullseye
			call	#get_metrics
			call	#overlay

			testb	game_flags,#bullseye wz
		if_nz	jmp	#:hitz
			call	#get_metrics
			call	#plot
			jmp	#next_coglet

'bomb hit something  

:hitz			mov	y_hit_,hit_address
			sub	y_hit_,_video
			sub	y_hit_,window
			mov	x_hit_,y_hit_
			shr	y_hit_,#5
			and	x_hit_,#$1f
			shl	x_hit_,#3

			mov	:ax,#b0
			add	:ax,byte_ofst
			sets	:fred,:ax
			mov	:cx,#8
			mov	:dx,#$80
			nop
			nop
:fred			mov	:ax,0
			test	:ax,:dx wz
		if_nz	or	:ex,:dx
			shr	:dx,#1
			djnz	:cx,@:fred

:hitz2			not	:ex
			rdbyte	:ax,hit_address
			and	:ax,:ex
		'	wrbyte	:ax,hit_address
			wrbyte	zero,hit_address
			add	hit_address,#bytes_per_col '32
			getlfsr	:bx
			rdbyte	:ax,hit_address
			and	:ax,:bx
			wrbyte	:ax,hit_address

			clrb	game_flags,#bomb_active2
:tmx			getcnt	release_timer2_
			add	release_timer2_,:rt_offset
			jmp	#next_coglet

:ls			long	@level_settings

:_release		long	120 * ms

:_bomb_speed2		long	bomb_speed2
:ec			long	0 '|< alien_cols-1
:ax			long	0
:bx			long	0
:cx			long	0
:dx			long	0
:ex			long	0
:count			long	total_aliens
:alien			long	e_alien0

:rt_offset		long	333 * ms

c_x2			long	0
b_x2			long	0
_ff2			long	$ff
ba_end2			long	$cececece
{
'*********************************************************************

			org

_g_id_window		add	pc,#1
			rdbyte	:ax4,pc

			mov	:fx4,:loc
			isob	:ax4,#0 wz,nr
		if_nz	add	:fx4,#28
			isob	:ax4,#1 wz,nr
		if_nz	add	:fx4,:loc2

			mov	:gx4,:ax4
			add	:gx4,#"0"
			and	:gx4,#$3f
			shl	:gx4,#3
			add	:gx4,:charst

			mov	:dx4,#8
:loop2			rdbyte	:ax4,:gx4
			add	:gx4,#1
			mov	:bx4,#8
:loopk			testb	:ax4,#7 wz
			shl	:hx,#4
			shl	:ax4,#1
		if_nz	or	:hx,#%1111
		if_z	andn	:hx,#%1111
			djnz	:bx4,@:loopk

			setf	#%0_11_11_10_00
			movf	:cx4,:hx
			movf	:cx4,:hx
			movf	:cx4,:hx
			movf	:cx4,:hx


			wrlong	:cx4,:fx4
			add	:fx4,:adj
			wrlong	:cx4,:fx4
			add	:fx4,:adj

			wrlong	:cx4,:fx4
			add	:fx4,:adj
		'	wrlong	:cx4,:fx4
		'	add	:fx4,:adj

			djnz	:dx4,@:loop2

			jmp	#next_coglet

:loc			long	@video1 + ((cols/8) * 50) + 16
:loc2			long	150 * (cols/8)

':loc			long	@video1 + ((cols/8) * 200) + 16

:charst			long	@chars
	
:ax4			long	0
:bx4			long	0
:cx4			long	0
:dx4			long	0
:fx4			long	0
:gx4			long	0
:hx			long	0

:adj			long	cols/8

idw_end			long	$cececece
}
'*********************************************************************

			org

freeze			jmp	#freeze

frz_end			long	$cececece
'*********************************************************************
			org

start_sound		mov	ch1_ptr,ufo_dead_sound
			setb	sys_flags,#ch1
			jmp	#next_coglet

ufo_dead_sound		long	@ufo_killed

strt_end		long	$cececece
'*********************************************************************

'Coglet pointers

			orgh

coglet_table		long	((@cls_end-@clearscreen)/4) << 24 + @clearscreen 
			long	((@ei_end-@entity_init)/4)<< 24 + @entity_init 
			long	((@idle_end-@idle)/4)<<24+@idle
			long	(( @pause_end-@pause_x100ms )/4) << 24 + @pause_x100ms 
			long	((@rpt_end-@_g_repeat)/4)<<24 +@_g_repeat
			long	((@loop_end - @_g_loop)/4)<< 24 +@_g_loop
			long	((@for_end - @_g_for)/4)<< 24 +@_g_for
			long	((@next_end-@_g_next)/4)<<24+@_g_next
			long	((@msg_end-@message )/4) << 24 + @message 
			long	((@wait4fire_end-@_g_wait4fire)/4)<<24+@_g_wait4fire
			long	((@back_end-@_g_back)/4)<<24+@_g_back
			long	((@plot_e_end-@_g_plot_e)/4)<<24+@_g_plot_e
			long	((@ce2_end-@check_edge)/4)<<24+@check_edge 
			long	((@daa_end-@draw_all_aliens)/4)<<24+@draw_all_aliens 
			long	((@ds_end-@draw_shields)/4)<<24+@draw_shields  
			long	((@ng_end-@new_game)/4)<<24+@new_game  
			long	((@ms_end-@move_saucer)/4)<<24+@move_saucer
			long	((@mc_end-@move_cannon)/4)<<24+@move_cannon
			long	((@mm_end-@move_missile)/4)<<24+@move_missile 
			long	((@ma_end-@move_aliens)/4)<<24+@move_aliens  
			long	((@wait4left_end-@_g_wait4left)/4)<<24+@_g_wait4left
			long	((@mv_end-@match_victim)/4)<<24+@match_victim 
			long	((@ps_end-@_g_plot_s)/4)<<24+@_g_plot_s
			long	((@ls_end-@load_sprites)/4)<<24+@load_sprites
			long	((@ba_end-@bombs_away)/4)<<24+@bombs_away
			long	((@blast_end-@blast)/4)<<24+@blast
			long	((@ge_end-@game_end)/4)<<24+@game_end
			long	((@send_end-@send)/4)<<24+@send
			long	((@comms_end-@comms)/4)<<24+@comms
			long	((@alive_end-@_g_alive)/4)<<24+@_g_alive
			long	((@goto_end-@goto)/4)<<24+@goto
			long	((@vap_end-@_g_vaporize)/4)<<24+@_g_vaporize
			long	((@nc_end-@_g_new_cannon)/4)<<24 + @_g_new_cannon
			long	((@ul_end-@update_lives)/4)<<24+@update_lives
			long	((@usc_end-@_g_update_scores)/4)<<24+@_g_update_scores
			long	((@ai_end-@_g_alien_init)/4)<<24+@_g_alien_init
			long	((@gs_end-@_g_game_status)/4)<<24 + @_g_game_status
			long	((@_elap_end-@_g_elapsed)/4)<<24+@_g_elapsed
			long	((@_el_end-@_g_elapsed_loop)/4)<<24+@_g_elapsed_loop
			long	((@_gr_end-@_g_restart)/4)<<24+@_g_restart
			long	((@dm_end-@_demo_start)/4)<<24+@_demo_start
			long	((@id_end-@_g_show_id)/4)<<24+@_g_show_id
			long	((@demo_s_end-@demo_status)/4)<<24+@demo_status
			long	((@ba_end2-@bombs_away2)/4)<<24+@bombs_away2
		'	long	((@idw_end-@_g_id_window)/4)<<24+@_g_id_window
			long	((@frz_end-@freeze)/4)<<24+@freeze
			long	((@strt_end-@start_sound)/4)<<24+@start_sound
			
mon			long	((@mon_end-@monitor)/4)<<24+@monitor

messages		long	@msg1
			long	@msg2
			long	@msg3                         
			long	@msg4
			long	@msg5
			long	@msg6
			long	@msg7
			long	@msg8
			long	@msg9
			long	@msg10
			long	@msg11
			long	@msg12
			long	@msg13
			long	@msg14
			long	@msg15
			long	@msg16
			long	@msg17
			long	@msg18
			long	@msg19

level_settings		long	400 * ms,240   'release time,bomb speed
			long	300 * ms,230
			long	200 * ms,220
			long	100 * ms,210
			long	50 * ms,200

colors			long	%000_100_000<<18 + %000_000_000<<9[19]

'blue color scheme
		        		      
pallette1		long	%000_110_000<<18 + %000_000_011<<9  'scores
			long	%111_000_000<<18 + %000_000_011<<9  'saucer
			long	%110_110_110<<18 + %000_000_011<<9  
			long	%110_110_110<<18 + %000_000_011<<9
			long	%110_110_110<<18 + %000_000_011<<9
			long	%110_110_110<<18 + %000_000_100<<9
			long	%110_110_110<<18 + %000_000_100<<9
			long	%110_110_110<<18 + %000_000_100<<9
			long	%110_110_110<<18 + %000_000_100<<9
			long	%110_110_110<<18 + %000_000_101<<9
			long	%110_110_110<<18 + %000_000_101<<9
			long	%110_110_110<<18 + %000_000_101<<9
			long	%111_111_111<<18 + %000_000_101<<9 
			long	%000_111_000<<18 + %000_000_110<<9 
			long	%000_111_000<<18 + %000_000_110<<9 'shield
			long	%111_111_000<<18 + %000_000_110<<9  'cannon
			long	%111_111_111<<18 + %000_000_110<<9  'line
			long	%111_111_000<<18 + %000_000_011<<9  'gog=
			long	%111_111_000<<18 + %000_000_010<<9  

'red color scheme

pallette2		long	%000_110_000<<18 + %011_000_000<<9  'scores
			long	%111_000_000<<18 + %011_000_000<<9  'saucer
			long	%110_110_110<<18 + %011_000_000<<9  
			long	%110_110_110<<18 + %011_000_000<<9
			long	%110_110_110<<18 + %011_000_000<<9
			long	%110_110_110<<18 + %100_000_000<<9
			long	%110_110_110<<18 + %100_000_000<<9
			long	%110_110_110<<18 + %100_000_000<<9
			long	%110_110_110<<18 + %100_000_000<<9
			long	%110_110_110<<18 + %101_000_000<<9
			long	%110_110_110<<18 + %101_000_000<<9
			long	%110_110_110<<18 + %101_000_000<<9
			long	%111_111_111<<18 + %101_000_000<<9 
			long	%000_111_000<<18 + %110_000_000<<9 
			long	%000_111_000<<18 + %110_000_000<<9 'shield
			long	%111_111_000<<18 + %110_000_000<<9  'cannon
			long	%111_111_111<<18 + %110_000_000<<9  'line
			long	%111_111_000<<18 + %011_000_000<<9  'gog=
			long	%111_111_000<<18 + %010_000_000<<9  

'magenta color scheme

pallette3		long	%000_110_000<<18 + %011_000_011<<9  'scores
			long	%111_000_000<<18 + %011_000_011<<9  'saucer
			long	%110_110_110<<18 + %011_000_011<<9  
			long	%110_110_110<<18 + %011_000_011<<9
			long	%110_110_110<<18 + %011_000_011<<9
			long	%110_110_110<<18 + %100_000_100<<9
			long	%110_110_110<<18 + %100_000_100<<9
			long	%110_110_110<<18 + %100_000_100<<9
			long	%110_110_110<<18 + %100_000_100<<9
			long	%110_110_110<<18 + %101_000_101<<9
			long	%110_110_110<<18 + %101_000_101<<9
			long	%110_110_110<<18 + %101_000_101<<9
			long	%111_111_111<<18 + %101_000_101<<9 
			long	%000_111_000<<18 + %110_000_110<<9 
			long	%000_111_000<<18 + %110_000_110<<9 'shield
			long	%111_111_000<<18 + %110_000_110<<9  'cannon
			long	%111_111_111<<18 + %110_000_110<<9  'line
			long	%111_111_000<<18 + %011_000_011<<9  'gog=
			long	%111_111_000<<18 + %010_000_010<<9  

'b/w color scheme

pallette4		long	%110_110_110<<18 + %000_000_000<<9  'scores
			long	%110_110_110<<18 + %000_000_000<<9  'saucer
			long	%110_110_110<<18 + %000_000_000<<9  
			long	%110_110_110<<18 + %000_000_000<<9
			long	%110_110_110<<18 + %000_000_000<<9
			long	%110_110_110<<18 + %000_000_000<<9
			long	%110_110_110<<18 + %000_000_000<<9
			long	%110_110_110<<18 + %000_000_000<<9
			long	%110_110_110<<18 + %000_000_000<<9
			long	%110_110_110<<18 + %000_000_000<<9
			long	%110_110_110<<18 + %000_000_000<<9
			long	%110_110_110<<18 + %000_000_000<<9
			long	%110_110_110<<18 + %000_000_000<<9 
			long	%110_110_110<<18 + %000_000_000<<9 
			long	%110_110_110<<18 + %000_000_000<<9 'shield
			long	%110_110_110<<18 + %000_000_000<<9  'cannon
			long	%110_110_110<<18 + %000_000_000<<9  'line
			long	%110_110_110<<18 + %000_000_000<<9  'gog=
			long	%110_110_110<<18 + %000_000_000<<9  



cannon			word	%000000010000000  '       1
			word	%000000111000000  '      111
			word	%000001111100000  '     11111
			word	%001111111111100  '  11111111111
			word	%011111111111110  ' 1111111111111
			word	%111111111111111  '111111111111111
			word	%111111111111111  '111111111111111
			word	%111111111111111  '111111111111111


missile			word	%1  'x
			word	%1  'x 
			word	%1  'x  
			word	%0  ' 
			word	%0  ' 
			word	%0  '
			word	%0  '
			word	%0  '

bomb_a			word	%00  '
			word	%00  '
			word	%01  ' X
			word	%10  'X
			word	%01  ' X
			word	%10  'X
			word	%00  '
			word	%00  '

bomb_b			word	%00  '
			word	%00  '
			word	%10  'x
			word	%01  ' x
			word	%10  'x
			word	%01  ' x
			word	%00  '
			word	%00  '

saucer			word	%0000001111000000  '      XXXX
			word	%0001111111111000  '   XXXXXXXXXX
			word	%0011111111111100  '  XXXXXXXXXXXX
			word	%0110110110110110  ' XX XX XX XX XX
			word	%1111111111111111  'XXXXXXXXXXXXXXXX
			word	%0011100110011100  '  XXX  XX  XXX
			word	%0001000000001000  '   X        X
			word	%0000000000000000  '
	

alien1a			word	%00011000  '   XX
			word	%00111100  '  XXXX
			word	%01111110  ' XXXXXX
			word	%11011011  'XX XX XX
			word	%11111111  'XXXXXXXX
			word	%01011010  ' X XX X
			word	%10000001  'X      X
			word	%01000010  ' X    X
		
alien1b			word	%00011000  '   XX
			word	%00111100  '  XXXX
			word	%01111110  ' XXXXXX
			word	%11011011  'XX XX XX
			word	%11111111  'XXXXXXXX
			word	%00100100  '  X  X
			word	%01011010  ' X XX X
			word	%10100101  'X X  X X

alien2a			word	%00100000100  '  X     X    
			word	%00010001000  '   X   X   
			word	%00111111100  '  XXXXXXX  
			word	%01101110110  ' XX XXX XX
			word	%11111111111  'XXXXXXXXXXX
			word	%10111111101  'X XXXXXXX X
			word	%10100000101  'X X     X X
			word	%00011011000  '   XX XX  

alien2b			word	%00100000100  '  X     X  
			word	%10010001001  'X  X   X  X
			word	%10111111101  'X XXXXXXX X
			word	%11101110111  'XXX XXX XXX
			word	%11111111111  'XXXXXXXXXXX
			word	%01111111110  ' XXXXXXXXX
			word	%00100000100  '  X     X  
			word	%01000000010  ' X       X

alien3a			word	%000011110000  '    XXXX
			word	%011111111110  ' XXXXXXXXXX
			word	%111111111111  'XXXXXXXXXXXX
			word	%111001100111  'XXX  XX  XXX
			word	%111111111111  'XXXXXXXXXXXX
			word	%000110011000  '   XX  XX  
			word	%001101101100  '  XX XX XX
			word	%110000000011  'XX        XX

alien3b			word	%000011110000  '    XXXX
			word	%011111111110  ' XXXXXXXXXX
			word	%111111111111  'XXXXXXXXXXXX
			word	%111001100111  'XXX  XX  XXX
			word	%111111111111  'XXXXXXXXXXXX
			word	%001110011100  '  XXX  XXX
			word	%011001100110  ' XX  XX  XX 
			word	%001100001100  '  XX    XX

shield_left		word	%0001111111111111  '   1111111111111
			word	%0011111111111111  '  11111111111111
			word	%0111111111111111  ' 111111111111111
			word	%1111111111111111  '1111111111111111
			word	%1111111111111111  '1111111111111111
			word	%1111111111100000  '11111111111
			word	%1111111111000000  '1111111111
			word	%1111111110000000  '111111111

shield_right		word	%1111111111111000  '1111111111111
			word	%1111111111111100  '11111111111111
			word	%1111111111111110  '111111111111111
			word	%1111111111111111  '1111111111111111
			word	%1111111111111111  '1111111111111111
			word	%0000011111111111  '     11111111111
			word	%0000001111111111  '      1111111111
			word	%0000000111111111  '       111111111

explosion1		word	%10010001001   '1  1   1  1
			word	%01010001010  ' 1 1   1 1 
			word	%00101010100  '  1 1 1 1  
			word	%11000000011  '11       11
			word	%00100000100  '  1     1   
			word	%01001001010  ' 1  1  1 1  
			word	%10010010101  '1  1  1 1 1 
			word	%00010010010  '   1  1  1


msg1			byte	"P2 INVADERS V2.04",0
msg2			byte	"PROGRAM BY OZPROPDEV 2014",0
msg3			byte	"DE2-115 1P VERSION",0

msg4			byte	"PRESS <FIRE> TO START",0
msg5			byte	" SCORE ????       HI-SCORE ????",0
msg6			byte	" GAME OVER ",0
msg7			byte	" =  30 POINTS",0
msg8			byte	" =  20 POINTS",0
msg9			byte	" =  10 POINTS",0
msg10			byte	" = ??? POINTS",0
msg11			byte	"  0",0
msg12			byte	"   ",0
msg13			byte	"ON 1 COG !",0
msg14			byte	"NEW HI-SCORE!",0
msg15			byte	"COG=",0
msg16			byte	"DEMO MODE",0
msg17			byte	"PRESS ANY KEY TO EXIT DEMO",0
msg18			byte	"WITH SOUND EFFECTS",0
msg19			byte	"PARALLAX PROPELLER P8X32C",0

chars   		byte    $00,$3C,$66,$6E,$6E,$60,$3E,$00
		        byte    $00,$18,$3C,$66,$66,$7E,$66,$00
		        byte    $00,$7C,$66,$7C,$66,$66,$7C,$00
		        byte    $00,$3C,$66,$60,$60,$66,$3C,$00
		        byte    $00,$78,$6C,$66,$66,$6C,$78,$00
		        byte    $00,$7E,$60,$7C,$60,$60,$7E,$00
		        byte    $00,$7E,$60,$7C,$60,$60,$60,$00
		        byte    $00,$3E,$60,$60,$6E,$66,$3E,$00
		        byte    $00,$66,$66,$7E,$66,$66,$66,$00
		        byte    $00,$7E,$18,$18,$18,$18,$7E,$00
		        byte    $00,$06,$06,$06,$06,$66,$3C,$00
		        byte    $00,$66,$6C,$78,$78,$6C,$66,$00
		        byte    $00,$60,$60,$60,$60,$60,$7E,$00
		        byte    $00,$63,$77,$7F,$6B,$63,$63,$00
			byte    $00,$66,$76,$7E,$7E,$6E,$66,$00
		        byte    $00,$3C,$66,$66,$66,$66,$3C,$00
		        byte    $00,$7C,$66,$66,$7C,$60,$60,$00
		        byte    $00,$3C,$66,$66,$66,$6C,$36,$00
		        byte    $00,$7C,$66,$66,$7C,$6C,$66,$00
		        byte    $00,$3C,$60,$3C,$06,$06,$3C,$00
		        byte    $00,$7E,$18,$18,$18,$18,$18,$00
		        byte    $00,$66,$66,$66,$66,$66,$3C,$00
		        byte    $00,$66,$66,$66,$66,$3C,$18,$00
		        byte    $00,$63,$63,$6B,$7F,$77,$63,$00
		        byte    $00,$66,$66,$3C,$3C,$66,$66,$00
		        byte    $00,$66,$66,$3C,$18,$18,$18,$00
		        byte    $00,$7E,$0C,$18,$30,$60,$7E,$00
		        byte    $00,$1E,$18,$18,$18,$18,$1E,$00
		        byte    $00,$40,$60,$30,$18,$0C,$06,$00
		        byte    $00,$78,$18,$18,$18,$18,$78,$00
		        byte    $00,$08,$1C,$36,$63,$00,$00,$00
		        byte    $00,$00,$00,$00,$00,$00,$7E,$00
		        byte    $00,$00,$00,$00,$00,$00,$00,$00
		        byte    $00,$18,$18,$18,$18,$00,$18,$00
		        byte    $00,$66,$66,$66,$00,$00,$00,$00
		        byte    $00,$66,$FF,$66,$66,$FF,$66,$00
		        byte    $18,$3E,$60,$3C,$06,$7C,$18,$00
		        byte    $00,$66,$6C,$18,$30,$66,$46,$00
		        byte    $1C,$36,$1C,$38,$6F,$66,$3B,$00
		        byte    $00,$18,$18,$18,$00,$00,$00,$00
		        byte    $00,$0E,$1C,$18,$18,$1C,$0E,$00
		        byte    $00,$70,$38,$18,$18,$38,$70,$00
		        byte    $00,$66,$3C,$FF,$3C,$66,$00,$00
		        byte    $00,$18,$18,$7E,$18,$18,$00,$00
		        byte    $00,$00,$00,$00,$00,$18,$18,$30
		        byte    $00,$00,$00,$7E,$00,$00,$00,$00
		        byte    $00,$00,$00,$00,$00,$18,$18,$00
		        byte    $00,$06,$0C,$18,$30,$60,$40,$00
		        byte    $00,$3C,$66,$6E,$76,$66,$3C,$00
		        byte    $00,$18,$38,$18,$18,$18,$7E,$00
		        byte    $00,$3C,$66,$0C,$18,$30,$7E,$00
		        byte    $00,$7E,$0C,$18,$0C,$66,$3C,$00
		        byte    $00,$0C,$1C,$3C,$6C,$7E,$0C,$00
		        byte    $00,$7E,$60,$7C,$06,$66,$3C,$00
		        byte    $00,$3C,$60,$7C,$66,$66,$3C,$00
		        byte    $00,$7E,$06,$0C,$18,$30,$30,$00
		        byte    $00,$3C,$66,$3C,$66,$66,$3C,$00
		        byte    $00,$3C,$66,$3E,$06,$0C,$38,$00
		        byte    $00,$00,$18,$18,$00,$18,$18,$00
		        byte    $00,$00,$18,$18,$00,$18,$30,$00
		        byte    $06,$0C,$18,$30,$18,$0C,$06,$00
		        byte    $00,$00,$7E,$00,$00,$7E,$00,$00
		        byte    $60,$30,$18,$0C,$18,$30,$60,$00
		        byte    $00,$3C,$66,$0C,$18,$00,$18,$00


string_buffer		byte	0[64]

packet_buffer		byte	14,1,15,1,"Alien count = "
ac			byte	"--"
			byte	2,1,2,"Alien speed = "
as			byte	"----"
			byte	2,1,3,"Score = "
scr			byte	"----"
			byte	2,1,5,"Saucer ticks ="
st			byte	"------"
			byte	2,1,6,"Saucer value = "
sv			byte	"---"
			byte	2,1,8,"Hit X = "
hitx			byte	"--- Y = "
hity			byte	"--- Offset ="
hito			byte	"--"
			byte	2,1,10,"Rel. Timer = "
rt			byte	"----------"
			byte	2,8,11,"CNT = "
cntr			byte	"----------"
			byte	2,1,13,"Cannon X ="
canx			byte	"---"
			byte	2,1,14,"Bomb x   ="
bmbx			byte	"---"
			byte	2,1,15,"RX byte = "
rxb			byte	"--- :"
rx_buffer		byte	" "[32]
			byte	2,40,1,"Bomb owner = "
ona			byte	"--"
			byte	2,40,2,"Col. Enables = "
bmsk			byte	"00000000000"
			byte	2,40,4,"Lives = "
lve			byte	"-"
			byte	2,40,5,"Level = "
lvl			byte	"-"
			byte	2,40,7,"Gamme loops/sec = "
stream			byte	"??????"

			byte	0

'alien load patterns

pattern_index		byte	2

'-----------------------------------------------------------------------------------

load_b2t		byte	44,45,46,47,48,49,50,51,52,53,54
			byte	33,34,35,36,37,38,39,40,41,42,43
			byte	22,23,24,25,26,27,28,29,30,31,32
			byte	11,12,13,14,15,16,17,18,19,20,21
			byte	0,1,2,3,4,5,6,7,8,9,10

spiral_load		byte	0,1,2,3,4,5,6,7,8,9,10
			byte	21,32,43
			byte	54,53,52,51,50,49,48,47,46,45,44
			byte	33,22,11
			byte	12,13,14,15,16,17,18,19,20
			byte	31,42
			byte	41,40,39,38,37,36,35,34
			byte	23,24,25,26,27,28,29,30

zig_zag			byte	0,1,2,3,4,5,6,7,8,9,10
			byte	21,20,19,18,17,16,15,14,13,12,11
			byte	22,23,24,25,26,27,28,29,30,31,32
			byte	43,42,41,40,39,38,37,36,35,34,33
			byte	44,45,46,47,48,49,50,51,52,53,54

zig_zag2		byte	0,11,22,33,44
			byte	45,34,23,12,1
			byte	2,13,24,35,46
			byte	47,36,25,14,3
			byte	4,15,26,37,48
			byte	49,38,27,16,5
			byte	6,17,28,39,50
			byte	51,40,29,18,7
			byte	8,19,30,41,52
			byte	53,42,31,20,9
			byte	10,21,32,43,54

sfx_index		byte	0

'====================================================================
'Bytcode game program


			

game_start		byte	g_entity_init
			byte	g_load_sprites

game_restart		byte	g_cls
			byte	g_show_id
			byte	g_message,0,7,3   'prop-2 invaders
			byte	g_message,2,7,5  'version
			byte	g_message,12,11,7 'on 1 cog
			byte	g_message,17,7,9   'with sound effects
			byte	g_message,1,3,11  'program by..
			byte	g_message,3,5,13   'press any key
			byte	g_message,18,3,1   'p8x32c
			byte	g_plot_s,s_alien2a,16,24
			byte	g_plot_s,s_alien3a,200,24
			byte	g_start_sound

'score details		
			byte	g_demo_start
			byte	g_cls
			byte	g_show_id
			byte	g_demo_status
			byte	g_message,6,11,4
			byte	g_message,7,11,6
			byte	g_message,8,11,8
			byte	g_message,9,11,10
			byte	g_plot_s,s_alien1a,48,32
			byte	g_plot_s,s_alien2a,48,48
			byte	g_plot_s,s_alien3a,48,64
			byte	g_plot_s,s_saucer,48,80
			byte	g_tx_byte,16

			byte	g_elapsed,50
			byte	g_comms
			byte	g_elapsed_loop
			byte	g_new_game
			byte	g_goto,@begin-@game_start

game_entry		byte	g_elapsed,50
			byte	g_saucer
			byte	g_missile
			byte	g_id_victim
			byte	g_blast
			byte	g_update_scores
			byte	g_comms
			byte	g_elapsed_loop
			byte	g_new_game

begin			byte	g_cls
			byte	g_show_id
			byte	g_message,4,0,0
			byte	g_alien_init
			byte	g_update_scores
			byte	g_plot_e,e_cannon
			byte	g_plot_shields
			byte	g_plot_all_aliens
			byte	g_update_lives
			byte	g_elapsed,20
			byte	g_comms
			byte	g_elapsed_loop

'Main game loop

main			byte	g_comms
main2			byte	g_cannon
			byte	g_saucer
			byte	g_missile
			byte	g_id_victim
			byte	g_blast
			byte	g_update_scores
			byte	g_aliens
			byte	g_check_edge
			byte	g_move_bomb
			byte	g_move_bomb2
			byte	g_update_lives
			byte	g_game_status
			byte	g_alive_loop

'player killed

			byte	g_elapsed,10
			byte	g_vaporize
			byte	g_saucer
			byte	g_missile
			byte	g_id_victim
			byte	g_blast
			byte	g_update_scores
			byte	g_comms
			byte	g_elapsed_loop
'adjust lives
			byte	g_new_cannon
			byte	g_update_lives
			byte	g_elapsed,20
			byte	g_saucer
			byte	g_comms
			byte	g_elapsed_loop
			byte	g_restart
'game over 
			byte	g_game_over
   			byte	g_elapsed,70
			byte	g_saucer
			byte	g_comms
			byte	g_elapsed_loop
			byte	g_goto,@game_restart-@game_start
	

'=================================================================
'Video buffer

video1			long	$10101010[(cols / 32) * rows]


alien_killed_sound	byte	$86,$6A,$D1,$6C,$73,$58,$E9,$39,$B6,$48,$D8,$25,$7A,$44,$8C,$74
			byte	$7C,$86,$8A,$63,$7C,$84,$DE,$52,$5A,$72,$59,$BC,$B7,$50,$04,$A6
			byte	$EF,$F7,$00,$00,$05,$FF,$FF,$B0,$00,$1A,$8F,$FF,$B2,$00,$03,$AF
			byte	$FF,$FF,$30,$03,$28,$DF,$FF,$93,$00,$08,$CD,$EF,$FD,$00,$01,$18
			byte	$FF,$FF,$90,$00,$44,$4A,$FF,$E8,$30,$00,$64,$7D,$FF,$94,$00,$00
			byte	$89,$DF,$FF,$50,$00,$05,$DE,$EF,$FF,$70,$04,$32,$7D,$FF,$FD,$70
			byte	$00,$78,$6B,$FF,$F8,$40,$00,$66,$6B,$FF,$FB,$70,$00,$27,$7D,$FF
			byte	$FE,$63,$00,$18,$DA,$CF,$FF,$C1,$00,$02,$9C,$BD,$FF,$94,$10,$00
			byte	$78,$7F,$FF,$ED,$70,$00,$25,$7C,$FF,$FF,$F8,$00,$11,$27,$BF,$FF
			byte	$FE,$20,$00,$32,$38,$FF,$FF,$FE,$20,$00,$16,$AE,$EE,$FF,$F8,$00
			byte	$00,$06,$CC,$AF,$FF,$C3,$00,$00,$09,$EC,$BF,$FF,$E8,$20,$00,$17
			byte	$DA,$AE,$FF,$D8,$30,$00,$05,$79,$BF,$FF,$EE,$D5,$00,$01,$38,$CC
			byte	$BE,$FE,$D8,$40,$00,$05,$7B,$EC,$DF,$FF,$C2,$00,$00,$56,$7A,$DE
			byte	$DF,$FE,$93,$10,$02,$67,$8C,$DC,$DF,$FB,$85,$10,$00,$44,$9C,$FD
			byte	$CE,$FF,$D9,$20,$00,$16,$68,$AC,$DD,$EF,$FC,$72,$00,$01,$78,$8A
			byte	$BE,$FD,$EF,$D9,$30,$00,$04,$9B,$AA,$AD,$FD,$DF,$C7,$30,$00,$00
			byte	$4A,$AB,$CD,$CC,$DF,$B8,$63,$00,$00,$34,$AC,$DA,$AB,$FE,$CC,$C6
			byte	$10,$00,$01,$5A,$AA,$BD,$BA,$CD,$FA,$97,$40,$00,$01,$39,$CD,$B9
			byte	$BC,$CB,$CD,$A8,$53,$00,$00,$36,$9B,$DC,$AA,$BC,$BC,$DA,$98,$53
			byte	$00,$04,$56,$9C,$CB,$AB,$A9,$BB,$DC,$A9,$86,$00,$00,$14,$7A,$CB
			byte	$BC,$A9,$9B,$CC,$AB,$98,$63,$20,$00,$16,$79,$BC,$BA,$AB,$A9,$BC
			byte	$BA,$AA,$A8,$51,$10,$01,$37,$89,$BC,$BA,$99,$A9,$8A,$BA,$9A,$A8
			byte	$65,$31,$01,$33,$58,$AB,$AB,$BA,$99,$A9,$89,$AA,$99,$99,$86,$64
			byte	$10,$13,$45,$69,$AB,$BA,$AA,$A8,$89,$98,$8B,$AA,$99,$99,$86,$32
			byte	$20,$12,$45,$67,$BB,$BA,$AB,$A9,$99,$87,$88,$99,$9A,$A9,$88,$87
			byte	$65,$42,$12,$33,$45,$79,$9A,$AB,$AA,$99,$98,$88,$88,$88,$98,$89
			byte	$AA,$98,$88,$77,$77,$54,$23,$33,$45,$66,$78,$AA,$AB,$BA,$A9,$99
			byte	$88,$88,$88,$88,$88,$88,$88,$99,$98,$88,$87,$67,$77,$52,$00,$36
			byte	$8A,$CF,$FA,$53,$6D,$D5,$44,$7E,$C4,$47,$EC,$44,$47,$F4,$44,$7F
			byte	$C4,$43,$FD,$43,$36,$FD,$53,$6E,$E5,$33,$5D,$E6,$35,$CF,$73,$34
			byte	$BF,$33,$3A,$FA,$33,$3F,$B3,$33,$7F,$D4,$36,$EF,$62,$34,$CF,$83
			byte	$3A,$FB,$33,$37,$F4,$23,$6E,$F6,$23,$BF,$92,$33,$8F,$C3,$36,$FF
			byte	$52,$34,$BF,$23,$38,$FD,$42,$35,$F7,$23,$3A,$FB,$33,$6F,$F5,$23
			byte	$4B,$F3,$23,$7F,$E5,$23,$4F,$A2,$33,$6F,$F5,$24,$BF,$B3,$23,$6E
			byte	$62,$34,$9F,$C3,$23,$CF,$82,$33,$7F,$F5,$34,$AF,$B3,$23,$5D,$82
			byte	$33,$7F,$F5,$24,$9F,$C3,$23,$5B,$F2,$23,$6D,$F7,$23,$3F,$F5,$23
			byte	$49,$FD,$43,$4A,$FC,$32,$35,$FB,$32,$35,$CF,$92,$36,$DF,$82,$33
			byte	$7E,$72,$34,$7E,$F7,$23,$7E,$F7,$23,$47,$E7,$23,$47,$EF,$82,$27
			byte	$DF,$82,$33,$6C,$F3,$33,$6C,$FA,$33,$3A,$FC,$32,$24,$9F,$42,$34
			byte	$8F,$E4,$23,$7E,$F7,$22,$46,$CF,$22,$35,$AF,$C3,$23,$8F,$F5,$33
			byte	$47,$D9,$32,$36,$AF,$C4,$25,$8F,$F6,$23,$46,$BB,$32,$35,$9F,$F5
			byte	$24,$7B,$FA,$33,$35,$FF,$63,$34,$6B,$FB,$33,$58,$EF,$73,$34,$AF
			byte	$D4,$33,$57,$CF,$33,$35,$8F,$F6,$34,$69,$FD,$43,$35,$7F,$B3,$23
			byte	$57,$CF,$93,$36,$8E,$F7,$33,$49,$FF,$63,$34,$69,$E5,$33,$46,$9F
			byte	$D5,$34,$69,$FE,$43,$34,$9F,$E5,$33,$46,$9F,$53,$34,$69,$FE,$63
			byte	$46,$8E,$F7,$33,$48,$DF,$93,$33,$57,$BB,$32,$35,$7A,$FD,$43,$46
			byte	$9F,$F6,$33,$68,$CF,$93,$33,$67,$FD,$43,$34,$78,$EF,$33,$46,$7B
			byte	$FC,$43,$56,$8E,$F7,$33,$47,$BF,$C4,$33,$57,$8F,$93,$33,$57,$9F
			byte	$E3,$34,$67,$BF,$C4,$35,$78,$CF,$A3,$33,$79,$EF,$83,$34,$57,$EF
			byte	$73,$34,$67,$9F,$62,$34,$67,$9F,$E5,$34,$67,$9F,$D6,$34,$67,$9F
			byte	$E6,$33,$47,$9E,$F8,$33,$46,$7D,$F9,$33,$35,$78,$CB,$43,$35,$67
			byte	$AF,$53,$34,$67,$9E,$F8,$34,$57,$8B,$FC,$43,$56,$79,$EF,$83,$34
			byte	$78,$BF,$C4,$33,$47,$9D,$F9,$33,$35,$7A,$FE,$73,$34,$67,$8F,$C4
			byte	$33,$46,$78,$CB,$43,$34,$67,$9C,$A4,$33,$56,$79,$CF,$43,$35,$78
			byte	$9C,$FA,$33,$56,$78,$BF,$B4,$34,$67,$8B,$FC,$53,$46,$78,$AE,$E8
			byte	$34,$57,$79,$CF,$A4,$35,$68,$8A,$FD,$63,$36,$78,$9C,$FA,$43,$46
			byte	$78,$AE,$E7,$33,$57,$88,$BF,$C5,$33,$67,$89,$BF,$B4,$33,$67,$89
			byte	$CF,$B4,$35,$67,$88,$CF,$A4,$35,$67,$88,$BF,$B4,$34,$67,$89,$BF
			byte	$C6,$34,$67,$88,$AE,$E8,$33,$57,$78,$9C,$FB,$33,$46,$78,$9A,$EE
			byte	$33,$35,$78,$89,$BE,$53,$34,$67,$88,$9C,$B4,$33,$46,$78,$8C,$EA
			byte	$43,$34,$67,$89,$CF,$A4,$33,$56,$78,$8B,$FB,$53,$34,$68,$88,$AE
			byte	$D7,$33,$57,$78,$89,$CE,$A4,$34,$67,$88,$8A,$ED,$33,$45,$77,$88
			byte	$9B,$C6,$33,$45,$77,$89,$BE,$C6,$33,$45,$78,$88,$AE,$C7,$33,$47
			byte	$78,$88,$AD,$E9,$43,$46,$78,$88,$9B,$B5,$33,$46,$78,$88,$AC,$E9
			byte	$43,$34,$67,$88,$9A,$CD,$94,$33,$67,$88,$88,$AC,$D4,$33,$46,$78
			byte	$89,$9B,$EB,$53,$34,$57,$78,$88,$AC,$D9,$33,$36,$78,$88,$89,$AD
			byte	$73,$34,$57,$78,$88,$8A,$DC,$83,$34,$56,$88,$88,$8A,$CD,$94,$34
			byte	$67,$88,$88,$8A,$DC,$73,$34,$56,$78,$88,$99,$BD,$B6,$34,$56,$78
			byte	$88,$88,$9C,$C8,$33,$35,$67,$88,$88,$89,$BD,$A5,$34,$67,$88,$88
			byte	$88,$9B,$C9,$53,$34,$67,$88,$89,$88,$9B,$C6,$33,$45,$67,$88,$88
			byte	$88,$9B,$C9,$53,$35,$67,$88,$88,$88,$8B,$CA,$63,$34,$57,$88,$88
			byte	$88,$88,$9B,$94,$33,$56,$78,$88,$88,$88,$89,$BC,$95,$34,$67,$88
			byte	$88,$98,$88,$8A,$BB,$84,$34,$67,$88,$88,$98,$88,$89,$BC,$A6,$33
			byte	$47,$78,$88,$88,$88,$88,$9B,$BA,$63,$34,$67,$88,$88,$88,$88,$88
			byte	$9B,$B9,$53,$34,$78,$88,$88,$88,$88,$88,$8A,$BB,$84,$35,$67,$88
			byte	$88,$88,$88,$88,$88,$8A,$BA,$73,$45,$67,$88,$88,$88,$88,$88,$87
			byte	$89,$B9,$64,$34,$56,$78,$88,$88,$88,$88,$87,$87,$9A,$BA,$74,$35
			byte	$67,$88,$88,$88,$88,$88,$88,$87,$88,$9A,$85,$43,$45,$67,$88,$88
			byte	$88,$88,$88,$88,$78,$78,$9A,$AA,$43,$45,$67,$88,$88,$88,$88,$88
			byte	$88,$87,$87,$78,$89,$AA,$94,$34,$56,$78,$88,$88,$88,$88,$88,$88
			byte	$87,$87,$88,$88,$99,$A7,$54,$34,$57,$78,$88,$88,$88,$88,$87,$87
			byte	$77,$77,$78,$77,$78,$89,$99,$86,$43,$56,$78,$88,$88,$88,$88,$88
			byte	$88,$88,$77,$78,$87,$77,$88,$88,$88,$99,$99,$76,$54,$56,$78,$88
			byte	$88,$88,$88,$88,$88,$88,$87,$78,$88,$87,$87,$77,$77,$78,$88,$88
			byte	$89,$99,$98,$65,$44,$66,$78,$89,$88,$88,$89,$B7,$67,$77,$87,$68
			byte	$78,$A7,$68,$6A,$76,$86,$8A,$76,$78,$A7,$68,$68,$A7,$86,$8A,$76
			byte	$86,$8A,$68,$68,$97,$78,$67,$77,$86,$79,$87,$77,$89,$77,$77,$89
			byte	$77,$78,$A7,$68,$67,$A6,$86,$79,$77,$76,$79,$76,$77,$8A,$76,$67
			byte	$A7,$68,$67,$98,$77,$78,$98,$67,$68,$76,$86,$79,$88,$77,$89,$76
			byte	$86,$89,$77,$77,$89,$76,$77,$87,$78,$67,$98,$87,$78,$A7,$67,$77
			byte	$98,$77,$78,$A7,$68,$77,$98,$77,$78,$A7,$77,$78,$98,$67,$78,$97
			byte	$77,$78,$A7,$67,$77,$87,$67,$77,$97,$77,$78,$A7,$67,$77,$87,$77
			byte	$77,$98,$77,$78,$97,$77,$77,$89,$77,$77,$89,$76,$77,$78,$87,$77
			byte	$89,$87,$77,$89,$87,$77,$78,$77,$77,$78,$97,$77,$78,$97,$77,$77
			byte	$89,$77,$77,$89,$77,$77,$89,$77,$77,$78,$97,$77,$78,$97,$77,$77
			byte	$98,$77,$77,$79,$87,$77,$78,$97,$77,$78,$97,$77,$77,$89,$77,$77
			byte	$89,$77,$77,$78,$87,$77,$77,$89,$77,$77,$89,$77,$77,$78,$87,$77
			byte	$77,$87,$77,$77,$78,$87,$77,$78,$97,$77,$77,$87,$77,$77,$78,$97
			byte	$77,$78,$88,$77,$77,$89,$77,$87,$77,$88,$77,$77,$89,$77,$77,$78
			byte	$97,$77,$78,$79,$87,$77,$78,$87,$77,$87,$89,$77,$77,$88,$97,$77
			byte	$78,$88,$97,$77,$87,$88,$77,$77,$88,$88,$77,$77,$88,$77,$77,$78
			byte	$88,$77,$78,$88,$87,$77,$77,$88,$87,$77,$78,$98,$77,$77,$78,$97
			byte	$77,$77,$89,$77,$88,$78,$87,$77,$78,$78,$87,$77,$78,$88,$77,$77
			byte	$87,$78,$77,$78,$88,$88,$77,$77,$78,$87,$77,$78,$88,$87,$77,$78
			byte	$88,$87,$77,$88,$88,$87,$77,$77,$88,$77,$77,$88,$88,$77,$77,$78
			byte	$88,$77,$77,$88,$88,$77,$77,$77,$78,$77,$77,$88,$88,$77,$77,$88
			byte	$88,$77,$77,$78,$88,$77,$87,$78,$88,$77,$87,$77,$78,$87,$77,$88
			byte	$78,$88,$87,$77,$77,$88,$77,$77,$88,$88,$77,$87,$87,$78,$77,$77
			byte	$77,$77,$87,$77,$77,$88,$87,$77,$78,$78,$88,$77,$77,$78,$78,$87
			byte	$77,$88,$88,$88,$77,$77,$77,$78,$87,$77,$77,$77,$88,$77,$77,$77
			byte	$78,$87,$77,$77,$77,$87,$77,$77,$77,$88,$78,$77,$87,$77,$88,$77
			byte	$77,$77,$88,$87,$77,$77,$77,$88,$77,$87,$77,$88,$87,$78,$78,$77
			byte	$78,$87,$77,$77,$77,$78,$77,$77,$77,$78,$88,$87,$87,$88,$88,$88
			byte	$78,$77,$77,$77,$87,$77,$77,$77,$88,$87,$77,$77,$77,$78,$87,$77
			byte	$78,$77,$88,$87,$77,$77,$77,$87,$87,$77,$78,$77,$78,$78,$78,$87
			byte	$78,$87,$88,$77,$77,$87,$77,$88,$87,$87
			byte	$E  'end marker (1850 bytes total)

shoot_sound		byte	$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88
			byte	$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88
			byte	$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$89,$A9,$65,$56,$78
			byte	$66,$7A,$97,$6B,$64,$9C,$71,$6D,$B6,$CA,$50,$6F,$81,$F6,$08,$F8
			byte	$06,$E7,$9F,$50,$AF,$60,$3B,$51,$CA,$23,$CB,$16,$70,$6D,$D2,$4E
			byte	$73,$AF,$50,$9F,$80,$3F,$50,$AF,$22,$CB,$48,$F9,$14,$BD,$15,$E4
			byte	$08,$F7,$09,$F6,$0F,$A3,$0A,$F3,$1C,$24,$EA,$40,$9F,$60,$F5,$0A
			byte	$F5,$08,$FB,$07,$F8,$05,$CE,$50,$F9,$23,$DB,$16,$D3,$2C,$D4,$08
			byte	$F8,$0D,$B1,$6F,$60,$6E,$C3,$BF,$40,$BF,$23,$C5,$06,$FB,$26,$F6
			byte	$7C,$F5,$08,$F7,$08,$72,$1A,$F9,$03,$BF,$1C,$D5,$08,$F6,$0B,$40
			byte	$BF,$50,$AF,$66,$F5,$07,$ED,$31,$B4,$07,$F8,$08,$DB,$4A,$F5,$08
			byte	$F7,$23,$C4,$1D,$C3,$1D,$C2,$BF,$30,$BD,$50,$8F,$15,$DC,$31,$BF
			byte	$50,$F5,$0B,$F3,$1C,$D2,$DB,$24,$DA,$15,$D4,$09,$F7,$0A,$F5,$0F
			byte	$A1,$6C,$D4,$08,$F2,$3D,$A0,$9E,$93,$0F,$40,$CE,$32,$BF,$07,$ED
			byte	$25,$D9,$30,$D3,$1C,$F4,$0A,$F7,$7E,$50,$8E,$B1,$7E,$20,$BF,$60
			byte	$8F,$59,$F8,$16,$DB,$40,$A6,$06,$BF,$60,$7E,$95,$DB,$32,$AF,$70
			byte	$3F,$60,$AF,$70,$6E,$19,$F5,$0A,$F7,$16,$A3,$0A,$F5,$0A,$EA,$0B
			byte	$E4,$09,$F7,$17,$92,$5E,$71,$8D,$C4,$CB,$40,$AF,$60,$8A,$40,$BF
			byte	$70,$6D,$A0,$BF,$41,$CF,$40,$A5,$0A,$F7,$22,$CF,$4A,$F6,$09,$E8
			byte	$15,$C3,$0C,$F4,$0B,$F5,$BF,$31,$BE,$50,$8F,$18,$DC,$33,$CD,$31
			byte	$E3,$1A,$F6,$09,$E0,$9D,$C4,$0C,$E3,$1F,$50,$9E,$83,$2A,$F0,$9D
			byte	$93,$0B,$F3,$1F,$71,$3B,$F3,$0B,$50,$7E,$A3,$3C,$F3,$CF,$40,$BF
			byte	$72,$2B,$40,$BF,$82,$1B,$F5,$9D,$B5,$0B,$F5,$0F,$50,$BF,$61,$7E
			byte	$67,$DC,$25,$D9,$22,$D2,$7E,$81,$9E,$51,$7D,$30,$BF,$50,$AE,$15
			byte	$DC,$26,$DA,$40,$F6,$23,$CE,$31,$BF,$16,$CD,$30,$BF,$51,$BF,$30
			byte	$BE,$40,$C3,$1D,$D3,$1B,$F4,$0D,$21,$CC,$23,$DB,$3C,$F3,$0A,$F5
			byte	$18,$C3,$0A,$F7,$26,$D9,$5C,$C2,$4D,$93,$4C,$40,$AE,$40,$BF,$51
			byte	$CF,$40,$BE,$40,$9F,$26,$BD,$40,$AE,$92,$CD,$30,$9F,$A2,$76,$32
			byte	$BF,$30,$AE,$85,$CA,$21,$CF,$40,$89,$29,$E4,$25,$BF,$3B,$E7,$22
			byte	$CF,$30,$F4,$1B,$E5,$06,$DB,$2D,$D3,$1C,$E3,$1C,$71,$2B,$F3,$09
			byte	$EA,$8E,$72,$5D,$A2,$66,$1B,$E6,$26,$D9,$1E,$50,$BF,$62,$4C,$F0
			byte	$DE,$30,$9F,$82,$6F,$20,$BD,$82,$0C,$30,$AD,$A3,$1D,$C2,$DB,$23
			byte	$EB,$25,$CF,$0B,$E3,$19,$F9,$25,$F3,$08,$D9,$19,$E2,$2D,$F1,$4E
			byte	$92,$5C,$21,$DF,$40,$AE,$47,$DD,$24,$DC,$20,$D3,$0A,$F5,$28,$DD
			byte	$0B,$F8,$16,$CA,$30,$F2,$2D,$D2,$1B,$F4,$8E,$A0,$8C,$82,$2D,$30
			byte	$DE,$23,$DD,$3B,$E8,$24,$E8,$25,$D1,$5D,$A2,$3C,$E2,$0D,$22,$CF
			byte	$30,$AE,$69,$D8,$15,$DA,$21,$C1,$5D,$B3,$0C,$F6,$9D,$52,$6D,$D2
			byte	$1D,$40,$AE,$51,$8D,$A2,$DC,$22,$EC,$25,$E1,$8D,$92,$3E,$A2,$4F
			byte	$21,$DE,$20,$AF,$6A,$CB,$20,$CF,$51,$77,$29,$D8,$33,$CF,$0B,$D8
			byte	$20,$DF,$21,$EA,$22,$DC,$15,$E7,$5D,$F1,$2E,$B2,$2B,$50,$AD,$42
			byte	$6D,$D3,$DD,$20,$CE,$82,$0F,$22,$9E,$A1,$5D,$A3,$CF,$21,$BE,$A1
			byte	$1C,$14,$DE,$20,$CE,$1D,$D2,$1D,$F4,$19,$31,$DF,$41,$8D,$51,$E5
			byte	$25,$CF,$20,$BC,$23,$DB,$22,$EE,$1D,$B2,$0C,$F4,$26,$D1,$0D,$E5
			byte	$18,$D8,$3D,$F4,$2D,$D2,$17,$D1,$1E,$E3,$09,$E7,$7D,$A1,$7D,$82
			byte	$1C,$41,$AC,$72,$1C,$F3,$DD,$21,$AD,$52,$BE,$28,$DD,$11,$EC,$1D
			byte	$B1,$2E,$C1,$4E,$A3,$CF,$41,$9C,$72,$4C,$16,$DA,$20,$DF,$3C,$D2
			byte	$1C,$D4,$28,$92,$4C,$F3,$0A,$C2,$9E,$A2,$4D,$E1,$0D,$22,$DE,$11
			byte	$DD,$21,$D8,$22,$ED,$24,$D2,$2C,$E7,$15,$CA,$2E,$B2,$3C,$E8,$22
			byte	$D1,$2D,$D2,$1A,$D6,$3D,$F2,$16,$CE,$10,$D3,$27,$DC,$14,$DA,$4E
			byte	$A2,$4C,$E5,$25,$E1,$1D,$D4,$29,$D6,$BD,$53,$4D,$F4,$2C,$F1,$29
			byte	$CD,$11,$99,$27,$CB,$21,$CE,$59,$C7,$26,$D8,$2A,$C3,$2B,$E5,$3B
			byte	$C4,$AC,$A2,$2E,$B2,$5D,$26,$DA,$22,$CD,$33,$DB,$16,$C8,$33,$BE
			byte	$28,$C5,$3A,$C7,$3D,$D1,$2C,$D4,$3C,$C2,$AD,$43,$BC,$53,$8A,$22
			byte	$DD,$43,$6C,$C3,$DB,$24,$DC,$22,$D6,$35,$CE,$22,$AC,$2B,$C5,$34
			byte	$DD,$24,$B2,$28,$DC,$23,$DB,$2B,$D5,$46,$CD,$2D,$B2,$2A,$C8,$37
			byte	$C2,$4D,$A3,$5C,$D3,$2C,$73,$4B,$E4,$3C,$B3,$DC,$33,$9C,$73,$C8
			byte	$26,$C9,$26,$C9,$5C,$B2,$6C,$74,$5C,$33,$7C,$B2,$5C,$83,$CA,$23
			byte	$DA,$25,$C2,$39,$DB,$24,$DB,$2C,$B3,$48,$EB,$27,$B2,$2C,$C4,$3A
			byte	$C7,$3C,$A2,$4C,$C2,$4C,$B3,$BC,$64,$7C,$A2,$AD,$73,$AB,$53,$5D
			byte	$36,$CB,$23,$AC,$74,$BD,$33,$CB,$33,$7C,$24,$DB,$23,$CC,$4A,$C6
			byte	$3A,$B5,$46,$C2,$3C,$C7,$45,$CC,$3C,$B4,$46,$DB,$35,$C2,$3A,$B5
			byte	$4C,$B2,$DA,$34,$CC,$64,$5C,$24,$7C,$B3,$5C,$B2,$AB,$54,$BB,$54
			byte	$9C,$46,$CC,$33,$9B,$6A,$B6,$45,$CC,$34,$C3,$58,$CA,$12,$BB,$46
			byte	$CC,$34,$6C,$B2,$4C,$83,$5B,$C4,$47,$93,$8B,$83,$4C,$C4,$9B,$54
			byte	$9B,$64,$6B,$44,$CA,$43,$AB,$55,$BC,$44,$CA,$44,$6C,$44,$7B,$B2
			byte	$49,$C3,$4C,$A4,$59,$D8,$3B,$B4,$46,$BB,$24,$C3,$59,$CA,$24,$BB
			byte	$5C,$93,$5C,$A3,$5B,$44,$9B,$64,$9B,$64,$CB,$34,$AB,$64,$8B,$35
			byte	$C9,$35,$CB,$4C,$94,$5A,$B6,$46,$B3,$5B,$B4,$47,$CB,$39,$B7,$4A
			byte	$A6,$45,$C3,$5C,$A3,$5A,$B6,$9A,$74,$7B,$74,$6A,$73,$7B,$74,$6B
			byte	$B3,$CA,$34,$9B,$74,$AA,$59,$B6,$56,$AB,$49,$B9,$34,$BA,$64,$6B
			byte	$45,$AA,$55,$8C,$A4,$AB,$64,$5B,$B5,$5B,$75,$6A,$B5,$57,$A3,$5C
			byte	$A3,$49,$B6,$8B,$93,$5A,$B7,$45,$A4,$57,$BB,$35,$AA,$5B,$95,$56
			byte	$CA,$4A,$B6,$46,$BA,$46,$B4,$5B,$A4,$59,$A7,$4B,$85,$7B,$93,$58
			byte	$C3,$6B,$93,$59,$B7,$59,$C8,$45,$9B,$64,$B8,$46,$BA,$45,$AA,$46
			byte	$BA,$45,$BA,$45,$BA,$35,$B9,$45,$A5,$69,$B9,$35,$BA,$59,$A7,$56
			byte	$BA,$45,$96,$58,$B9,$45,$8C,$A5,$B9,$45,$9B,$65,$A7,$57,$B7,$57
			byte	$B9,$5A,$A5,$59,$A8,$46,$84,$68,$C8,$47,$A8,$5A,$B6,$58,$A8,$4B
			byte	$84,$6A,$A4,$58,$A5,$69,$B8,$45,$A9,$47,$B9,$45,$8B,$84,$69,$46
			byte	$9A,$74,$7B,$46,$B9,$46,$B9,$46,$A6,$6A,$96,$58,$A6,$79,$B5,$58
			byte	$B9,$35,$A6,$58,$A8,$46,$A5,$6A,$A6,$57,$9B,$78,$A6,$58,$A6,$58
			byte	$A4,$7B,$84,$6A,$A6,$5B,$94,$6A,$A6,$59,$66,$8B,$75,$78,$B8,$5A
			byte	$A5,$67,$B9,$45,$A6,$68,$A8,$56,$9A,$59,$96,$66,$9B,$79,$96,$57
			byte	$B9,$46,$7A,$56,$8A,$85,$6A,$96,$8A,$85,$69,$A8,$5A,$96,$67,$A9
			byte	$56,$A7,$57,$A9,$46,$A9,$68,$B7,$57,$8B,$84,$A9,$55,$7A,$95,$69
			byte	$75,$99,$66,$8A,$86,$8B,$94,$58,$A8,$5A,$85,$69,$97,$56,$A5,$69
			byte	$97,$67,$A9,$58,$A7,$56,$8A,$85,$A8,$56,$8A,$95,$67,$95,$69,$96
			byte	$68,$A7,$7A,$95,$69,$A6,$67,$96,$67,$A9,$56,$88,$56,$99,$66,$99
			byte	$77,$99,$56,$A9,$56,$7A,$66,$78,$A6,$58,$96,$7A,$95,$68,$A8,$6A
			byte	$96,$69,$96,$67,$A8,$57,$A8,$56,$7A,$66,$7A,$95,$69,$86,$99,$66
			byte	$8A,$86,$79,$66,$8A,$85,$68,$A6,$68,$A7,$67,$99,$58,$98,$56,$8A
			byte	$85,$78,$56,$89,$86,$7A,$87,$98,$66,$99,$66,$86,$67,$A8,$56,$8A
			byte	$67,$99,$66,$89,$76,$8A,$85,$68,$97,$67,$85,$79,$76,$79,$77,$8A
			byte	$76,$79,$96,$69,$76,$78,$A8,$56,$87,$68,$98,$67,$99,$67,$89,$66
			byte	$79,$96,$89,$76,$79,$86,$77,$86,$68,$97,$67,$98,$68,$97,$67,$98
			byte	$66,$97,$67,$98,$67,$79,$66,$79,$85,$79,$87,$79,$96,$77,$98,$67
			byte	$98,$67,$79,$86,$79,$96,$67,$89,$67,$89,$76,$80
			byte	$E  'end marker (1532 bytes total)


explosion_sound		byte	$77,$77,$78,$88,$87,$77,$77,$88,$87,$66,$55,$67,$88,$87,$66,$55
			byte	$67,$77,$88,$89,$AA,$AA,$88,$76,$44,$44,$55,$78,$88,$89,$AA,$A9
			byte	$66,$66,$78,$98,$88,$9A,$BB,$BB,$AA,$84,$20,$00,$00,$12,$57,$88
			byte	$9A,$CD,$DC,$BB,$CE,$FF,$FF,$FF,$DA,$85,$22,$22,$22,$32,$00,$00
			byte	$00,$01,$79,$BC,$DE,$FF,$ED,$96,$20,$00,$00,$03,$8A,$CD,$EF,$DB
			byte	$A9,$9A,$A8,$52,$10,$13,$58,$BC,$CC,$BA,$9A,$BB,$BA,$9A,$CF,$FF
			byte	$FF,$FE,$A6,$20,$01,$46,$8A,$BA,$A8,$64,$21,$22,$22,$47,$98,$54
			byte	$34,$68,$AA,$DF,$FE,$B7,$30,$00,$37,$AD,$DB,$74,$21,$11,$00,$14
			byte	$9E,$FF,$FF,$FF,$FC,$94,$00,$00,$00,$24,$44,$47,$78,$77,$9B,$DF
			byte	$FF,$FF,$FF,$FF,$FF,$85,$10,$00,$00,$27,$74,$21,$13,$45,$66,$77
			byte	$9D,$FF,$FF,$FD,$A7,$56,$8A,$CC,$C4,$00,$00,$00,$00,$3C,$FF,$FF
			byte	$FD,$B9,$60,$00,$00,$00,$18,$DC,$DF,$FF,$FF,$DC,$FF,$FF,$FD,$86
			byte	$68,$CD,$DC,$A8,$76,$65,$66,$77,$52,$00,$27,$89,$9B,$EF,$FF,$FF
			byte	$FF,$FB,$63,$11,$38,$AD,$ED,$A5,$10,$00,$12,$58,$99,$AB,$A7,$41
			byte	$12,$12,$33,$45,$55,$54,$32,$33,$69,$CE,$EE,$CA,$98,$87,$65,$57
			byte	$AD,$FF,$ED,$DB,$98,$66,$57,$89,$99,$AA,$AA,$99,$AA,$BB,$BB,$BB
			byte	$A9,$87,$66,$66,$66,$65,$44,$44,$44,$45,$78,$99,$AA,$BA,$AA,$86
			byte	$53,$11,$12,$35,$78,$9A,$AA,$A9,$88,$88,$87,$54,$43,$45,$67,$88
			byte	$98,$88,$9A,$AA,$87,$67,$8A,$CF,$FF,$FF,$D9,$41,$02,$45,$67,$87
			byte	$75,$31,$10,$01,$35,$8B,$CA,$87,$67,$78,$88,$AB,$CA,$85,$31,$01
			byte	$36,$8B,$B9,$75,$45,$54,$44,$47,$AD,$FF,$EE,$DC,$BA,$85,$10,$00
			byte	$00,$24,$44,$47,$77,$77,$9B,$CF,$FF,$FF,$EF,$FF,$FF,$96,$20,$00
			byte	$00,$36,$64,$20,$13,$45,$66,$78,$9D,$FF,$FF,$FD,$A7,$56,$8A,$CC
			byte	$C4,$00,$00,$00,$00,$3C,$FF,$FF,$FD,$B9,$60,$00,$00,$00,$18,$DC
			byte	$DF,$FF,$FF,$DC,$FF,$FF,$FD,$86,$68,$CD,$DC,$A8,$76,$65,$66,$77
			byte	$52,$00,$27,$89,$AB,$EF,$FF,$FF,$FF,$FB,$63,$01,$37,$BE,$FE,$A6
			byte	$10,$00,$01,$47,$99,$AB,$A7,$31,$11,$11,$23,$34,$54,$43,$20,$12
			byte	$69,$DF,$FF,$DA,$99,$86,$43,$35,$9F,$FF,$FF,$FF,$DA,$97,$67,$89
			byte	$99,$99,$99,$88,$98,$89,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88
			byte	$87,$77,$88,$77,$77,$77,$77,$77,$77,$77,$77,$77,$66,$67,$66,$66
			byte	$66,$66,$67,$76,$77,$77,$76,$44,$44,$46,$9B,$97,$53,$32,$33,$5D
			byte	$FF,$FF,$FE,$84,$35,$54,$32,$11,$00,$00,$00,$00,$49,$FF,$FF,$FE
			byte	$ED,$A8,$54,$22,$20,$02,$57,$66,$33,$33,$46,$79,$BF,$FF,$FF,$FF
			byte	$FB,$60,$00,$00,$00,$46,$66,$55,$44,$44,$55,$56,$66,$77,$76,$31
			byte	$01,$34,$79,$AC,$DE,$FF,$FF,$FF,$FF,$F6,$00,$00,$01,$68,$75,$10
			byte	$00,$00,$00,$10,$00,$36,$77,$66,$8E,$FE,$CA,$87,$66,$56,$65,$32
			byte	$11,$59,$CC,$AA,$BA,$98,$89,$99,$BD,$EE,$DE,$DB,$53,$10,$00,$11
			byte	$12,$12,$33,$58,$99,$98,$77,$76,$66,$66,$57,$89,$99,$88,$88,$87
			byte	$78,$78,$88,$88,$87,$78,$88,$88,$88,$77,$76,$78,$89,$98,$87,$77
			byte	$67,$77,$77,$77,$77,$76,$43,$47,$AB,$BB,$A8,$87,$66,$66,$66,$66
			byte	$66,$66,$77,$77,$77,$77,$77,$77,$75,$31,$24,$68,$88,$88,$8A,$DE
			byte	$FF,$FF,$CA,$85,$44,$23,$47,$77,$89,$86,$21,$00,$00,$00,$12,$7A
			byte	$EF,$ED,$B9,$86,$56,$66,$67,$77,$64,$55,$66,$8B,$FF,$FB,$BA,$A9
			byte	$AC,$DD,$DE,$C9,$75,$33,$22,$23,$34,$44,$55,$55,$32,$10,$12,$48
			byte	$AC,$CE,$FF,$FF,$FF,$DC,$85,$21,$00,$00,$00,$36,$66,$54,$46,$9C
			byte	$BB,$A9,$AB,$CD,$B5,$10,$01,$36,$89,$97,$54,$32,$21,$00,$15,$AE
			byte	$FF,$FF,$FF,$C9,$76,$56,$79,$A9,$65,$54,$44,$55,$56,$66,$77,$77
			byte	$78,$87,$32,$11,$23,$57,$9C,$DF,$FF,$FF,$FF,$F8,$65,$67,$9A,$98
			byte	$50,$00,$00,$00,$35,$89,$88,$87,$54,$32,$22,$11,$35,$89,$99,$98
			byte	$88,$88,$89,$99,$99,$99,$AA,$AA,$AA,$A9,$99,$99,$99,$98,$74,$31
			byte	$12,$34,$6B,$EF,$FF,$FF,$FF,$D6,$43,$58,$AD,$EE,$C3,$00,$00,$00
			byte	$00,$38,$CF,$FE,$CB,$A8,$43,$22,$23,$33,$33,$33,$34,$7B,$DE,$ED
			byte	$EF,$FF,$FF,$DA,$87,$88,$89,$AA,$98,$75,$55,$55,$66,$67,$77,$78
			byte	$88,$76,$68,$89,$99,$98,$89,$AA,$CC,$CB,$A9,$87,$77,$66,$78,$88
			byte	$88,$87,$55,$42,$22,$34,$44,$68,$AA,$AA,$9B,$BB,$CB,$A8,$65,$55
			byte	$56,$66,$65,$67,$88,$86,$67,$89,$CF,$FF,$FE,$DA,$75,$42,$10,$00
			byte	$12,$46,$77,$65,$44,$43,$45,$69,$AB,$DE,$FF,$EE,$ED,$CB,$97,$53
			byte	$21,$00,$03,$56,$77,$65,$57,$9B,$BA,$A9,$9A,$BC,$B5,$32,$22,$36
			byte	$89,$98,$75,$44,$32,$21,$26,$AD,$FF,$FF,$EE,$B9,$76,$56,$79,$98
			byte	$65,$55,$55,$55,$56,$66,$77,$77,$78,$87,$32,$11,$23,$57,$9C,$DF
			byte	$FF,$FF,$FF,$F8,$65,$67,$9A,$98,$50,$00,$00,$00,$35,$89,$88,$87
			byte	$54,$32,$22,$11,$35,$89,$99,$98,$88,$88,$89,$99,$99,$99,$AA,$AA
			byte	$AA,$A9,$99,$99,$99,$98,$74,$31,$12,$34,$6B,$EF,$FF,$FF,$FF,$D6
			byte	$33,$48,$BD,$FE,$C3,$00,$00,$00,$00,$28,$DF,$FF,$DC,$A7,$32,$11
			byte	$22,$32,$22,$22,$24,$7C,$FF,$FE,$FF,$FF,$FF,$EB,$88,$88,$9A,$BB
			byte	$A8,$75,$44,$45,$56,$66,$77,$88,$89,$88,$99,$99,$99,$98,$88,$88
			byte	$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$87,$64,$46,$77,$65,$67
			byte	$77,$67,$9C,$FF,$FF,$EA,$64,$33,$37,$86,$54,$43,$10,$00,$12,$59
			byte	$EF,$FF,$FF,$DA,$75,$41,$00,$00,$00,$37,$A9,$85,$57,$99,$AA,$AA
			byte	$9A,$DE,$DA,$87,$88,$89,$AA,$99,$88,$88,$88,$88,$89,$89,$99,$99
			byte	$99,$99,$99,$99,$88,$88,$87,$65,$56,$6A,$CC,$CB,$A9,$88,$AB,$A9
			byte	$86,$54,$44,$34,$44,$45,$66,$66,$66,$66,$66,$66,$66,$67,$77,$77
			byte	$77,$77,$77,$77,$77,$88,$67,$88,$64,$32,$36,$9B,$BC,$DD,$CA,$75
			byte	$33,$35,$8D,$FF,$FF,$EA,$52,$10,$00,$14,$68,$98,$87,$54,$56,$76
			byte	$54,$33,$32,$22,$00,$01,$24,$7A,$DF,$FF,$FF,$FF,$FF,$FF,$FC,$84
			byte	$00,$00,$3A,$BB,$96,$53,$10,$00,$00,$00,$02,$34,$67,$AC,$EF,$FF
			byte	$EC,$88,$8A,$EF,$FF,$FF,$73,$00,$00,$02,$7B,$FF,$EB,$86,$42,$00
			byte	$00,$00,$03,$9C,$DB,$CD,$EF,$EC,$A9,$83,$22,$11,$11,$36,$BF,$FF
			byte	$FF,$FE,$C9,$53,$34,$6A,$FF,$FF,$FF,$D9,$51,$00,$01,$8A,$BA,$AA
			byte	$AA,$97,$00,$01,$13,$57,$85,$44,$66,$54,$34,$7F,$FF,$FE,$C9,$99
			byte	$95,$57,$9C,$EE,$DB,$97,$65,$55,$55,$55,$66,$53,$24,$66,$67,$BE
			byte	$FD,$B9,$AA,$98,$43,$34,$79,$AB,$EF,$FF,$D9,$53,$34,$5A,$CC,$BA
			byte	$98,$51,$00,$04,$79,$A9,$75,$21,$21,$00,$00,$13,$7C,$DD,$DC,$DE
			byte	$FF,$FE,$C9,$64,$00,$00,$01,$48,$DF,$FF,$FE,$FF,$EB,$84,$21,$13
			byte	$AF,$FF,$FE,$CA,$84,$34,$7A,$DF,$FF,$D5,$32,$34,$66,$65,$20,$00
			byte	$00,$00,$13,$49,$CE,$FF,$EE,$FF,$FF,$FF,$FD,$84,$10,$47,$89,$BB
			byte	$A7,$41,$01,$23,$47,$AB,$BC,$DD,$DC,$A8,$62,$00,$00,$01,$69,$98
			byte	$79,$BC,$BA,$9B,$DF,$FF,$FF,$DC,$B9,$75,$42,$46,$77,$78,$9A,$A8
			byte	$75,$34,$56,$53,$23,$57,$9A,$DE,$FF,$ED,$B9,$88,$88,$BE,$FF,$FF
			byte	$C7,$42,$10,$13,$55,$67,$64,$10,$02,$34,$67,$66,$65,$44,$20,$01
			byte	$11,$3A,$DE,$DD,$DD,$CA,$74,$34,$69,$CE,$EE,$99,$88,$74,$22,$45
			byte	$78,$77,$78,$9B,$CB,$99,$AC,$EF,$FF,$FF,$FF,$EB,$A8,$64,$42,$00
			byte	$01,$22,$10,$02,$45,$79,$AC,$DF,$FE,$DC,$A8,$53,$10,$02,$35,$8B
			byte	$EF,$EC,$75,$55,$67,$88,$52,$00,$00,$00,$03,$7A,$EF,$FF,$FF,$DC
			byte	$B9,$9A,$BA,$98,$65,$41,$00,$03,$7A,$BD,$CA,$99,$9A,$BB,$97,$52
			byte	$24,$8A,$BB,$AB,$CB,$A8,$54,$43,$33,$78,$88,$87,$76,$67,$64,$10
			byte	$00,$02,$6A,$DD,$DE,$EC,$A9,$9A,$CC,$B8,$41,$00,$00,$37,$AA,$BC
			byte	$CB,$A7,$78,$86,$55,$44,$34,$7A,$CD,$DC,$CB,$95,$44,$69,$DF,$FE
			byte	$A7,$65,$43,$23,$59,$EF,$FD,$A8,$76,$52,$00,$00,$05,$9C,$DC,$BB
			byte	$BB,$AA,$98,$71,$00,$00,$00,$24,$6D,$FF,$FF,$EF,$FF,$FD,$CB,$99
			byte	$98,$88,$AD,$DC,$A7,$52,$21,$12,$22,$34,$55,$66,$88,$89,$AC,$CA
			byte	$85,$00,$25,$89,$99,$88,$75,$32,$23,$46,$8D,$ED,$B9,$99,$86,$45
			byte	$66,$78,$98,$88,$99,$85,$20,$01,$46,$9B,$BA,$99,$AB,$CB,$87,$66
			byte	$55,$68,$AB,$87,$66,$66,$55,$68,$CD,$DC,$CC,$CC,$CA,$88,$89,$9B
			byte	$DE,$ED,$CB,$98,$77,$76,$63,$00,$00,$00,$00,$00,$46,$9B,$CD,$EE
			byte	$EE,$EE,$DC,$A7,$41,$00,$01,$47,$AD,$ED,$97,$77,$89,$88,$64,$21
			byte	$22,$22,$36,$8B,$DF,$FE,$DC,$A8,$64,$56,$77,$88,$99,$85,$44,$58
			byte	$AB,$BB,$A8,$89,$AB,$DC,$B8,$62,$13,$58,$9A,$AC,$CB,$A8,$65,$53
			byte	$22,$56,$67,$78,$77,$78,$64,$21,$00,$13,$7A,$CB,$CD,$DC,$A9,$9C
			byte	$DD,$C9,$52,$00,$01,$47,$AA,$BC,$CB,$A7,$88,$86,$55,$44,$34,$7A
			byte	$CD,$DC,$CB,$75,$44,$69,$DF,$FE,$A7,$65,$43,$23,$59,$EF,$FD,$A8
			byte	$76,$52,$00,$00,$05,$9C,$DB,$BB,$BB,$AA,$98,$71,$00,$00,$00,$24
			byte	$6D,$FF,$FF,$EF,$FF,$FD,$CB,$99,$98,$88,$CE,$DC,$A7,$42,$21,$01
			byte	$22,$34,$55,$67,$89,$89,$AC,$CA,$73,$00,$14,$89,$99,$86,$42,$10
			byte	$02,$46,$AF,$FF,$CA,$99,$86,$57,$78,$89,$99,$89,$AA,$96,$30,$02
			byte	$58,$CB,$A9,$88,$9A,$BC,$98,$86,$43,$36,$89,$86,$55,$66,$77,$79
			byte	$FF,$FF,$FE,$DD,$C8,$66,$77,$78,$AB,$B9,$87,$55,$56,$78,$84,$00
			byte	$00,$00,$00,$00,$37,$AD,$EE,$EE,$DE,$FF,$FF,$FB,$72,$00,$00,$02
			byte	$59,$DF,$DA,$99,$BB,$A9,$88,$67,$9A,$98,$89,$BD,$DD,$A7,$64,$20
			byte	$00,$00,$00,$4A,$EF,$FF,$FF,$FF,$FE,$B7,$42,$58,$CF,$FF,$DB,$41
			byte	$00,$01,$36,$AD,$EC,$BB,$BA,$85,$10,$00,$01,$58,$BC,$BA,$87,$65
			byte	$45,$68,$98,$31,$12,$46,$78,$AF,$FF,$FF,$DB,$BA,$AD,$EC,$BA,$97
			byte	$42,$14,$67,$64,$10,$00,$00,$01,$34,$58,$BF,$FF,$FD,$CC,$CD,$DC
			byte	$86,$53,$33,$56,$64,$10,$02,$46,$99,$98,$8A,$CE,$FE,$C9,$60,$00
			byte	$00,$13,$56,$6B,$DF,$FD,$A9,$87,$8B,$B9,$74,$21,$36,$9C,$BA,$98
			byte	$75,$56,$BB,$BB,$AA,$99,$99,$AA,$BA,$97,$66,$77,$67,$89,$9A,$BD
			byte	$FF,$D9,$54,$10,$00,$01,$47,$AC,$DE,$DC,$A7,$40,$00,$00,$00,$01
			byte	$45,$78,$AD,$EF,$ED,$FF,$FF,$FF,$FE,$87,$77,$67,$88,$86,$20,$00
			byte	$00,$25,$65,$57,$9B,$CA,$98,$76,$44,$43,$45,$79,$98,$65,$56,$78
			byte	$88,$86,$43,$33,$33,$34,$68,$87,$78,$BD,$DC,$BC,$CC,$BB,$DF,$FF
			byte	$EB,$85,$32,$23,$69,$FF,$ED,$A6,$43,$22,$56,$54,$31,$00,$00,$00
			byte	$35,$78,$87,$64,$56,$89,$BB,$CB,$B9,$75,$43,$22,$47,$BF,$FF,$EA
			byte	$86,$55,$64,$33,$33,$35,$7A,$C9,$87,$65,$44,$68,$CD,$FF,$FE,$CB
			byte	$BB,$A9,$75,$30,$00,$00,$48,$AB,$AA,$9B,$CC,$CB,$BA,$AC,$FF,$FF
			byte	$FF,$D8,$41,$00,$27,$99,$74,$00,$00,$00,$02,$45,$67,$9A,$A8,$76
			byte	$53,$10,$02,$89,$BB,$BA,$86,$44,$67,$78,$87,$41,$01,$57,$66,$68
			byte	$9A,$98,$9B,$DE,$DB,$A9,$88,$9A,$CF,$FF,$FF,$FB,$86,$43,$35,$8B
			byte	$DE,$B7,$30,$00,$00,$00,$00,$00,$13,$44,$67,$9A,$CE,$EC,$96,$31
			byte	$12,$33,$44,$68,$AB,$CD,$EE,$DB,$AC,$EF,$FF,$EA,$63,$25,$8A,$AA
			byte	$BB,$97,$56,$78,$85,$32,$00,$27,$89,$AC,$FF,$FF,$FF,$FD,$95,$10
			byte	$00,$25,$8C,$EF,$FD,$A7,$67,$76,$54,$21,$00,$69,$A9,$88,$99,$88
			byte	$78,$9A,$BB,$BA,$62,$24,$57,$89,$98,$73,$10,$12,$33,$44,$32,$35
			byte	$79,$AA,$AB,$FF,$FF,$FE,$EB,$96,$55,$67,$78,$88,$87,$44,$67,$89
			byte	$86,$20,$00,$13,$56,$65,$47,$77,$54,$46,$8A,$CD,$B9,$86,$54,$44
			byte	$33,$32,$11,$36,$99,$99,$AA,$AA,$AB,$EF,$FE,$DB,$98,$9B,$BB,$CB
			byte	$AA,$97,$53,$11,$23,$47,$99,$87,$65,$78,$9A,$98,$88,$88,$9A,$CD
			byte	$CB,$A8,$51,$00,$01,$48,$BD,$EC,$A9,$98,$64,$20,$01,$48,$BD,$ED
			byte	$CB,$86,$66,$77,$77,$52,$00,$00,$24,$57,$AD,$FF,$FF,$FE,$DC,$CB
			byte	$86,$67,$77,$89,$AB,$AA,$86,$44,$32,$10,$00,$01,$37,$AA,$AA,$BD
			byte	$DD,$DC,$BA,$96,$56,$78,$88,$76,$77,$76,$68,$AC,$DC,$97,$43,$45
			byte	$67,$87,$42,$00,$00,$00,$13,$79,$99,$99,$99,$AA,$BC,$DD,$CB,$97
			byte	$75,$43,$33,$56,$89,$AC,$EE,$DC,$CC,$B9,$73,$21,$13,$57,$88,$88
			byte	$88,$88,$88,$8A,$EF,$FF,$DA,$86,$43,$34,$45,$67,$75,$55,$78,$76
			byte	$65,$55,$58,$9A,$98,$78,$88,$99,$9A,$BB,$BA,$AA,$96,$54,$45,$67
			byte	$89,$98,$65,$56,$66,$65,$42,$34,$79,$AA,$AB,$CC,$CB,$A9,$86,$53
			byte	$34,$56,$77,$78,$99,$77,$89,$99,$75,$20,$00,$34,$68,$99,$99,$98
			byte	$76,$67,$9B,$BB,$98,$66,$55,$55,$55,$43,$21,$35,$78,$89,$AA,$AA
			byte	$AC,$DE,$FE,$CA,$88,$89,$99,$AA,$99,$99,$75,$33,$33,$46,$88,$76
			byte	$55,$78,$9A,$99,$88,$88,$8A,$BC,$BA,$97,$51,$00,$12,$58,$BD,$EC
			byte	$B9,$98,$75,$31,$02,$58,$BD,$EC,$CB,$76,$66,$77,$77,$52,$00,$00
			byte	$24,$57,$AD,$FF,$FF,$FE,$DC,$CB,$86,$67,$77,$89,$AB,$AA,$86,$44
			byte	$32,$10,$00,$01,$37,$AA,$AA,$BD,$DD,$DC,$BA,$96,$56,$78,$88,$76
			byte	$77,$76,$68,$AC,$DC,$97,$43,$45,$67,$87,$42,$00,$00,$00,$13,$79
			byte	$AA,$99,$9A,$AA,$BC,$DC,$BA,$87,$64,$32,$12,$35,$89,$BD,$EE,$ED
			byte	$DC,$CA,$82,$10,$02,$68,$9A,$98,$88,$76,$65,$68,$DF,$FF,$EB,$98
			byte	$65,$43,$33,$44,$32,$24,$88,$76,$66,$67,$7A,$AA,$98,$77,$88,$99
			byte	$9A,$CC,$BA,$AA,$A8,$65,$43,$56,$89,$AB,$A9,$88,$99,$86,$32,$24
			byte	$69,$AA,$AA,$87,$66,$44,$32,$00,$02,$35,$66,$78,$AC,$BB,$BA,$A8
			byte	$64,$20,$02,$46,$9B,$DE,$EC,$A9,$88,$89,$AB,$A8,$75,$44,$67,$88
			byte	$87,$65,$31,$12,$45,$78,$99,$AA,$BB,$BB,$CB,$A8,$86,$65,$45,$66
			byte	$79,$AC,$DC,$A8,$65,$55,$43,$22,$25,$8A,$BA,$99,$98,$76,$66,$65
			byte	$32,$10,$12,$45,$79,$BD,$EE,$EF,$FF,$ED,$CA,$98,$99,$89,$98,$77
			byte	$65,$21,$11,$23,$45,$66,$67,$8A,$A9,$99,$99,$76,$54,$43,$22,$23
			byte	$58,$99,$AA,$CE,$EC,$CC,$CB,$98,$87,$67,$9A,$BB,$A9,$77,$52,$10
			byte	$12,$34,$67,$88,$88,$89,$99,$AB,$A8,$88,$78,$89,$87,$54,$44,$57
			byte	$8A,$AA,$99,$9B,$CB,$A8,$63,$34,$68,$9A,$99,$96,$54,$55,$66,$55
			byte	$42,$23,$56,$77,$89,$AC,$CC,$BA,$98,$65,$20,$00,$13,$69,$BC,$BB
			byte	$CC,$CB,$98,$87,$9A,$AA,$99,$9A,$99,$76,$55,$55,$44,$55,$55,$55
			byte	$55,$56,$79,$9A,$BB,$BB,$BB,$BB,$A9,$76,$43,$22,$36,$88,$87,$66
			byte	$66,$66,$66,$66,$55,$57,$99,$88,$77,$8A,$AA,$AA,$A9,$88,$76,$55
			byte	$44,$57,$9A,$BA,$96,$55,$56,$78,$88,$76,$55,$55,$66,$77,$78,$77
			byte	$65,$55,$68,$AA,$A9,$88,$76,$54,$44,$57,$9B,$DE,$EC,$B9,$87,$77
			byte	$76,$65,$33,$34,$67,$87,$77,$89,$AA,$BA,$AB,$CD,$DC,$A9,$87,$64
			byte	$33,$45,$66,$66,$78,$88,$77,$66,$67,$77,$76,$66,$68,$9A,$BA,$88
			byte	$76,$55,$68,$99,$88,$65,$44,$45,$56,$88,$88,$87,$76,$66,$54,$46
			byte	$79,$AA,$AA,$99,$87,$66,$55,$54,$43,$44,$55,$65,$66,$78,$9A,$AA
			byte	$99,$8A,$BC,$BB,$BA,$98,$76,$66,$77,$76,$66,$65,$56,$79,$99,$99
			byte	$99,$A9,$99,$98,$88,$76,$55,$67,$88,$89,$77,$66,$55,$54,$45,$56
			byte	$68,$89,$A9,$9A,$99,$98,$88,$89,$AB,$CC,$CC,$B9,$86,$44,$56,$88
			byte	$98,$86,$45,$44,$33,$44,$56,$99,$99,$88,$88,$76,$67,$66,$65,$55
			byte	$55,$66,$78,$99,$99,$98,$88,$89,$99,$88,$76,$66,$88,$89,$99,$99
			byte	$98,$87,$76,$67,$8A,$AA,$A9,$86,$54,$32,$23,$44,$67,$89,$98,$87
			byte	$77,$77,$65,$44,$33,$34,$45,$67,$8A,$BB,$BB,$BB,$BC,$CB,$BB,$98
			byte	$87,$66,$67,$88,$88,$76,$55,$54,$44,$34,$45,$69,$99,$99,$99,$AA
			byte	$A9,$87,$65,$55,$56,$77,$77,$78,$88,$88,$89,$AA,$AA,$99,$98,$87
			byte	$66,$55,$55,$56,$67,$66,$66,$66,$66,$77,$78,$89,$9A,$AA,$AA,$98
			byte	$87,$77,$78,$87,$66,$65,$67,$77,$77,$66,$56,$67,$77,$66,$67,$77
			byte	$88,$88,$88,$88,$88,$88,$88,$89,$9A,$A9,$87,$76,$67,$88,$88,$98
			byte	$77,$77,$78,$87,$64,$44,$55,$66,$78,$89,$9A,$A9,$98,$87,$66,$66
			byte	$55,$67,$77,$88,$99,$98,$88,$88,$9A,$99,$98,$77,$77,$77,$77,$77
			byte	$88,$87,$77,$67,$66,$66,$78,$88,$88,$88,$88,$87,$76,$66,$66,$67
			byte	$78,$88,$98,$88,$88,$88,$88,$87,$88,$77,$77,$77,$77,$76,$77,$77
			byte	$77,$67,$77,$77,$77,$78,$77,$78,$88,$88,$88,$89,$88,$87,$77,$77
			byte	$77,$87,$77,$67,$88,$88,$88,$77,$88,$88,$87,$77,$78,$88,$88,$77
			byte	$66,$55,$56,$66,$78,$89,$98,$88,$77,$76,$66,$55,$55,$66,$77,$88
			byte	$99,$AA,$AA,$99,$9A,$AA,$AA,$98,$87,$76,$67,$77,$88,$87,$66,$66
			byte	$55,$55,$56,$78,$88,$78,$88,$99,$98,$87,$76,$66,$66,$88,$88,$88
			byte	$88,$77,$89,$99,$99,$98,$88,$77,$76,$55,$55,$56,$77,$77,$66,$67
			byte	$76,$77,$77,$88,$99,$9A,$A9,$98,$87,$77,$88,$87,$76,$66,$67,$77
			byte	$77,$66,$66,$67,$77,$66,$67,$78,$88,$88,$88,$88,$88,$88,$88,$89
			byte	$9A,$A9,$87,$76,$67,$88,$88,$98,$77,$77,$78,$87,$64,$44,$55,$66
			byte	$78,$89,$9A,$A9,$98,$87,$66,$66,$55,$67,$77,$88,$99,$98,$88,$88
			byte	$9A,$99,$98,$77,$77,$77,$77,$77,$88,$87,$77,$77,$66,$67,$78,$88
			byte	$88,$88,$88,$77,$66,$66,$66,$66,$77,$88,$88,$88,$88,$88,$88,$87
			byte	$88,$88,$77,$78,$88,$77,$77,$76,$66,$66,$67,$77,$77,$88,$88,$88
			byte	$99,$99,$88,$88,$88,$77,$66,$66,$66,$77,$77,$77,$88,$88,$77,$66
			byte	$77,$88,$88,$76,$66,$66,$66,$77,$77,$88,$88,$77,$88,$89,$98,$87
			byte	$76,$66,$66,$66,$67,$88,$99,$99,$99,$99,$88,$87,$77,$88,$99,$98
			byte	$88,$76,$66,$66,$78,$88,$88,$88,$88,$78,$77,$65,$54,$55,$67,$77
			byte	$77,$88,$88,$88,$88,$99,$99,$98,$87,$77,$77,$88,$88,$87,$66,$66
			byte	$66,$66,$67,$78,$88,$88,$88,$87,$77,$66,$66,$66,$77,$77,$88,$88
			byte	$88,$88,$88,$88,$88,$77,$76,$67,$78,$78,$88,$88,$88,$77,$77,$78
			byte	$88,$77,$88,$88,$88,$77,$66,$67,$77,$88,$87,$77,$88,$88,$78,$88
			byte	$88,$88,$88,$88,$77,$67,$77,$88,$88,$88,$88,$77,$77,$77,$77,$76
			byte	$77,$77,$78,$88,$88,$88,$88,$88,$88,$88,$87,$77,$77,$88,$88,$88
			byte	$77,$77,$77,$77,$77,$78,$88,$78,$77,$88,$87,$88,$77,$76,$66,$66
			byte	$77,$88,$98,$88,$87,$88,$88,$87,$77,$77,$77,$77,$77,$88,$88,$87
			byte	$77,$77,$78,$88,$88,$88,$77,$77,$88,$88,$88,$88,$88,$87,$77,$77
			byte	$77,$78,$87,$77,$77,$77,$77,$78,$88,$88,$88,$77,$77,$77,$77,$77
			byte	$88,$88,$88,$88,$77,$77,$77,$77,$77,$78,$78,$77,$77,$77,$77,$77
			byte	$77,$77,$77,$77,$87,$77,$88,$88,$88,$77,$77,$77,$77,$77,$77,$88
			byte	$88,$88,$77,$88,$88,$88,$87,$88,$88,$88,$87,$77,$77,$87,$87,$77
			byte	$77,$78,$87,$77,$77,$88,$88,$88,$77,$78,$88,$88,$77,$77,$88,$88
			byte	$88,$88,$78,$88,$87,$77,$78,$88,$88,$87,$77,$78,$88,$88,$88,$88
			byte	$88,$77,$77,$77,$78,$88,$88,$88,$88,$88,$87,$77,$77,$77,$77,$78
			byte	$88,$88,$88,$88,$87,$77,$77,$88,$88,$88,$88,$87,$77,$77,$77,$77
			byte	$77,$77,$78,$88,$88,$88,$88,$87,$77,$78,$77,$77,$88,$88,$87,$87
			byte	$77,$77,$77,$77,$77,$77,$88,$88,$88,$88,$88,$88,$88,$88,$87,$77
			byte	$77,$77,$78,$88,$77,$87,$77,$77,$77,$77,$88,$88,$87,$77,$77,$77
			byte	$77,$77,$77,$77,$77,$88,$88,$88,$88,$88,$88,$87,$77,$77,$78,$88
			byte	$88,$77,$77,$77,$77,$78,$77,$77,$77,$78,$78,$88,$77,$77,$77,$88
			byte	$88,$87,$77,$77,$77,$88,$88,$88,$88,$77,$77,$77,$77,$78,$88,$87
			byte	$77,$77,$78,$88,$88,$88,$77,$77,$77,$77,$88,$88,$88,$88,$88,$87
			byte	$77,$77,$77,$77,$78,$88,$88,$88,$78,$88,$88,$88,$88,$88,$88,$88
			byte	$77,$77,$77,$78,$88,$88,$88,$87,$77,$77,$88,$88,$87,$77,$78,$88
			byte	$88,$87,$77,$77,$77,$78,$88,$88,$88,$88,$88,$77,$77,$77,$78,$88
			byte	$88,$88,$87,$77,$78,$88,$88,$77,$88,$88,$88,$87,$77,$77,$78,$77
			byte	$77,$77,$77,$78,$88,$88,$88,$80
			byte	$E  'end marker (3960 bytes total)


tone1			byte	$76,$53,$20,$01,$13,$45,$68,$9B,$CD,$EE,$FF,$FF,$FF,$FF,$FE,$ED
			byte	$CC,$CB,$AA,$98,$87,$76,$55,$44,$33,$44,$45,$55,$55,$43,$32,$10
			byte	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11,$33,$44,$56,$78,$9A
			byte	$BB,$CC,$DE,$EF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FE,$EE,$ED,$CC,$CB,$BA,$A9,$99,$88,$77,$66,$65
			byte	$55,$44,$44,$32,$10,$00,$00,$00,$00,$00,$02,$34,$56,$67,$78,$88
			byte	$88,$77,$66,$66,$55,$44,$33,$22,$11,$00,$00,$00,$00,$01,$33,$33
			byte	$22,$10,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$13,$34,$56,$78
			byte	$89,$AC,$CD,$EF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$ED,$CC,$BA
			byte	$AA,$99,$88,$88,$76,$66,$55,$42,$00,$00,$00,$00,$00,$02,$34,$55
			byte	$66,$77,$77,$87,$77,$76,$66,$54,$44,$32,$21,$10,$00,$00,$00,$00
			byte	$00,$00,$10,$10,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
			byte	$00,$12,$34,$56,$68,$9A,$AB,$CD,$EE,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$ED
			byte	$DC,$CB,$BA,$A9,$99,$88,$87,$76,$66,$55,$54,$20,$00,$00,$00,$00
			byte	$03,$45,$56,$78,$88,$99,$99,$98,$88,$87,$65,$55,$43,$33,$22,$00
			byte	$00,$00,$00,$00,$11,$22,$22,$11,$00,$00,$00,$00,$00,$00,$00,$00
			byte	$00,$00,$00,$12,$34,$45,$67,$89,$AB,$CC,$DE,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FE,$EE,$DD,$CC,$CB,$BA,$99,$98,$88,$87,$66,$55,$55,$44,$43,$33
			byte	$23,$22,$11,$11,$11,$11,$00,$00,$00,$00,$00,$00,$00,$11,$11,$11
			byte	$11,$11,$12,$22,$22,$33,$33,$33,$34,$44,$44,$45,$55,$55,$56,$66
			byte	$66,$66,$77,$78,$88,$88,$88,$88,$88,$88,$89,$99,$99,$99,$9A,$A9
			byte	$AA,$AA,$AA,$AA,$AA,$AA,$AA,$BA,$BA,$AA,$BA,$AB,$AA,$BA,$AA,$BA
			byte	$BA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$9A,$AA,$99,$99,$99,$99,$99,$99
			byte	$99,$99,$98,$98,$99,$89,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88
			byte	$87,$77,$77,$67,$76,$76,$76,$76,$67,$67,$67,$67,$66
			byte	$E  'end marker (445 bytes total)

tone2			byte	$88,$75,$41,$10,$11,$34,$56,$8A,$BB,$CD,$EF,$FF,$FF,$FF,$FF,$FE
			byte	$ED,$CB,$BA,$A9,$98,$87,$65,$54,$43,$33,$44,$55,$55,$54,$43,$21
			byte	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11,$23,$44,$56,$78,$99
			byte	$AB,$BC,$CD,$EF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$EE,$DD,$CC,$BB,$BA,$AA,$99,$98,$88,$77,$76
			byte	$65,$55,$44,$44,$33,$33,$22,$22,$11,$11,$00,$00,$00,$00,$00,$00
			byte	$01,$23,$45,$56,$68,$88,$88,$88,$88,$88,$87,$76,$66,$55,$44,$43
			byte	$33,$22,$12,$34,$45,$55,$55,$44,$32,$11,$00,$00,$00,$00,$00,$00
			byte	$00,$12,$33,$45,$66,$78,$8A,$BB,$CD,$EE,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$EE,$DD,$CC,$BB,$BA,$99,$98,$87,$77,$66,$55,$54,$43,$33,$32
			byte	$21,$11,$10,$00,$00,$00,$00,$00,$00,$00,$01,$33,$55,$66,$77,$77
			byte	$87,$77,$66,$65,$55,$44,$33,$32,$11,$10,$00,$00,$01,$12,$33,$32
			byte	$11,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$12,$34,$56,$78
			byte	$99,$AB,$BC,$EF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$EE,$EC,$CC,$BB,$BB,$AA
			byte	$98,$88,$88,$76,$66,$54,$44,$33,$33,$33,$22,$11,$10,$00,$00,$00
			byte	$00,$00,$00,$13,$55,$67,$88,$88,$89,$89,$88,$88,$87,$76,$55,$55
			byte	$43,$33,$21,$11,$11,$12,$33,$44,$44,$33,$21,$10,$00,$00,$00,$00
			byte	$00,$00,$00,$00,$11,$23,$45,$67,$88,$9A,$AB,$DD,$EF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FE,$ED,$CC,$BB,$BA,$A9,$98,$88,$87,$76,$66,$55,$54,$44
			byte	$33,$33,$22,$11,$11,$11,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
			byte	$00,$10,$11,$11,$11,$11,$22,$22,$33,$33,$33,$44,$44,$44,$55,$55
			byte	$65,$66,$66,$76,$77,$78,$88,$88,$88,$89,$89,$99,$99,$99,$A9,$A9
			byte	$AA,$AA,$AA,$AA,$AA,$AA,$AA,$BB,$AB,$BA,$BB,$AB,$AB,$AA,$BA,$BB
			byte	$BB,$BB,$BA,$BA,$BB,$AA,$BA,$AA,$BA,$AA,$AA,$AA,$AA,$A9,$99,$99
			byte	$99,$99,$99,$88,$98,$89,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88
			byte	$88,$88,$88,$88,$88,$78,$78,$77,$77,$77,$77,$77,$76,$76,$67,$67
			byte	$67,$66,$76,$76,$76,$67,$66,$66,$70
			byte	$E  'end marker (473 bytes total)


tone3			byte	$88,$88,$88,$75,$43,$11,$01,$14,$56,$89,$AB,$CD,$EF,$FF,$FF,$FF
			byte	$FF,$FE,$ED,$DC,$CB,$AA,$98,$87,$66,$55,$44,$33,$44,$55,$55,$55
			byte	$33,$21,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$12,$34,$56
			byte	$77,$89,$9A,$BC,$DD,$EF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$EE,$DC,$CC,$BB,$AA,$99,$98,$88
			byte	$77,$66,$65,$55,$44,$43,$33,$21,$11,$11,$10,$10,$00,$00,$00,$00
			byte	$00,$00,$00,$00,$00,$00,$00,$00,$00,$23,$45,$68,$89,$9A,$AB,$BB
			byte	$BB,$BB,$BA,$AA,$99,$98,$88,$77,$65,$55,$44,$44,$56,$77,$87,$76
			byte	$65,$53,$32,$11,$10,$00,$00,$00,$01,$11,$22,$34,$56,$67,$89,$9A
			byte	$BC,$DE,$EF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$ED,$DC,$CB,$BB,$A9,$98,$88
			byte	$77,$66,$55,$44,$43,$33,$32,$11,$11,$10,$00,$00,$00,$00,$00,$00
			byte	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$13,$45,$67,$88,$88,$99
			byte	$99,$99,$98,$88,$87,$66,$65,$55,$44,$43,$32,$22,$34,$45,$66,$55
			byte	$44,$32,$11,$00,$00,$00,$00,$00,$00,$00,$11,$23,$34,$56,$78,$89
			byte	$AB,$BD,$EF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$DD,$CC,$CB,$BA,$A9,$99
			byte	$88,$87,$66,$66,$55,$44,$43,$33,$32,$21,$11,$11,$10,$10,$00,$00
			byte	$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$01,$11,$11,$22,$22,$33
			byte	$33,$33,$44,$44,$44,$55,$55,$56,$66,$66,$77,$78,$88,$88,$88,$89
			byte	$89,$99,$99,$99,$99,$AA,$AA,$AA,$AA,$AB,$BB,$AB,$AB,$BB,$BB,$BB
			byte	$BB,$BB,$BB,$BB,$BB,$BB,$BB,$BB,$BB,$BB,$BB,$BB,$BA,$AA,$BA,$AA
			byte	$AA,$AA,$AA,$AA,$AA,$AA,$9A,$99,$99,$99,$99,$99,$99,$89,$88,$88
			byte	$88,$88,$88,$88,$88,$88,$88,$88,$88,$87,$77,$87,$87,$77,$77,$76
			byte	$77,$66,$76,$67,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66
			byte	$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$77,$67,$67,$67,$66,$76
			byte	$77,$77,$77,$77,$77,$77,$77,$76,$76,$77,$77,$77,$77,$77,$87,$88
			byte	$78,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$89,$88,$98
			byte	$88,$88,$98,$89,$89,$98,$99,$88,$99,$98,$89,$89,$89,$88,$99,$89
			byte	$88,$88,$98,$99,$89,$98,$89,$99,$89,$88,$99,$89,$98,$88
			byte	$E  'end marker (478 bytes total)


tone4			byte	$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$88,$87,$63,$11,$00,$12
			byte	$35,$68,$AB,$CD,$EF,$FF,$FF,$FF,$FF,$FF,$FE,$DC,$CB,$BA,$99,$88
			byte	$76,$65,$54,$43,$33,$55,$55,$65,$54,$31,$00,$00,$00,$00,$00,$00
			byte	$00,$00,$00,$00,$00,$01,$23,$34,$56,$78,$89,$AA,$BC,$DE,$EF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FE,$EE,$DC,$CB,$A8,$63,$22,$12,$23,$45,$57,$78,$89,$9A,$AA,$A9
			byte	$99,$98,$88,$77,$65,$44,$32,$21,$00,$00,$00,$00,$00,$00,$00,$00
			byte	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$12
			byte	$34,$58,$89,$AB,$CD,$EF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$EC,$B9,$86,$66
			byte	$67,$88,$9A,$BC,$CD,$DE,$EE,$EE,$ED,$CC,$BB,$AA,$98,$86,$55,$44
			byte	$32,$11,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
			byte	$00,$00,$00,$00,$00,$00,$00,$00,$12,$34,$57,$88,$9A,$BB,$CD,$DF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FE,$DD,$CA,$87,$64,$44,$45,$56,$78,$89,$AA,$BC,$CC,$CC
			byte	$CC,$BA,$AA,$98,$88,$76,$64,$33,$21,$10,$00,$00,$00,$00,$00,$00
			byte	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$12
			byte	$34,$56,$78,$89,$BC,$CE,$EF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FC,$A9,$86,$55
			byte	$55,$67,$89,$9A,$BB,$CC,$DD,$EE,$DC,$CB,$BB,$99,$88,$86,$65,$44
			byte	$22,$10,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
			byte	$00,$00,$00,$00,$00,$00,$00,$01,$34,$56,$78,$89,$AB,$CD,$EF,$FF
			byte	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			byte	$FF,$FF,$FF,$FE,$ED,$DC,$BB,$BA,$A9,$99,$88,$88,$77,$66,$65,$54
			byte	$44,$44,$43,$33,$22,$22,$22,$12,$11,$11,$11,$11,$11,$11,$11,$22
			byte	$12,$21,$22,$22,$23,$23,$33,$33,$34,$44,$44,$44,$55,$55,$55,$66
			byte	$66,$66,$67,$77,$77,$77,$88,$88,$88,$88,$88,$98,$99,$99,$99,$99
			byte	$9A,$9A,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$BA,$BA,$AB,$AA,$AA,$AA
			byte	$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$9A,$99,$99,$99,$99,$99,$99
			byte	$99,$89,$99,$99,$89,$88,$89,$88,$88,$88,$88,$88,$88,$88,$88,$88
			byte	$88,$77,$77,$66,$76,$76,$76,$67,$67,$66,$76,$67,$66,$76,$76,$66
			byte	$76,$67
			byte	$E  'end marker (498 bytes total)

ufo_killed		byte	$77,$77,$77,$77,$77,$77,$78,$77,$77,$88,$88,$87,$77,$77,$77,$77
			byte	$77,$77,$78,$88,$88,$87,$77,$77,$77,$77,$78,$77,$77,$77,$77,$88
			byte	$88,$77,$77,$77,$77,$88,$78,$78,$78,$77,$78,$88,$78,$78,$78,$77
			byte	$87,$87,$88,$87,$87,$78,$77,$77,$77,$77,$78,$88,$77,$77,$78,$77
			byte	$78,$78,$77,$87,$87,$78,$78,$77,$77,$78,$88,$88,$87,$77,$77,$77
			byte	$77,$77,$77,$88,$88,$88,$77,$77,$77,$77,$77,$77,$78,$77,$77,$77
			byte	$77,$77,$77,$77,$78,$87,$87,$78,$78,$88,$88,$87,$87,$87,$88,$88
			byte	$77,$77,$87,$87,$78,$77,$78,$88,$77,$87,$87,$87,$87,$78,$78,$78
			byte	$88,$87,$77,$87,$87,$88,$77,$78,$77,$88,$87,$78,$78,$78,$87,$77
			byte	$77,$88,$88,$77,$77,$87,$89,$77,$77,$77,$88,$87,$77,$77,$78,$87
			byte	$77,$77,$77,$97,$77,$77,$78,$99,$77,$77,$77,$99,$77,$77,$88,$99
			byte	$67,$77,$78,$98,$77,$77,$77,$97,$77,$77,$78,$99,$77,$78,$78,$A8
			byte	$67,$78,$79,$A7,$77,$67,$8A,$86,$67,$77,$79,$66,$67,$77,$9A,$76
			byte	$67,$78,$A9,$66,$67,$79,$A7,$66,$67,$7B,$96,$66,$67,$79,$86,$66
			byte	$77,$8A,$B7,$66,$77,$8B,$A7,$66,$77,$8B,$A6,$55,$67,$8B,$A6,$55
			byte	$67,$8B,$B6,$55,$67,$78,$B7,$55,$57,$78,$BC,$85,$56,$78,$AC,$B6
			byte	$45,$77,$9C,$C7,$44,$67,$8A,$DB,$54,$45,$79,$CD,$84,$44,$57,$AD
			byte	$C7,$44,$46,$78,$DC,$63,$44,$67,$8E,$C6,$33,$46,$79,$BD,$63,$34
			byte	$67,$8B,$E8,$32,$35,$68,$AD,$E5,$23,$46,$79,$CE,$D3,$23,$57,$8A
			byte	$DF,$52,$23,$67,$9B,$EE,$41,$24,$67,$9C,$EE,$31,$23,$67,$AC,$EE
			byte	$41,$13,$57,$9C,$EB,$41,$02,$57,$9B,$ED,$62,$01,$46,$8A,$DF,$B5
			byte	$10,$24,$79,$BF,$E9,$40,$02,$57,$CE,$FE,$94,$00,$24,$9C,$EF,$FA
			byte	$41,$00,$68,$BD,$FF,$D7,$20,$25,$79,$DE,$FF,$B1,$00,$36,$8B,$DF
			byte	$FA,$40,$00,$36,$8B,$DF,$EA,$51,$00,$25,$7D,$EF,$FC,$72,$00,$36
			byte	$9B,$EF,$FE,$B5,$00,$04,$69,$CE,$FF,$B6,$10,$00,$36,$9C,$FF,$ED
			byte	$83,$00,$05,$7A,$DE,$FE,$DB,$70,$00,$15,$7A,$DE,$FD,$C8,$30,$00
			byte	$13,$6C,$EF,$ED,$CA,$62,$00,$14,$7A,$DE,$FE,$CA,$72,$00,$00,$36
			byte	$CE,$FF,$DC,$B9,$51,$00,$03,$69,$CE,$FF,$CB,$A6,$21,$00,$15,$7A
			byte	$DE,$FE,$DC,$A6,$31,$00,$12,$47,$AE,$FE,$DC,$BA,$86,$20,$02,$34
			byte	$69,$CE,$ED,$CB,$A9,$74,$21,$12,$35,$69,$CD,$EE,$CB,$A8,$86,$32
			byte	$11,$34,$56,$9B,$DE,$DC,$BA,$98,$76,$32,$12,$34,$56,$8A,$CD,$DC
			byte	$BA,$98,$87,$65,$32,$23,$45,$67,$8A,$DD,$DC,$BA,$98,$87,$75,$43
			byte	$23,$34,$56,$78,$9B,$CC,$CB,$BA,$88,$87,$77,$75,$43,$34,$55,$67
			byte	$78,$8B,$CC,$CB,$AA,$98,$87,$77,$77,$65,$43,$35,$56,$67,$78,$88
			byte	$AB,$BB,$BA,$A9,$98,$87,$77,$77,$77,$65,$44,$45,$56,$67,$77,$88
			byte	$88,$9A,$BB,$BA,$99,$98,$87,$87,$77,$77,$77,$77,$76,$55,$45,$56
			byte	$66,$77,$78,$88,$88,$88,$89,$AA,$AA,$A9,$99,$88,$87,$77,$77,$77
			byte	$77,$77,$77,$77,$77,$77,$76,$66,$66,$56,$66,$77,$77,$88,$88,$88
			byte	$88,$88,$88,$88,$98,$88,$99,$AA,$AA,$98,$88,$88,$77,$77,$77,$77
			byte	$77,$77,$77,$76,$67,$55,$55,$55,$67,$67,$78,$88,$88,$88,$89,$AB
			byte	$BA,$A9,$99,$88,$87,$77,$77,$77,$77,$65,$54,$45,$56,$67,$77,$78
			byte	$89,$9A,$BB,$BA,$A9,$88,$88,$77,$77,$77,$44,$44,$45,$66,$67,$88
			byte	$9A,$BB,$BB,$AA,$98,$87,$77,$77,$64,$34,$45,$56,$67,$79,$AC,$CC
			byte	$BA,$A9,$98,$77,$76,$43,$33,$35,$66,$78,$9B,$CC,$BB,$A9,$88,$77
			byte	$75,$33,$33,$45,$66,$8A,$CC,$CB,$BA,$98,$87,$43,$22,$33,$45,$6A
			byte	$CD,$DD,$CB,$A9,$87,$43,$22,$23,$45,$6B,$CD,$DD,$CB,$A9,$85,$21
			byte	$12,$34,$57,$CD,$ED,$CB,$A9,$96,$21,$12,$34,$58,$BD,$ED,$CB,$A9
			byte	$74,$21,$13,$45,$9C,$DE,$EC,$AA,$85,$21,$11,$26,$9C,$DE,$DC,$BA
			byte	$93,$10,$02,$35,$8C,$DE,$DC,$A9,$63,$10,$13,$6A,$CE,$EE,$DC,$73
			byte	$10,$01,$25,$9C,$EE,$DC,$A6,$31,$00,$37,$BD,$EE,$EC,$B4,$10,$01
			byte	$26,$AD,$EE,$DB,$74,$10,$01,$3B,$DE,$ED,$CA,$52,$00,$26,$AD,$EF
			byte	$ED,$63,$00,$02,$6A,$CE,$ED,$A6,$20,$00,$27,$DE,$ED,$C8,$31,$00
			byte	$5A,$DE,$FE,$D9,$40,$01,$49,$CE,$FE,$D4,$10,$01,$5A,$DE,$FC,$73
			byte	$10,$02,$7B,$DE,$EA,$52,$00,$15,$DF,$EE,$B6,$20,$00,$9D,$EF,$EB
			byte	$62,$00,$5A,$DE,$EE,$A5,$20,$16,$BD,$FE,$D9,$30,$04,$9C,$EF,$EB
			byte	$60,$02,$7B,$EF,$FC,$70,$01,$6A,$DF,$FD,$81,$01,$6A,$DF,$FC,$20
			byte	$02,$6B,$EF,$FC,$20,$03,$8C,$EF,$EA,$10,$05,$AD,$FF,$C7,$00,$38
			byte	$CE,$FE,$91,$01,$6B,$EF,$FA,$50,$05,$AD,$FF,$B5,$20,$5A,$DF,$FB
			byte	$52,$05,$AD,$FE,$A4,$10,$0B,$EF,$E9,$30,$02,$CE,$FC,$72,$00,$4A
			byte	$FF,$A4,$10,$17,$CE,$D7,$20,$05,$AD,$FE,$30,$03,$9D,$FF,$A1,$02
			byte	$8C,$EF,$B5,$21,$7C,$EF,$C6,$20,$1B,$EF,$C6,$20,$17,$BF,$B5,$10
			byte	$28,$CF,$A4,$10,$39,$CF,$E9,$00,$5A,$DF,$D7,$20,$7C,$EF,$A4,$10
			byte	$4A,$FD,$72,$01,$7C,$EA,$40,$04,$AD,$FC,$60,$28,$CF,$E8,$30,$0B
			byte	$EF,$B5,$10,$39,$CE,$82,$00,$6B,$EF,$51,$03,$8C,$FF,$93,$04,$AD
			byte	$FE,$82,$00,$BE,$FC,$62,$01,$7B,$FB,$61,$01,$7B,$EB,$51,$02,$7C
			byte	$EF,$B1,$01,$7C,$EF,$C6,$21,$6B,$EF,$D7,$20,$0A,$DF,$E9,$30,$03
			byte	$CF,$FB,$52,$01,$6B,$FE,$83,$00,$39,$CE,$C6,$20,$05,$AD,$FF,$41
			byte	$01,$6B,$EF,$E3,$10,$27,$BE,$FE,$81,$02,$8C,$EF,$E9,$30,$27,$BE
			byte	$FE,$94,$11,$6B,$DE,$FB,$62,$04,$9D,$EF,$D8,$31,$17,$BD,$EE,$B5
			byte	$20,$38,$CE,$EE,$94,$20,$5A,$DE,$ED,$83,$11,$5A,$DE,$ED,$83,$10
			byte	$5A,$DE,$ED,$94,$10,$49,$CE,$FE,$B6,$20,$27,$BD,$FE,$D8,$10,$04
			byte	$9C,$EE,$EB,$21,$01,$5A,$CE,$EE,$62,$10,$15,$AC,$EE,$B7,$31,$01
			byte	$49,$CE,$EC,$83,$10,$03,$7D,$EE,$DA,$62,$00,$18,$CD,$ED,$D9,$52
			byte	$01,$49,$CE,$ED,$CA,$21,$01,$48,$BD,$ED,$B6,$31,$01,$26,$AD,$ED
			byte	$C9,$52,$10,$13,$BD,$ED,$DC,$95,$21,$13,$7A,$CE,$DD,$C6,$32,$11
			byte	$25,$9B,$DD,$CB,$95,$31,$11,$39,$CD,$DD,$CB,$95,$11,$12,$58,$BD
			byte	$DD,$BA,$74,$21,$12,$36,$CD,$DD,$CB,$A7,$42,$12,$35,$9C,$CE,$DB
			byte	$A9,$53,$21,$23,$49,$CD,$DD,$CB,$A9,$62,$12,$34,$58,$BC,$DC,$BA
			byte	$98,$53,$22,$34,$68,$BC,$DD,$CB,$98,$64,$22,$23,$45,$9B,$CD,$DC
			byte	$BA,$99,$53,$22,$23,$45,$7B,$CC,$CB,$AA,$98,$74,$32,$33,$45,$68
			byte	$AC,$CC,$BA,$99,$88,$63,$33,$34,$56,$78,$BC,$CC,$BA,$A9,$88,$64
			byte	$33,$34,$45,$67,$9A,$BC,$CB,$BA,$98,$77,$75,$43,$34,$46,$67,$78
			byte	$AB,$BB,$BA,$99,$88,$77,$76,$54,$44,$55,$67,$77,$8A,$AB,$BA,$A9
			byte	$98,$87,$77,$77,$65,$54,$55,$66,$77,$78,$89,$AB,$BA,$A9,$98,$88
			byte	$77,$77,$77,$66,$55,$55,$66,$77,$77,$88,$89,$AA,$AA,$A9,$98,$88
			byte	$87,$77,$77,$77,$77,$65,$55,$55,$66,$77,$78,$88,$88,$88,$89,$9A
			byte	$AA,$99,$88,$78,$77,$77,$77,$77,$77,$77,$77,$77,$76,$65,$56,$66
			byte	$77,$77,$88,$88,$88,$88,$88,$88,$88,$88,$99,$99,$99,$98,$88,$88
			byte	$77,$77,$77,$77,$77,$77,$77,$77,$77,$77,$77,$77,$76,$65,$66,$77
			byte	$77,$78,$88,$88,$88,$88,$88,$9A,$AA,$A9,$99,$98,$87,$87,$77,$77
			byte	$77,$77,$76,$55,$55,$56,$67,$77,$78,$78,$88,$AA,$AA,$AA,$99,$88
			byte	$87,$77,$77,$77,$76,$54,$55,$56,$67,$77,$88,$9A,$AA,$BA,$A9,$88
			byte	$88,$77,$77,$64,$44,$55,$56,$67,$78,$9A,$BB,$BA,$A9,$98,$87,$77
			byte	$75,$44,$44,$56,$67,$78,$9B,$BB,$BA,$99,$88,$77,$54,$33,$44,$55
			byte	$67,$9A,$BC,$CB,$BA,$98,$87,$64,$33,$34,$46,$77,$AB,$CC,$CB,$A9
			byte	$88,$75,$43,$33,$35,$67,$9B,$CD,$CC,$A9,$88,$64,$32,$23,$45,$7A
			byte	$BD,$DC,$CB,$98,$74,$32,$22,$34,$7A,$CD,$DD,$CB,$A8,$53,$21,$22
			byte	$35,$7C,$DD,$DC,$BA,$97,$41,$12,$34,$6A,$CD,$DC,$BA,$96,$32,$11
			byte	$35,$8B,$DE,$DD,$CB,$63,$21,$12,$35,$9C,$ED,$DB,$A8,$42,$11,$24
			byte	$8B,$DE,$ED,$C8,$42,$00,$12,$59,$CE,$ED,$BA,$63,$10,$14,$8B,$DE
			byte	$ED,$CA,$61,$01,$24,$8B,$DE,$DC,$95,$21,$01,$26,$CE,$ED,$DA,$63
			byte	$10,$26,$9D,$EE,$DC,$A6,$10,$12,$6A,$DE,$EC,$95,$20,$01,$49,$CE
			byte	$ED,$B6,$21,$00,$3B,$DE,$ED,$B6,$21,$03,$8B,$DE,$ED,$A5,$00,$15
			byte	$AC,$EE,$EC,$41,$00,$37,$BD,$EE,$A5,$10,$02,$6B,$DE,$DA,$52,$00
			byte	$27,$BE,$ED,$94,$10,$02,$7E,$EE,$D7,$31,$00,$5C,$EE,$EA,$52,$00
			byte	$2B,$DE,$EC,$72,$00,$6A,$DE,$ED,$73,$10,$6A,$DE,$FD,$83,$10,$6A
			byte	$DF,$EC,$72,$00,$7B,$EF,$EB,$52,$04,$9C,$EF,$D8,$31,$06,$BE,$FE
			byte	$A5,$20,$09,$DF,$FC,$62,$00,$4C,$EF,$D7,$30,$03,$CE,$FD,$73,$00
			byte	$38,$EF,$D7,$20,$04,$9D,$FC,$62,$00,$5A,$DF,$A4,$10,$27,$CE,$F7
			byte	$20,$04,$AD,$FE,$A1,$02,$8C,$EF,$C6,$20,$6B,$DF,$D8,$30,$09,$DF
			byte	$E9,$40,$03,$DF,$FA,$41,$03,$8D,$EA,$41,$03,$9D,$FE,$40,$04,$9D
			byte	$FE,$83,$05,$AD,$FD,$72,$07,$BE,$FB,$61,$02,$8F,$E9,$40,$05,$AE
			byte	$F6,$10,$28,$CF,$F9,$30,$5A,$DF,$C6,$10,$9C,$FE,$72,$01,$7B,$FA
			byte	$50,$04,$AD,$FE,$20,$17,$CE,$FA,$50,$49,$DF,$E8,$30,$0B,$EF,$C6
			byte	$10,$18,$BF,$B5,$10,$28,$CF,$F4,$10,$39,$CF,$E9,$40,$49,$DF,$E9
			byte	$40,$39,$DF,$EA,$41,$02,$CE,$FB,$51,$01,$7B,$FC,$62,$00,$6A,$DF
			byte	$84,$00,$38,$CE,$F6,$10,$06,$AD,$FE,$91,$02,$8C,$EF,$D7,$20,$49
			byte	$DE,$FC,$62,$05,$AD,$FE,$B5,$20,$5A,$DF,$EB,$52,$00,$AD,$EF,$C6
			byte	$20,$04,$CE,$FD,$73,$00,$27,$EF,$EA,$41,$00,$5D,$EF,$C6,$30,$02
			byte	$7E,$FE,$B5,$20,$04,$8E,$EE,$94,$10,$04,$9E,$FD,$94,$10,$04,$CE
			byte	$EE,$A5,$20,$03,$CE,$EE,$B6,$20,$02,$BD,$EE,$D9,$41,$00,$8C,$EE
			byte	$EB,$73,$10,$59,$CE,$ED,$A5,$20,$15,$AD,$EE,$DB,$61,$01,$59,$CE
			byte	$ED,$C3,$10,$03,$8B,$DE,$DA,$52,$10,$15,$AC,$ED,$C8,$42,$00,$26
			byte	$CE,$ED,$C8,$42,$01,$6A,$CE,$ED,$C9,$52,$02,$48,$CD,$ED,$D7,$41
			byte	$01,$25,$9C,$DD,$CA,$63,$11,$12,$6C,$DE,$DC,$B7,$32,$12,$48,$BD
			byte	$ED,$CB,$53,$11,$13,$69,$CD,$DC,$B9,$52,$11,$23,$9C,$DD,$DC,$B9
			byte	$73,$11,$24,$7A,$CD,$DC,$A9,$63,$21,$22,$4A,$CD,$DD,$CB,$97,$41
			byte	$12,$35,$8B,$CD,$DB,$A9,$64,$21,$22,$58,$BC,$DD,$CB,$A9,$53,$21
			byte	$23,$46,$8B,$DD,$CB,$A9,$86,$32,$23,$45,$7A,$CC,$DC,$BA,$98,$64
			byte	$32,$24,$56,$8B,$CD,$CC,$B9,$88,$64,$32,$33,$46,$8A,$BC,$CC,$BA
			byte	$98,$86,$43,$23,$34,$67,$8A,$CC,$CB,$BA,$88,$77,$54,$33,$34,$66
			byte	$79,$AB,$CC,$BA,$98,$87,$76,$54,$34,$55,$66,$78,$9B,$BB,$BA,$99
			byte	$88,$77,$75,$43,$44,$55,$67,$78,$9A,$BB,$BB,$A9,$88,$87,$77,$76
			byte	$54,$45,$56,$67,$77,$88,$AB,$BA,$AA,$99,$88,$77,$77,$77,$65,$55
			byte	$55,$66,$77,$88,$88,$9A,$BA,$AA,$99,$98,$78,$77,$77,$77,$77,$55
			byte	$55,$55,$66,$77,$78,$88,$88,$89,$AA,$A9,$99,$98,$88,$77,$77,$77
			byte	$77,$77,$77,$77,$66,$55,$56,$67,$77,$78,$78,$88,$88,$88,$88,$88
			byte	$99,$A9,$99,$98,$88,$77,$77,$77,$77,$77,$77,$77,$77,$77,$77,$77
			byte	$77,$77,$77,$76,$66,$66,$77,$77,$78,$88,$88,$88,$88,$88,$89,$99
			byte	$AA,$AA,$99,$88,$88,$87,$77,$77,$77,$77,$77,$77,$65,$55,$55,$66
			byte	$67,$77,$78,$88,$88,$99,$AA,$A9,$99,$88,$87,$78,$77,$77,$77,$65
			byte	$45,$55,$66,$77,$78,$88,$9A,$AA,$AA,$99,$88,$87,$77,$77,$75,$44
			byte	$55,$56,$66,$78,$89,$AB,$BB,$AA,$99,$87,$77,$77,$65,$44,$45,$56
			byte	$77,$78,$BB,$BB,$AA,$99,$88,$77,$65,$43,$34,$56,$67,$8A,$BC,$CB
			byte	$BA,$98,$88,$76,$43,$34,$45,$66,$89,$BC,$CB,$AA,$98,$87,$64,$33
			byte	$34,$55,$78,$AC,$CC,$BA,$99,$87,$64,$22,$34,$56,$8A,$BD,$CC,$AA
			byte	$98,$74,$32,$23,$45,$7A,$CD,$DC,$BA,$98,$63,$21,$23,$46,$9C,$DD
			byte	$DC,$A9,$85,$32,$12,$23,$8B,$DD,$DC,$CA,$A8,$32,$12,$24,$69,$CD
			byte	$DC,$BA,$96,$32,$12,$35,$9C,$DE,$DD,$B8,$52,$11,$12,$47,$AE,$ED
			byte	$CB,$95,$21,$02,$48,$BD,$EE,$DC,$84,$20,$01,$26,$AC,$ED,$CB,$84
			byte	$20,$01,$6A,$DD,$ED,$CB,$84,$00,$13,$8B,$DE,$EC,$95,$21,$01,$37
			byte	$BE,$ED,$C9,$52,$10,$17,$BD,$EE,$DC,$94,$20,$14,$9C,$EE,$ED,$62
			byte	$10,$03,$7B,$DE,$DB,$73,$10,$03,$7B,$EE,$DB,$62,$00,$14,$BD,$EE
			byte	$D9,$41,$02,$6A,$DE,$EE,$A6,$20,$15,$9D,$EE,$EB,$60,$01,$49,$CE
extra_sound		byte	$EE,$B2,$00,$15,$AD,$EE,$D5,$20,$02,$7B,$DF,$C8,$31,$00,$59,$DE
			byte	$EA,$52,$00,$38,$CE,$EB,$62,$00,$27,$BE,$EB,$62,$00,$37,$BE,$EB
			byte	$52,$00,$38,$CF,$D9,$41,$00,$5A,$DF,$C7,$30,$02,$8B,$EE,$A4,$10
			byte	$16,$AE,$FB,$52,$00,$49,$DE,$C7,$20,$04,$9C,$EF,$72,$00,$39,$CE
			byte	$FC,$30,$03,$9D,$EF,$C2,$00,$5A,$DE,$FA,$40,$17,$BE,$FD,$83,$03
			byte	$9C,$EF,$B5,$20,$1B,$EF,$D7,$30,$04,$DF,$EA,$41,$03,$8C,$FB,$52
			byte	$02,$8C,$EF,$52,$01,$7B,$EF,$C6,$01,$7B,$EF,$C6,$10,$6A,$DF,$A4
			byte	$10,$3D,$FF,$B4,$10,$5A,$EE,$94,$01,$6B,$EF,$C2,$02,$8C,$FE,$93
			byte	$04,$AD,$FC,$51,$02,$CF,$E9,$30,$05,$AD,$A4,$00,$28,$CE,$C6,$01
			byte	$6B,$DE,$93,$04,$AD,$FD,$62,$01,$7E,$FB,$52,$04,$9D,$F9,$41,$16
			byte	$BE,$FE,$80,$27,$CF,$FD,$73,$28,$CF,$FC,$62,$02,$CF,$FC,$62,$02
			byte	$7C,$FC,$62,$01,$7B,$EF,$72,$00,$5A,$DF,$D3,$00,$39,$CE,$EA,$40
			byte	$16,$BD,$EC,$72,$04,$9C,$EE,$A4,$10,$1A,$DE,$D8,$20,$01,$AD,$EC
			byte	$73,$00,$49,$FF,$C7,$30,$04,$AD,$FC,$63,$00,$49,$CE,$C7,$20,$03
			byte	$8B,$ED,$83,$00,$27,$BE,$FA,$52,$00,$49,$CD,$E7,$20,$01,$6A,$DE
			byte	$D5,$20,$03,$8C,$EE,$A4,$20,$15,$AD,$FF,$A5,$21,$15,$AD,$FF,$B5
			byte	$31,$15,$AD,$FF,$C7,$32,$13,$8C,$EF,$D9,$42,$12,$5A,$DF,$EB,$63
			byte	$10,$26,$AE,$ED,$A5,$20,$02,$6C,$EE,$D9,$52,$00,$69,$CD,$DD,$A5
			byte	$20,$04,$8B,$DD,$DB,$73,$00,$26,$AC,$DD,$CA,$20,$00,$26,$AC,$CC
			byte	$A6,$31,$12,$48,$BE,$ED,$B7,$32,$11,$3A,$CD,$DD,$C8,$52,$01,$48
			byte	$BC,$DD,$CB,$31,$01,$24,$9C,$DD,$CB,$74,$20,$01,$37,$CD,$CC,$B9
			byte	$63,$10,$25,$9C,$DD,$DC,$B6,$32,$12,$36,$AC,$EE,$DC,$B7,$43,$23
			byte	$38,$BD,$EE,$EC,$BA,$72,$33,$45,$8B,$DE,$DC,$BA,$74,$32,$23,$6A
			byte	$CD,$ED,$CB,$A9,$32,$12,$34,$69,$BC,$CC,$B9,$96,$42,$12,$34,$79
			byte	$BC,$CC,$B9,$86,$42,$11,$23,$48,$AC,$CC,$BA,$98,$84,$21,$22,$34
			byte	$57,$BC,$CB,$BA,$98,$86,$32,$23,$45,$57,$9B,$CB,$BA,$99,$87,$64
			byte	$23,$34,$56,$79,$BC,$CB,$AA,$98,$87,$63,$33,$44,$56,$78,$AC,$CC
			byte	$BA,$A9,$98,$76,$44,$34,$45,$67,$89,$BB,$CC,$BA,$A9,$88,$77,$75
			byte	$44,$44,$66,$77,$88,$AB,$BC,$BA,$98,$88,$87,$76,$54,$44,$55,$66
			byte	$77,$88,$9A,$BB,$AA,$A9,$88,$88,$77,$77,$75,$44,$55,$66,$77,$88
'			byte	$e

'Trim for DE0


			byte	$88,$9A,$AB,$AA,$98,$88,$87,$77,$77,$77,$66,$55,$45,$56,$77,$78
			byte	$78,$88,$88,$AA,$AA,$99,$98,$88,$77,$77,$77,$77,$77,$77,$76,$55
			byte	$55,$66,$77,$77,$78,$78,$88,$88,$88,$89,$99,$99,$98,$88,$88,$78
			byte	$77,$77,$77,$77,$77,$77,$77,$77,$77,$77,$77,$76,$66,$66,$67,$77
			byte	$88,$88,$88,$88,$88,$88,$88,$88,$89,$99,$AA,$99,$99,$88,$87,$77
			byte	$77,$77,$77,$77,$77,$77,$76,$65,$55,$56,$66,$77,$78,$88,$88,$88
			byte	$89,$AA,$AA,$A9,$98,$88,$88,$78,$77,$77,$76,$55,$55,$55,$66,$77
			byte	$88,$88,$99,$AB,$AA,$99,$98,$88,$77,$77,$77,$54,$44,$55,$67,$77
			byte	$88,$9A,$AB,$BA,$99,$98,$88,$77,$76,$54,$44,$45,$57,$78,$89,$AB
			byte	$BB,$A9,$98,$87,$77,$75,$43,$44,$56,$67,$79,$AC,$BB,$AA,$98,$88
			byte	$75,$43,$33,$45,$56,$89,$BC,$CB,$BA,$99,$87,$64,$33,$33,$45,$68
			byte	$AB,$CC,$CB,$A9,$87,$64,$32,$23,$46,$79,$BC,$DC,$CB,$A8,$85,$42
			byte	$22,$34,$58,$BC,$DD,$CB,$A9,$85,$32,$22,$34,$57,$CD,$DD,$CB,$A9
			byte	$75,$21,$23,$45,$8B,$DD,$CB,$AA,$85,$22,$12,$36,$9C,$DE,$DC,$B9
			byte	$63,$21,$12,$35,$8D,$ED,$DC,$A9,$63,$21,$23,$6A,$CD,$ED,$BA,$73
			byte	$21,$11,$36,$CE,$ED,$CB,$96,$21,$12,$48,$BD,$EE,$DC,$73,$10,$11
			byte	$38,$BE,$ED,$CA,$63,$10,$14,$8C,$DE,$ED,$B8,$40,$01,$37,$BD,$EE
			byte	$D9,$52,$00,$13,$7B,$EE,$DC,$84,$20,$01,$9C,$DE,$ED,$A6,$21,$03
			byte	$7B,$DE,$ED,$B6,$10,$03,$7B,$DE,$EB,$63,$10,$03,$8B,$DE,$D9,$52
			byte	$00,$16,$AE,$EE,$B7,$31,$00,$4C,$EE,$EC,$83,$10,$38,$CE,$EE,$C8
			byte	$31,$04,$9C,$EF,$EB,$73,$01,$5A,$DE,$ED,$95,$00,$38,$BD,$EE,$C3
			byte	$00,$16,$AD,$EE,$D3,$10,$15,$9D,$EE,$D4,$10,$05,$AD,$EE,$D3,$10
			byte	$16,$AD,$FE,$62,$00,$27,$CE,$FE,$52,$00,$59,$DF,$EC,$30,$03,$7C
			byte	$EF,$E9,$10,$16,$BD,$FE,$A2,$00,$5A,$DF,$EA,$50,$05,$AD,$FF,$B5
			byte	$10,$6A,$DF,$E9,$51,$07,$BE,$FE,$83,$00,$8C,$EF,$C6,$20,$05,$DF
			byte	$E9,$41,$02,$8C,$FC,$62,$00,$6B,$DF,$83,$00,$4A,$CF,$E4,$10,$39
			byte	$CE,$FA,$50,$38,$CE,$FA,$51,$08,$CE,$FA,$51,$03,$8F,$FA,$51,$03
			byte	$9C,$E9,$30,$05,$AD,$FD,$30,$06,$BE,$FB,$61,$38,$CF,$E8,$30,$05
			byte	$DF,$C6,$10,$28,$CE,$83,$00,$6B,$EF,$B1,$04,$9D,$FD,$72,$07,$CF
			byte	$F9,$40,$05,$AF,$D6,$20,$27,$CE,$A4,$10,$49,$DF,$E8,$00,$6B,$DF
			byte	$C6,$20,$7B,$EF,$B6,$10,$28,$EF,$A5,$10,$38,$CF,$A5,$10,$28,$CF
			byte	$F5,$10,$28,$CE,$FB,$60,$16,$BE,$FD,$73,$05,$AD,$FE,$94,$10,$8C
			byte	$EF,$C6,$20,$06,$DF,$E8,$41,$03,$8C,$FC,$72,$00,$49,$DF,$B5,$20
			byte	$05,$AD,$FA,$51,$01,$6B,$DF,$E4,$10,$16,$AD,$FE,$A2,$01,$5A,$DF
			byte	$EB,$60,$04,$9C,$EE,$D8,$30,$27,$BD,$FE,$A5,$00,$49,$CE,$ED,$83
			byte	$01,$6A,$DE,$EC,$72,$02,$7B,$DE,$EB,$62,$02,$7B,$DE,$EC,$60,$02
			byte	$e

